(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* NbsOs葱 *)

unit Clip;

interface

Type Real=Double;

function  LineClipping(var x0,y0,x1,y1:Integer):Boolean;
function  BarClipping(var x0,y0,x1,y1:Integer):Boolean;
function  LineClippingReal(var x0,y0,x1,y1:Real):Boolean;
function  BarClippingReal(var x0,y0,x1,y1:Real):Boolean;
procedure UseWindow(MinX,MinY,MaxX,MaxY:Integer);
procedure SetWindow(MinX,MinY,MaxX,MaxY: Real);
function  XToG(x:Real):Integer;
function  YToG(y:Real):Integer;
function  GToX(x:Integer):Real;
function  GToY(y:Integer):Real;
function  XScaleG(x:Real):Integer;
function  YScaleG(y:Real):Integer;
function  GScaleX(x:Integer):Real;
function  GscaleY(y:Integer):Real;
procedure GMoveTo(x,y:Real);
procedure GMoveRel(dx,dy:Real);
function  GGetX:Real;
function  GGetY:Real;
function  WInXY(x,y:Real):Boolean;
function  GInXY(x,y:Integer):Boolean;

implementation

Const MAXINT=32767;
      MININT=-32768;
var
      GMinX, GMinY, GMaxX, GMaxY :Integer;
      WMinX, WMinY, WMaxX, WMaxY :Real;
      PointerX, PointerY  :Real;
      Ratex    ,Ratey     :Real;
      LeftTop :Boolean;

function  LineClipping(var x0,y0,x1,y1:Integer):Boolean;

  function fny(x:Integer):Integer;
     begin
       fny:=(y1-y0)*(x-x0) div (x1-x0)+y0;
     end;

  function fnx(y:Integer):Integer;
     begin
       fnx:=(x1-x0)*(y-y0) div (y1-y0)+x0;
     end;

var a,xl,yl,xg,yg:integer;
    minx,miny,maxx,maxy:Integer;

begin
	if GMinX>GMaxX then begin
	       minx:=GMaxX;
	       maxx:=GMinX;
	end else begin
	       minx:=GMinX;
	       maxx:=GMaxX;
	end;
	if GMaxY>GMinY then begin
	       miny:=GMinY;
	       maxy:=GMaxY;
	end else begin
	       miny:=GMaxY;
	       maxy:=GMinY;
	end;
        if x0<x1 then begin
            xl:=x0;  yl:=y0; xg:=x1;  yg:=y1;
        end else begin
            xl:=x1;  yl:=y1; xg:=x0;  yg:=y0;
        end;
        if (xg<minx) or (xl>maxx) then begin
	   LineClipping:=false; exit;
        end;
        if xg>maxx then begin
           xg:=maxx; yg:=fny(maxx);
        end;
        if xl<minx then begin
           xl:=minx; yl:=fny(minx);
        end;
        if yl>yg then begin
           a:=yl;  yl:=yg;  yg:=a;  a:=xl;  xl:=xg;  xg:=a;
        end;
        if (yg<miny) or (yl>maxy) then begin
	   LineClipping:=false; exit;
        end;
        if yg>maxy then begin
           yg:=maxy; xg:=fnx(maxy);
        end;
        if yl<miny then begin
           yl:=miny; xl:=fnx(miny);
        end;
	if (y0<y1) or ( (y0=y1) and (x0<x1) ) then begin
           x0:=xl ; y0:=yl;   x1:=xg ; y1:=yg;
	end else begin
           x0:=xg ; y0:=yg;   x1:=xl ; y1:=yl;
        end;
	LineClipping:=true;
end;

function BarClipping(var x0,y0,x1,y1:Integer):Boolean;
var xl,yl,xg,yg:integer;
    minx,miny,maxx,maxy:Integer;
begin
	if GMinX>GMaxX then begin
	       minx:=GMaxX;
	       maxx:=GMinX;
	end else begin
	       minx:=GMinX;
	       maxx:=GMaxX;
	end;
	if GMaxY>GMinY then begin
	       miny:=GMinY;
	       maxy:=GMaxY;
	end else begin
	       miny:=GMaxY;
	       maxy:=GMinY;
	end;
        if x0<x1 then begin xl:=x0; xg:=x1;
             end else begin xl:=x1; xg:=x0; end;
        if y0<y1 then begin yl:=y0; yg:=y1;
             end else begin yl:=y1; yg:=y0; end;
	if (xg<minx) or (xl>maxx) then begin BarClipping:=false; exit; end;
	if (yg<miny) or (yl>maxy) then begin BarClipping:=false; exit; end;
	if (xg>maxx) and (xl<minx) and (yg>maxy) and (yl<miny)
	     then begin BarClipping:=false; exit; end;
	if xg>maxx then xg:=maxx;
	if xl<minx then xl:=minx;
	if yg>maxy then yg:=maxy;
	if yl<miny then yl:=miny;
	x0:=xl;  y0:=yl;
	x1:=xg;  y1:=yg;
	BarClipping:=True;
end;

function  LineClippingReal(var x0,y0,x1,y1:Real):Boolean;

  function fny(x:Real):Real;
     begin
       fny:=(y1-y0)*(x-x0)/(x1-x0)+y0;
     end;

  function fnx(y:Real):Real;
     begin
       fnx:=(x1-x0)*(y-y0)/(y1-y0)+x0;
     end;

var a,xl,yl,xg,yg:Real;
    minx,miny,maxx,maxy:Real;

begin
	if WMinX>WMaxX then begin
	       minx:=WMaxX;
	       maxx:=WMinX;
	end else begin
	       minx:=WMinX;
	       maxx:=WMaxX;
	end;
	if WMaxY>WMinY then begin
	       miny:=WMinY;
	       maxy:=WMaxY;
	end else begin
	       miny:=WMaxY;
	       maxy:=WMinY;
	end;
        if x0<x1 then begin
            xl:=x0;  yl:=y0; xg:=x1;  yg:=y1;
        end else begin
            xl:=x1;  yl:=y1; xg:=x0;  yg:=y0;
        end;
        if (xg<minx) or (xl>maxx) then begin
	   LineClippingReal:=false; exit;
        end;
        if xg>maxx then begin
           xg:=maxx; yg:=fny(maxx);
        end;
        if xl<minx then begin
           xl:=minx; yl:=fny(minx);
        end;
        if yl>yg then begin
           a:=yl;  yl:=yg;  yg:=a;  a:=xl;  xl:=xg;  xg:=a;
        end;
        if (yg<miny) or (yl>maxy) then begin
	   LineClippingReal:=false; exit;
        end;
        if yg>maxy then begin
           yg:=maxy; xg:=fnx(maxy);
        end;
        if yl<miny then begin
           yl:=miny; xl:=fnx(miny);
        end;
	if (y0<y1) or ( (y0=y1) and (x0<x1) ) then begin
           x0:=xl ; y0:=yl;   x1:=xg ; y1:=yg;
        end else begin
           x0:=xg ; y0:=yg;   x1:=xl ; y1:=yl;
        end;
	LineClippingReal:=true;
end;

function BarClippingReal(var x0,y0,x1,y1:Real):Boolean;
var xl,yl,xg,yg:Real;
    minx,miny,maxx,maxy:Real;
begin
	if WMinX>WMaxX then begin
	       minx:=WMaxX;
	       maxx:=WMinX;
	end else begin
	       minx:=WMinX;
	       maxx:=WMaxX;
	end;
	if WMaxY>WMinY then begin
	       miny:=WMinY;
	       maxy:=WMaxY;
	end else begin
	       miny:=WMaxY;
	       maxy:=WMinY;
	end;
	if x0<x1 then begin xl:=x0; xg:=x1;
             end else begin xl:=x1; xg:=x0; end;
        if y0<y1 then begin yl:=y0; yg:=y1;
             end else begin yl:=y1; yg:=y0; end;
	if (xg<minx) or (xl>maxx) then begin BarClippingReal:=false; exit; end;
	if (yg<miny) or (yl>maxy) then begin BarClippingReal:=false; exit; end;
	if (xg>maxx) and (xl<minx) and (yg>maxy) and (yl<miny)
	     then begin BarClippingReal:=false; exit; end;
	if xg>maxx then xg:=maxx;
	if xl<minx then xl:=minx;
	if yg>maxy then yg:=maxy;
	if yl<miny then yl:=miny;
	x0:=xl;  y0:=yl;
	x1:=xg;  y1:=yg;
	BarClippingReal:=true;
end;

procedure UseWindow(MinX,MinY,MaxX,MaxY:Integer);
begin
   GMinX:=MinX;
   GMinY:=MinY;
   GMaxX:=MaxX;
   GMaxY:=MaxY;
end;

procedure SetWindow(MinX,MinY,MaxX,MaxY: Real);
begin
    WMinX:=MinX;
    WMinY:=MinY;
    WMaxX:=MaxX;
    WMaxY:=MaxY;
    Ratex:=(GMaxX-GMinX)/(WMaxX-WMinX);
    Ratey:=(GMaxY-GMinY)/(WMaxY-WMinY);
    PointerX:=MinX;
    PointerY:=MinY;
end;

function XToG(x:Real):Integer;
var a:Real;
  begin
    a:=(x-WMinX)*RateX;
    if (a>MAXINT) then a:=MAXINT;
    if (a<MININT) then a:=MININT;
    XToG:=Round(a);
  end;

function YToG(y:Real):Integer;
var a:Real;
  begin
    a:=(y-WMinY)*RateY;
    if (a>MAXINT) then a:=MAXINT;
    if (a<MININT) then a:=MININT;
    YToG:=Round(a);
  end;

function GToX(x:Integer):Real;
  begin
    GToX:=x/RateX+WMinX;
  end;

function GToY(y:Integer):Real;
var a:Real;
  begin
    GToY:=y/RateY+WMinY;
  end;

function XScaleG(x:Real):Integer;
var a:Real;
  begin
    a:=abs(x*RateX);
    if (a>MAXINT) then a:=MAXINT;
    XScaleG:=Round(a);
  end;

function YscaleG(y:Real):Integer;
var a:Real;
  begin
    a:=abs(Y*RateY);
    if (a>MAXINT) then a:=MAXINT;
    YScaleG:=Round(a);
  end;

function GScaleX(x:Integer):Real;
  begin
    GScaleX:=x/RateX;
  end;

function GscaleY(y:Integer):Real;
  begin
    GScaleY:=y/RateY;
  end;

procedure GMoveTo(x,y:Real);
begin
   PointerX:=x;
   PointerY:=y;
end;

procedure GMoveRel(dx,dy:Real);
begin
   PointerX:=PointerX+dx;
   PointerY:=PointerY+dy;
end;

function GGetX:Real;
begin
   GGetX:=PointerX;
end;

function GGetY:Real;
begin
   GGetY:=PointerY;
end;

function WInXY(x,y:Real):Boolean;
begin
   if ( (WMinX<=x) and (x<=WMaxX) or (WMaxX<=x) and (x<=WMinX) ) and
      ( (WMinY<=y) and (y<=WMaxY) or (WMaxY<=y) and (y<=WMinY) ) then WInXY:=True
   else WInXY:=False;
end;

function GInXY(x,y:Integer):Boolean;
begin
   if ( (GMinX<=x) and (x<=GMaxX) or (GMaxX<=x) and (x<=GMinX) ) and
      ( (GMinY<=y) and (y<=GMaxY) or (GMaxY<=y) and (y<=GMinY) ) then GInXY:=True
   else GInXY:=False;
end;

end.
