(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I[oC葱Aϐ̏ *)

unit Construc;

interface

uses DOSCall,Crt,Jctype,Variable,PullMenu;

Type Real=Double;

procedure Construct;

implementation

procedure Construct;

var i,j:Integer;
begin


(* SYSTEM RECORD VARIABLE *)

    With WinEnv do begin
        TFont:='';
        TSize:=0;
        TExtra:=1;
    end;


    With DGSYS do begin
        Main :=' Ngraph ';
        Ver  :='ver. 5.3';
        Ver2 :='1';
        Ver3 :=' ';
        TEMPDIR:=GetEnv('TEMP');
        if TEMPDIR='' then TEMPDIR:=GetEnv('TMP');
        if TEMPDIR='' then TEMPDIR:='.';
        i:=1;
        While i<=Length(TEMPDIR) do begin
          if not IsKanji(Ord(TEMPDIR[i])) then TEMPDIR[i]:=UpCase(TEMPDIR[i])
                                          else Inc(i);
          Inc(i);
        end;
        if TEMPDIR[Length(TEMPDIR)]<>'\' then TEMPDIR:=TEMPDIR+'\';
        GRADIR:=TEMPDIR;
        Getdir(0,ActivDir);
        INItitle :='INI file';
        PRMtitle :='PRM file';
        DPMtitle :='DPM file';
        GRAtitle :='GRA file';
        Copyright:='Copyright (C) S.Ishizaka. 1997.';
        TEMPNAME    :='$NGRAPH$';
        DataBufSize :=0;
        DataBufSeg  :=0;
        MaximData   :=0;
        SPMaximData :=0;
        GraphicFil  :='';
        Device :=0;
        OutPutDevice:=Printer;
        Resolution:=10;
        AutoRun   :=True;
        FullPath  :='Yes ';
        DPMOut    :='No  ';
        FileOption:='No  ';
        Previewer :='GRA2GRA.EXE';
        OutPutFile:='';
        ParamFile:='*.PRM';
    end;


(* GRAPH PARAMETER *)

    With NGRAPH do begin
        Drawn     :=False;
        GraphTyp  :=1;
        TopMargin :=400;
        LeftMargin:=0;
        RegionSize:=2100;
        ViewX1    :=400;
        ViewY1    :=300;
        Sizex     :=1400;
        Sizey     :=1400;
        DrawMode[0]:='Yes ';
        DrawMode[1]:='Yes ';
        DrawMode[2]:='Yes ';
        Con00     :='Yes ';
        for i:=0 to 6 do Aattr[i] :='%FH%JG%S24%P+00%R%C0';
        for i:=0 to 6 do ASattr[i]:='%FH%JG%S18%P+00%R%C0';
        UserFn[0]:='X';
        UserFn[1]:='Y';
    end;


(* DRIVER RECORD VARIABLE *)

    With DRIVER[0] do begin
       Name:='GRA2GRA.EXE';
       Opt:='GRA2PRNW.EXE -s';
       Note:='Windows                       ';
    end;
    With DRIVER[1] do begin
       Name:='GRA2GRA.EXE';
       Opt:=' -g GRA2PRNW.EXE -s';
       Note:='Windows (MVA>>Symbol)';
    end;
    With DRIVER[2] do begin
       Name:='GRA2LIPS.EXE';
       Opt:='';
       Note:='LASER SHOT LIPS/II/II+ (CANON)';
    end;
    With DRIVER[3] do begin
       Name:='GRA2LIPS.EXE';
       Opt:=' -3';
       Note:='LASER SHOT LIPS III    (CANON)';
    end;
    With DRIVER[4] do begin
       Name:='GRA2PS.EXE';
       Opt:='';
       Note:='{ PostScript(R)          ';
    end;


(* ADD-IN RECORD VARIABLE *)

    With VAF do begin
       for i:=0 to 2 do Prolog[i]:='';
       for i:=0 to 2 do Draw[i]:='';
       for i:=0 to 2 do Epilog[i]:='';
       Menu[0]:='READPRM.ADI';
       Menu[1]:='COLOR.ADI';
       Menu[2]:='KEY.ADI';
       Menu[3]:='CALC.ADI';
       Menu[4]:='FFT.ADI';
       Menu[5]:='FITEQ.ADI';
       for i:=6 to 14 do Menu[i]:='';
    end;


(* FILE PARAMETER *)

   FilePar.Num:=0;
   For i:=0 to maxfil+1 do With FilePar.Body[i] do begin
      Name:='';
      hax:=1;
      vax:=2;
      Axisx:=0;
      Axisy:=0;
      DotTyp:=8;
      DotAttr:=0;
      DotWidth:=40;
      DotCol:=0;
      DotSize:=20;
      DottedSize:=15;
      ReadStep:=1;
      Smoothingx:=0;
      Smoothingy:=0;
      DotNum:=-2;
      SkipNum:=0;
      FinalLine:=-1;
      Comment:='';
      IsRead:=False;
      LeastMode:=0;
      Lx:=0;
      Ly:=0;
      ModX:='X';
      ModY:='Y';
   end;

   With LSQPar do begin
       Typ:=-1;
       Dim:=2;
       for i:=1 to 8 do begin
           Coe[i]:=0;
           CoeError[i]:=0;
       end;
       ExitCode:=-1;
       Error:=0;
       Correlation:=-1;
       FitError:=1;
       FitDif:='No  ';
       FitVal[1]:=0;
       FitVal[2]:=0;
       FitVal[3]:=0;
       FitVal[4]:=0;
       FitVal[5]:=0;
       FitVal[6]:=0;
       FitVal[7]:=0;
       FitExp[0]:='%00+%01*X';
       FitExp[1]:='1';
       FitExp[2]:='X';
       FitExp[3]:='';
       FitExp[4]:='';
       FitExp[5]:='';
       FitExp[6]:='';
       FitExp[7]:='';
   end;


(* AXIS RECORD VARIABLE *)

    for i:=0 to 3 do With AxisPar[i] do begin
        Min:=-1;
        Max:=1;
        Scale:=1;
        SetMin:=False;
        SetMax:=False;
        SetScale:=False;
        ScType:=0;
        ScDiv:='Auto';
        ScMode:='Yes ';
        ScFull:='Yes ';
        ScCros:='Auto';
        ScAuto:='Yes ';
        ScNum:='Auto';
        ScStart:='Auto';
        ScStep:='Auto';
        ScFig:='5.5 ';
        ScZero:='No  ';
        ScPlus:='No  ';
        ScPer:='No  ';
        ScPosS:=0;
        ScPosE:=10000;
        ScDir:=0;
        ScLog:=1;
        LLen[1]:=15;
        LLen[2]:=30;
        LLen[3]:=40;
        Lattr[0]  :=0;
        Lattr[1]  :=1;
        Lattr[2]  :=0;
        Lattr[3]  :=0;
        Lattr[4]  :=0;
        LWidth[0] :=40;
        LWidth[1] :=20;
        LWidth[2] :=20;
        LWidth[3] :=20;
        LWidth[4] :=40;
        Lcol[0]   :=0;
        Lcol[1]   :=3;
        Lcol[2]   :=3;
        Lcol[3]   :=3;
        Lcol[4]   :=0;
    end;
    With AxisPar[0] do begin
        ScLR:=2;
        ScPosx:=0;
        ScPosy:=10;
    end;
    With AxisPar[1] do begin
        ScLR:=1;
        ScPosx:=-10;
        ScPosy:=0;
    end;
    With AxisPar[2] do begin
        ScLR:=2;
        ScPosx:=0;
        ScPosy:=-10;
    end;
    With AxisPar[3] do begin
        ScLR:=3;
        ScPosx:=10;
        ScPosy:=0;
    end;


(* MASK-POINT RECORD VALIABLE *)

   Mask.Num:=0;
   for i:=0 to 20 do
       With Mask.Body[i] do begin
           Fil:=0;
           Lin:=0;
           x:=0;
           y:=0;
       end;


(* MASK-REGION RECORD VARIABLE *)

   MaskReg.Num:=0;
   for i:=0 to 20 do begin
       With MaskReg.Body[i] do begin
           Fil:=0;
           Mx1:=0;
           My1:=0;
           Mx2:=0;
           My2:=0;
       end;
   end;

   ChgData.Num:=0;
   for i:=0 to 20 do begin
       With ChgData.Body[i] do begin
           Fil:=0;
           Lin:=0;
           x:=0;
           y:=0;
       end;
   end;

(* MERGE RECORD VARIABLE *)

   for i:=0 to 10 do With Merge[i] do begin
       Fil:='';
       X:=0;
       Y:=0;
       Size:=2100;
   end;

(* LEGEND-TITLE RECORD VARIABLE *)

   With Title[0] do begin
       x:=    0;
       y:=-2000;
       Str:='';
   end;
   With Title[1] do begin
       x:=    0;
       y:= 3000;
       Str:='';
   end;
   With Title[2] do begin
       x:=    0;
       y:= 2000;
       Str:='';
   end;
   With Title[3] do begin
       x:=-2000;
       y:=    0;
       Str:='';
   end;
   With Title[4] do begin
       x:=    0;
       y:=-1000;
       Str:='';
   end;
   With Title[5] do begin
       x:= 2500;
       y:=    0;
       Str:='';
   end;


(* LEGEND-TEXT RECORD VARIABLE *)

   for i:=0 to 20 do
       With Remark[i] do begin
           x:=10500;
           y:=10500;
           dir:=0;
           Str:='';
       end;


(* LEGEND-ARROW RECORD VARIABLE *)

   for i:=0 to 20 do
       With Arrow[i] do begin
	   sx:=10500;
           sy:=10500;
           ex:=10500;
           ey:=10500;
           Attr:=0;
           Width:=40;
           Len:=300;
           Col:=0;
           Act:=False;
       end;


(* LEGEND-DOT RECORD VARIABLE *)

    for i:=0 to 20 do
       With Dot[i] do begin
           for j:=0 to 9 do begin
               x[j]:=10500;
               y[j]:=10500;
           end;
           Attr:=0;
           Width:=40;
           Typ:=0;
           Col:=0;
           ActivNum:=0;
           DotSize:=20;
           DottedSize:=15;
       end;


(* MENU COLOR RECORD VARIABLE *)

   With Color2 do begin
       Message2[0]:=Crt.White + Crt.Reverse;
       Message2[1]:=0;
       Message2[2]:=Crt.Green + Crt.Reverse + Crt.Blink;
       Message2[3]:=Crt.Cyan + Crt.Reverse + Crt.Blink;
       Message2[4]:=Crt.Red + Crt.Reverse + Crt.Blink;
       Message2[5]:=Crt.Magenta + Crt.Reverse + Crt.Blink;
       Message2[6]:=Crt.Yellow + Crt.Reverse + Crt.Blink;
       Param[0]:=Crt.Green;
       Param[1]:=Crt.Yellow;
       Param[2]:=Crt.Magenta;
       Param[3]:=Crt.White + Crt.Reverse;
       Graphic[0]:=7;
       Graphic[1]:=7;
       Graphic[2]:=3;
       Graphic[3]:=6;
       Graphic[4]:=3;
       Graphic[5]:=6;
       With MainMenu do begin
             Frame :=Crt.Black;
             Title :=Crt.Black;
             Title2:=Crt.Black;
             Back  :=Crt.Cyan + Crt.Reverse;
             Bar   :=Crt.Yellow + Crt.Reverse;
             Sel   :=Crt.Black;
             SelBar:=Crt.Black;
             First :=Crt.Yellow + Crt.Reverse;
             Shadow:=0;
       end;
       With Menu do begin
         Frame :=Crt.White ;
	 Title :=Crt.Yellow + Crt.Reverse;
	 Title2:=Crt.Black;
	 Back  :=Crt.White ;
	 Bar   :=Crt.White + Crt.Reverse;
	 Sel   :=Crt.Blue  ;
	 SelBar:=Crt.Blue + Crt.Reverse;
	 First :=Crt.Cyan  ;
         Shadow:=0;
       end;
       With Menu2 do begin
          Frame :=Crt.White ;
	  Title :=Crt.White + Crt.Reverse;
	  Title2:=Crt.Black;
	  Back  :=Crt.White ;
	  Bar   :=Crt.Cyan + Crt.Reverse;
	  Sel   :=Crt.Blue ;
	  SelBar:=Crt.Cyan + Crt.Reverse;
	  First :=Crt.Cyan ;
          Shadow:=0;
       end;
       With Menu3 do begin
          Frame :=Crt.White ;
	  Title :=Crt.White + Crt.Reverse;
	  Title2:=Crt.Black;
	  Back  :=Crt.White ;
	  Bar   :=Crt.Yellow + Crt.Reverse;
	  Sel   :=Crt.Blue ;
	  SelBar:=Crt.Cyan + Crt.Reverse;
	  First :=Crt.Cyan ;
          Shadow:=0;
       end;
       With Setting do begin
           Frame :=Crt.White + Crt.Reverse ;
	   Title :=Crt.Yellow + Crt.Reverse ;
	   Title2:=Crt.White + Crt.Reverse ;
	   Back  :=Crt.White + Crt.Reverse ;
	   Bar   :=Crt.Cyan + Crt.Reverse ;
	   Sel   :=Crt.Cyan + Crt.Reverse ;
	   SelBar:=Crt.Green + Crt.Reverse ;
	   First :=Crt.Cyan + Crt.Reverse ;
           Shadow:=0;
       end;
       With Setting2 do begin
            Frame :=Crt.White + Crt.Reverse ;
	    Title :=Crt.Cyan + Crt.Reverse ;
	    Title2:=Crt.White + Crt.Reverse ;
	    Back  :=Crt.White + Crt.Reverse ;
	    Bar   :=Crt.Yellow + Crt.Reverse ;
	    Sel   :=Crt.Yellow + Crt.Reverse ;
	    SelBar:=Crt.Green + Crt.Reverse ;
	    First :=Crt.Yellow + Crt.Reverse ;
            Shadow:=0;
       end;
       With Directory do begin
              Frame :=Crt.White + Crt.Reverse;
	      Title :=Crt.Cyan + Crt.Reverse;
	      Title2:=Crt.White + Crt.Reverse;
	      Back  :=Crt.White + Crt.Reverse;
	      Bar   :=Crt.Yellow + Crt.Reverse;
	      Sel   :=Crt.Black;
	      SelBar:=Crt.Black;
	      First :=Crt.Black;
              Shadow:=0;
       end;
       With WindowInput do begin
                Frame :=Crt.White + Crt.Reverse;
	        Title :=Crt.White + Crt.Reverse;
		Title2:=Crt.Black;
		Back  :=Crt.White + Crt.Reverse;
		Bar   :=Crt.Black;
                Sel   :=Crt.Yellow + Crt.Reverse;
		SelBar:=Crt.Black;
		First :=Crt.Black;
                Shadow:=0;
       end;
       With Verify do begin
           Frame :=Crt.White + Crt.Reverse;
	   Title :=Crt.White + Crt.Reverse;
	   Title2:=Crt.White + Crt.Reverse;
	   Back  :=Crt.Yellow + Crt.Reverse;
	   Bar   :=Crt.Black;
	   Sel   :=Crt.White + Crt.Reverse;
	   SelBar:=Crt.Black;
	   First :=Crt.Black;
           Shadow:=0;
       end;
       With Verify2 do begin
            Frame :=Crt.White + Crt.Reverse;
	    Title :=Crt.White + Crt.Reverse;
	    Title2:=Crt.White + Crt.Reverse;
	    Back  :=Crt.Cyan + Crt.Reverse;
	    Bar   :=Crt.Black;
	    Sel   :=Crt.White + Crt.Reverse;
	    SelBar:=Crt.Black;
	    First :=Crt.Black;
            Shadow:=0;
       end;
       With SelFile do begin
            Frame :=Crt.Magenta ;
	    Title :=Crt.Magenta + Crt.Reverse;
	    Title2:=Crt.Yellow + Crt.Reverse;
	    Back  :=Crt.Green + Crt.Reverse;
	    Bar   :=Crt.White + Crt.Reverse;
	    Sel   :=Crt.White + Crt.Reverse;
	    SelBar:=Crt.Yellow + Crt.Reverse;
	    First :=Crt.Black;
            Shadow:=0;
       end;
       With FileDisp do begin
             Frame :=Crt.Cyan ;
	     Title :=Crt.Cyan ;
	     Title2:=Crt.Magenta ;
	     Back  :=Crt.Blue ;
	     Bar   :=Crt.Yellow + Crt.Reverse;
	     Sel   :=Crt.Green + Crt.Reverse;
	     SelBar:=Crt.Red + Crt.Reverse;
	     First :=Crt.Magenta + Crt.Reverse + Crt.Blink;
             Shadow:=0;
       end;
       With Error do begin
          Frame :=Crt.Red + Crt.Reverse;
	  Title :=Crt.Red + Crt.Reverse;
	  Title2:=Crt.Black;
	  Back  :=Crt.Red + Crt.Reverse;
	  Bar   :=Crt.Black;
	  Sel   :=Crt.Red + Crt.Reverse;
	  SelBar:=Crt.Black;
	  First :=Crt.Black;
          Shadow:=0;
       end;
   end;
end;

end.
