(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(*  I|oC葱CDG.INI o *)

unit DGINI;

interface

uses PullMenu,Variable,Display,IOProc,DosCall;

Type Real=Double;

procedure IniOut(fil:PathStr);
procedure IniIn(Fil:PathStr);

implementation

procedure IniOut(fil:PathStr);
var fp:text;
    i:integer;
    Error:Boolean;
begin
    Assign(fp,fil);
    Rewrite(fp);
    WriteLn(fp,DGSYS.Main+DGSYS.Ver+'  '+DGSYS.INItitle);

    With FilePar.Body[0] do begin
       WriteLn(fp,hax,' ',vax,' ',Axisx,' ',Axisy,' ',DotTyp,' ',DotAttr,' ',
                  DotWidth,' ',DotCol,' ',DotSize,' ',DottedSize);
       WriteLn(fp,SkipNum,' ',ReadStep,' ',FinalLine,' ',Smoothingx,' ',Smoothingy);
       WriteLn(fp,LeastMode,' ',Lx,' ',Ly);
       WriteLn(fp,ModX);
       WriteLn(fp,ModY);
    end;

    With DGSYS do begin
        WriteLn(fp,OutPutDevice,' ',Resolution);
        WriteLn(fp,FullPath,DPMOut,FileOption);
        if DGSYS.FullPath[1]='Y' then begin
            WriteLn(fp,Previewer);
            WriteLn(fp,OutPutFile);
        end else begin
            WriteLn(fp,MakeFileName2(Previewer));
            WriteLn(fp,MakeFileName2(OutPutFile));
        end;
    end;

    for i:=0 to 4 do With DRIVER[i] do begin
        if DGSYS.FullPath[1]='Y' then WriteLn(fp,Name)
                                 else WriteLn(fp,MakeFileName2(Name));
        WriteLn(fp,Opt);
        WriteLn(fp,Note);
    end;

    With VAF do begin
        for i:=0 to 2 do
           if DGSYS.FullPath[1]='Y' then WriteLn(fp,Prolog[i])
                                    else WriteLn(fp,MakeFileName2(Prolog[i]));
        for i:=0 to 2 do
           if DGSYS.FullPath[1]='Y' then WriteLn(fp,Draw[i])
                                    else WriteLn(fp,MakeFileName2(Draw[i]));
        for i:=0 to 2 do
           if DGSYS.FullPath[1]='Y' then WriteLn(fp,Epilog[i])
                                    else WriteLn(fp,MakeFileName2(Epilog[i]));
        for i:=0 to 14 do
           if DGSYS.FullPath[1]='Y' then WriteLn(fp,Menu[i])
                                    else WriteLn(fp,MakeFileName2(Menu[i]));
    end;

    With Color2 do begin
        WriteLn(fp,Message2[0],' ',Message2[1],' ',Message2[2],' ',Message2[3],' ',Message2[4],' ',Message2[5],' ',
                   Message2[6]);
        WriteLn(fp,Param[0],' ',Param[1],' ',Param[2],' ',Param[3]);
        WriteLn(fp,Graphic[0],' ',Graphic[1],' ',Graphic[2],' ',Graphic[3],' ',Graphic[4],' ',Graphic[5]);
        With MainMenu do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With Menu do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With Menu2 do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With Menu3 do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With Setting do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With Setting2 do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With Directory do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With WindowInput do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With Verify do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With Verify2 do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With SelFile do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With FileDisp do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
        With Error do WriteLn(fp,Frame,' ',Title,' ',Title2,' ',Back,' ',Bar,' ',Sel,' ',SelBar,' ',First,' ',Shadow);
    end;
    With PullKey do
        WriteLn(fp,Ord(ESC),' ',Ord(BS),' ',Ord(CR),' ',Ord(UP),' ',Ord(DOWN),' ',Ord(LEFT),' ',Ord(RIGHT),
               ' ',Ord(HOME),' ',Ord(HOMES),' ',Ord(ROLLUP),' ',Ord(ROLLDOWN),' ',Ord(DEL));

    With WinEnv do begin
      if (TFont='') or (TSize<=0) then begin
        TFont:='';
        TSize:=0;
      end;
      WriteLn(fp,TSize,' ',TExtra);
      WriteLn(fp,TFont);
    end;
    Close(fp);
    Error:=IOErrorCheck;
end;

procedure IniIn(Fil:PathStr);
var c1,c2:longint;
    fp:text;
    i,j:integer;
    Str:String;
    Error:Boolean;
    Dir:DirStr;
    Name:NameStr;
    Ext:ExtStr;
    ESC2,BS2,CR2,UP2,DOWN2,LEFT2,RIGHT2,
    HOME2,HOMES2,ROLLUP2,ROLLDOWN2,DEL2:Byte;
    FileType:Integer;
begin
     FWild(Fil,Dir,Name,Ext,'.INI');
     if Find(Fil,true) then begin
	  Assign(fp,fil);
	  Reset(fp);
          ReadLn(fp,Str);
	  if Str=(DGSYS.Main+Ver2+'  '+DGSYS.INItitle) then FileType:=2
	  else if Str=(DGSYS.Main+DGSYS.Ver+'  '+DGSYS.INItitle) then FileType:=3
          else FileType:=0;
          if (FileType<>0) then begin
	    With FilePar.Body[0] do begin
                ReadLn(fp,hax,vax,Axisx,Axisy,DotTyp,DotAttr,
                          DotWidth,DotCol,DotSize,DottedSize);
                Readln(fp,SkipNum,ReadStep,FinalLine,Smoothingx,Smoothingy);
                ReadLn(fp,LeastMode,Lx,Ly);
                ReadLn(fp,ModX);
                ReadLn(fp,ModY);
            end;

            With DGSYS do begin
                ReadLn(fp,OutPutDevice,Resolution);
                if FileType=2 then ReadLn(fp,FullPath,FileOption)
                else if FileType=3 then ReadLn(fp,FullPath,DPMOut,FileOption);
                ReadLn(fp,Previewer);
                ReadLn(fp,OutPutFile);
            end;

            for i:=0 to 4 do With DRIVER[i] do begin
                ReadLn(fp,Name);
                ReadLn(fp,Opt);
                ReadLn(fp,Note);
            end;

            With VAF do begin
                for i:=0 to 2 do ReadLn(fp,Prolog[i]);
                for i:=0 to 2 do ReadLn(fp,Draw[i]);
                for i:=0 to 2 do ReadLn(fp,Epilog[i]);
                for i:=0 to 14 do ReadLn(fp,Menu[i]);
            end;

            With Color2 do begin
                ReadLn(fp,Message2[0],Message2[1],Message2[2],Message2[3],Message2[4],Message2[5],Message2[6]);
                ReadLn(fp,Param[0],Param[1],Param[2],Param[3]);
                if FileType=3 then ReadLn(fp,Graphic[0],Graphic[1],Graphic[2],Graphic[3],Graphic[4],Graphic[5]);
                With MainMenu do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With Menu do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With Menu2 do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With Menu3 do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With Setting do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With Setting2 do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With Directory do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With WindowInput do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With Verify do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With Verify2 do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With SelFile do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With FileDisp do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
                With Error do ReadLn(fp,Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow);
            end;

            With PullKey do begin
                ReadLn(fp,ESC2,BS2,CR2,UP2,DOWN2,LEFT2,RIGHT2,HOME2,HOMES2,ROLLUP2,ROLLDOWN2,DEL2);
                ESC:=Chr(ESC2);
                BS:=Chr(BS2);
                CR:=Chr(CR2);
                UP:=Chr(UP2);
                DOWN:=Chr(DOWN2);
                LEFT:=Chr(LEFT2);
                RIGHT:=Chr(RIGHT2);
                HOME:=Chr(HOME2);
                HOMES:=Chr(HOMES2);
                ROLLUP:=Chr(ROLLUP2);
                ROLLDOWN:=Chr(ROLLDOWN2);
                DEL:=Chr(DEL2);
            end;

            With WinEnv do begin
              ReadLn(fp,TSize,TExtra);
              ReadLn(fp,TFont);
            end;

	  end else ErrorDisp('Error: Incompatible INI file('+fil+')');
	  Close(fp);
	  Error:=IOErrorCheck;
     end;
end;

end.
