(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I|oC葱Ct@C_CO *)

unit Dialog;

interface

uses PullMenu,Variable,Display,DosCall;

Type Real=Double;

function  GetFileName(x,y:Integer;var Fil,Path:PathStr;Extension,Mes:String):Boolean;
function  SetFileParam(x,y,Fil:Integer;Update:Boolean):Integer;

implementation

function GetFileName(x,y:Integer;var Fil,Path:PathStr;Extension,Mes:String):Boolean;
var S:String;
    Path2:PathStr;
    Dir:DirStr;
    Name:NameStr;
    Ext:ExtStr;
begin
    GetFileName:=False;
    S:=Path;
    PullColor:=Color2.WindowInput;
    if WindowInput(x,y,30,S,Mes,'') then begin
        Path:=S;
        FWild(Path,Dir,Name,Ext,Extension);
        Path2:=Path;
        if (Pos('*',Path2)<>0) or (Pos('?',Path2)<>0) then begin
            PullColor:=Color2.Directory;
            Path2:=SelectAFile(x,y,3,10,Path,'ESC:~ CR:I');
        end;
        if Length(Path2)<>0 then begin
            GetFileName:=True;
            Fil:=Path2;
        end;
    end;
end;

const

AxisXMenu : array [0..1] of String[6]=('X-axis',
                                       'U-axis');
AxisYMenu : array [0..1] of String[6]=('Y-axis',
                                       'R-axis');
SetFileMenu : array [0..16] of String[17+10]=
    ('      f[^:',
     'c      f[^:',
     'h b g  ^Cv:',
     ' C   J|:',
     ' C   `  :',
     ' C       :',
     'h b g  TCY:',
     ' C _Ԋu:',
     '      :',
     'c      :',
     '擪XLbvs:',
     'ǍXebvs:',
     'Ǎ   I s:',
     '  Q      :',
     'c  Q      :',
     ' Q          ',
     ' ~          ');

   LSQMenu2: array [0..1] of String[12]  = ('ʉߓ_',
                                            'ʉߓ_L' );

function SetFileParam(x,y,Fil:Integer;Update:Boolean):Integer;
var S:Str10;
    a,Sel,Sel2:Integer;
    WInput:Boolean;
    SCom,SmodX,SModY,SName:String;
    SIsRead:Boolean;
    SDotNum:LongInt;
    SelFile:ByteSet;
begin
  With FilePar.Body[Fil] do begin
    PullColor:=Color2.Setting;
    if Update then SelectMenuSFirst(x,y,1,16,17+10,0,16)
              else SelectMenuSFirst(x,y,1,17,17+10,0,17);
    repeat
        if hax=0 then S:=' Numbering'
        else begin
            Str(hax:2,S);
            S:=' Column '+S;
        end;
        SetMenuVal(0,17+10,SetFileMenu,S,6,10);
        if vax=0 then S:=' Numbering'
        else begin
            Str(vax:2,S);
            S:=' Column '+S;
        end;
        SetMenuVal(1,17+10,SetFileMenu,S,6,10);
        SetMenuVal(2,17+10,SetFileMenu,DotMenu[DotTyp],6,10);
        SetMenuVal(3,17+10,SetFileMenu,ColMenu[DotCol],6,10);
        SetMenuVal(4,17+10,SetFileMenu,LineMenu[DotAttr],6,10);
        SetMenuVal(5,17+10,SetFileMenu,DotWidth,1,0);
        SetMenuVal(6,17+10,SetFileMenu,DotSize,1,0);
        SetMenuVal(7,17+10,SetFileMenu,DottedSize,1,0);
        SetMenuVal(8,17+10,SetFileMenu,Smoothingx,1,0);
        SetMenuVal(9,17+10,SetFileMenu,Smoothingy,1,0);
        SetMenuVal(10,17+10,SetFileMenu,SkipNum,2,0);
        SetMenuVal(11,17+10,SetFileMenu,ReadStep,1,0);
        SetMenuVal(12,17+10,SetFileMenu,FinalLine,2,0);
        SetMenuVal(13,17+10,SetFileMenu,AxisXMenu[Axisx],6,6);
        SetMenuVal(14,17+10,SetFileMenu,AxisYMenu[Axisy],6,6);
        Sel:=SelectMenuSNext(SetFileMenu,Name,'');
        PullColor:=Color2.Setting2;
        case Sel of
             0: ValInput(PWinX+18,PWinY+1,'(0:Numbering 1-99:Column)',hax,1,0,99);
             1: ValInput(PWinX+18,PWinY+2,'(0:Numbering 1-99:Column)',vax,1,0,99);
             2: begin
                    SelectMode(False,False,False,True);
                    Sel2:=SelectAMenu(PWinX+18,PWinY+3,1,10,14,DotTyp,52,DotMenu,'','');
                    SelectMode(True,False,False,True);
                    if Sel2>=0 then begin
                        DotTyp:=Sel2;
                        if Sel2 in [42..50] then begin
                            a:=SelectAMenu(PWinX+18,PWinY+3,1,2,12,LeastMode,2,LSQMenu2,'','');
                            if a>=0 then begin
                                LeastMode:=a;
                                if a=1 then begin
                                    Winput:=WindowInputReal(PWinX+18,PWinY+3,'POINT (X)',Lx,4);
                                    Winput:=WindowInputReal(PWinX+18,PWinY+4,'POINT (Y)',Ly,4);
                                end;
                            end;
                        end;
                    end;
                end;
             3: begin
                    Sel2:=SelectAMenu(PWinX+18,PWinY+4,1,8,10,DotCol,8,ColMenu,'','');
                    if Sel2>=0 then DotCol:=Sel2;
                end;
             4: begin
                    Sel2:=SelectAMenu(PWinX+18,PWinY+5,1,4,10,DotAttr,4,LineMenu,'','');
                    if Sel2>=0 then DotAttr:=Sel2;
                  end;
             5: begin
                   if DotWidth=20 then a:=0
                   else if DotWidth=40 then a:=1
                   else a:=2;
                   Sel2:=SelectAMenu(PWinX+18,PWinY+6,1,3,10,a,3,WidthMenu,'','');
                   if Sel2>=0 then
                       case Sel2 of
                         0: DotWidth:=20;
                         1: DotWidth:=40;
                         2: ValInput(PWinX+18,PWinY+6,'NEW VALUE(1~1000/0.01mm)',DotWidth,1,1,1000);
                       end;
                end;
             6: ValInput(PWinx+18,PWiny+7,'NEW VALUE(1~2000/0.1mm)',DotSize,1,1,2000);
             7: ValInput(PWinx+18,PWiny+8,'NEW VALUE(1~1000/0.1mm)',DottedSize,1,1,1000);
             8: ValInput(PWinx+18,PWiny+9,'NEW VALUE(0~50)',Smoothingx,1,0,50);
             9: ValInput(PWinx+18,PWiny+10,'NEW VALUE(0~50)',Smoothingy,1,0,50);
            10: ValInput(PWinx+18,PWiny+11,'NEW VALUE(0~ )',SkipNum,2,0,MaxlongInt);
            11: ValInput(PWinx+18,PWiny+12,'NEW VALUE(1~ )',ReadStep,1,1,MaxInt);
            12: ValInput(PWinx+18,PWiny+13,'NEW VALUE(-1~ )',FinalLine,2,-1,MaxLongInt);
            13: begin
                    Sel2:=SelectAMenu(PWinx+18,PWiny+14,1,2,6,Axisx,2,AxisxMenu,'','');
                    if Sel2>=0 then Axisx:=Sel2;
                end;
            14: begin
                    Sel2:=SelectAMenu(PWinx+18,PWiny+15,1,2,6,Axisy,2,AxisyMenu,'','');
                    if Sel2>=0 then Axisy:=Sel2;
                end;
            15: begin
	          Sel2:=SelectFile(True,SelFile,'REFER');
	          if (Sel2>0) then begin
                      SModX:=ModX;
                      SModY:=ModY;
                      SCom:=Comment;
                      SIsRead:=IsRead;
                      SDotNum:=DotNum;
                      SName:=Name;
                      FilePar.Body[Fil]:=FilePar.Body[Sel2];
                      ModX:=SModX;
                      ModY:=SModY;
                      Comment:=SCom;
                      IsRead:=SIsRead;
                      DotNum:=SDotNum;
                      Name:=SName;
                  end;
                end;
        end;
    until (Sel<0) or (Sel=16);
    SelectMenuSEnd;
    SetFileParam:=Sel;
  end;
end;

end.
