(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* OtEf[^`葱 *)

unit DotDraw;

interface

uses Crt,PullMenu,Math,PrSpLine,GRA2Crt,GraGraph,Clip,LSTSQR,Display,Data,DataScal,Variable;

Type Real=Double;

procedure DotSet(DotTyp,LMode:Integer;xp,yp:Real;gattr,gcol,gwidth:integer;
                 Minx0,Miny0,Maxx0,Maxy0:Real;Sizex,Sizey,DotSize,DottedSize:Integer;ScTypex,ScTypey:Integer);


implementation

procedure DotSet(DotTyp,LMode:Integer;xp,yp:Real;gattr,gcol,gwidth:integer;
                 Minx0,Miny0,Maxx0,Maxy0:Real;Sizex,Sizey,DotSize,DottedSize:Integer;ScTypex,ScTypey:Integer);

var dotx,dotY:Real;
    dottedx,dottedy:Real;
    ResX,ResY:Real;
    xo,yo:Real;
    dottype :array [0..3] of real;
    dotlen:Real;
    doti:Integer;
    dotf,Curvef:Boolean;
    Coe:Vector;

        procedure MoveOut(x,y:Real);
        begin
            dotlen:=0;
            doti:=0;
            dotf:=True;
            xo:=x;
            yo:=y;
            nMoveTo(xo,yo);
        end;

	procedure LineOut(x,y:Real);
        var Len:Real;
            x2,y2:Real;
	begin
            x2:=x;
            y2:=y;
            if (dottype[0]=0) then nLineTo(x2,y2)
            else begin
             if LineClippingReal(xo,yo,x,y) then begin
	       Len:=Sqrt(Sqr((x-xo)/dottedx)+Sqr((y-yo)/dottedy));
               While ((Len+dotlen)>dottype[doti]) do begin
                  xo:=xo+(x-xo)*(dottype[doti]-dotlen)/Len;
                  yo:=yo+(y-yo)*(dottype[doti]-dotlen)/Len;
                  if dotf then nLineTo(xo,yo)
                          else nMoveTo(xo,yo);
                  dotf:=not dotf;
                  Len:=Len-dottype[doti]+dotlen;
                  dotlen:=0;
                  Inc(doti);
                  if doti=4 then doti:=0;
               end;
               if dotf then nLineTo(x,y);
               if (x2<>x) or (y2<>y) then nMoveTo(x2,y2);
               dotlen:=dotlen+Len;
             end else nMoveTo(x2,y2);
            end;
            xo:=x2;
            yo:=y2;
	end;

	function Curve(xs,ys,xw:Real):Boolean;
	var x,y,dx,dy,d,dd,ddx,ddy,wx:Real;
	begin
            if not Curvef then begin
                MoveOut(xs,ys);
                Curvef:=True;
            end;
            d:=0;
            while d<1 do begin
               if KeyCheck then begin
                   Curve:=False;
                   Exit;
               end;
               case DotTyp of
                 2,3:begin
                      dx:=2*Coe[2]+6*d*Coe[3];
                      dy:=2*Coe[5]+6*d*Coe[6];
                      ddx:=6*Coe[3];
                      ddy:=6*Coe[6];
                     end;
                   4:begin
                      dx:=0;
                      dy:=(2*Coe[2]+6*xw*d*Coe[3])*Sqr(xw);
                      ddx:=0;
                      ddy:=6*xw*Coe[3]*Sqr(xw);
                     end;
                 5,6:begin
                      dx:=2*Coe[3]+6*d*Coe[4];
                      dy:=2*Coe[7]+6*d*Coe[8];
                      ddx:=6*Coe[4];
                      ddy:=6*Coe[8];
                     end;
               end;
               if Abs(dx)+Abs(ddx)/3=0 then dx:=1
               else dx:=Sqrt(2*ResX/(Abs(dx)+Abs(ddx)/3));
               if Abs(dy)+Abs(ddy)/3=0 then dy:=1
               else dy:=Sqrt(2*ResY/(Abs(dy)+Abs(ddy)/3));
               if dx<dy then dd:=dx
                        else dd:=dy;
               d:=d+dd;
               if d>1 then d:=1;
               case DotTyp of
                 2,3:begin
                      x:=xs+d*(Coe[1]+d*(Coe[2]+d*Coe[3]));
                      y:=ys+d*(Coe[4]+d*(Coe[5]+d*Coe[6]));
                     end;
                   4:begin
                      wx:=xw*d;
                      x:=xs+wx;
                      y:=ys+wx*(Coe[1]+wx*(Coe[2]+wx*Coe[3]));
                     end;
                 5,6:begin
                      x:=Coe[1]+d*(Coe[2]+d*(Coe[3]+d*Coe[4]));
                      y:=Coe[5]+d*(Coe[6]+d*(Coe[7]+d*Coe[8]));
                     end;
               end;
               LineOut(x,y);
            end;
            Curve:=True;
        end;

        procedure CurveLSQ;
	var x,y,x0,y0,x1,d,wd,a,b:Real;
            cond,cond0,Linef:Boolean;
	begin
	   wd:=ResX/Abs(Maxx0-Minx0);
           cond0:=False;
           Linef:=False;
           d:=0;
           While d<1 do begin
               if KeyCheck then Exit;
               x:=Minx0+(Maxx0-Minx0)*d;
               x1:=x;
               cond:=ConvData(False,ScTypex,x1);
               cond:=cond and LeastFn(x1,y);
               cond:=cond and ConvData(True,ScTypey,y);
               if cond then begin
                   if not cond0 then MoveOut(x,y)
                   else if not Linef then begin
                       a:=(y-y0)/(x-x0);
                       b:=y0-a*x0;
                       Linef:=True;
                   end else begin
                       if Abs(a*x+b-y)>=ResY then begin
                           LineOut(x0,y0);
                           a:=(y-y0)/(x-x0);
                           b:=y0-a*x0;
                       end;
                   end;
                   x0:=x;
                   y0:=y;
               end else if Linef then begin
                   LineOut(x0,y0);
                   Linef:=False;
               end;
               d:=d+wd;
               cond0:=cond;
           end;
           if Linef then LineOut(x0,y0);
	end;

var
    cond:Boolean;
    i,j,Num:integer;
    x0,y0,x1,y1,wd:real;
    BS1,BS2:Array [0..6] of Real;
    BS3,BS4:Array [1..3] of Real;
    PolyPoints:Po;
    Lin:LongInt;
    NAN0,NAN1,NAN,NewData,GetD,Cv:Boolean;

begin
       if DotTyp in [0..6,34..35,42..51] then nSetLineStyle(0,gwidth,gcol,0)
	      	                         else nSetLineStyle(gattr,gwidth,gcol,0);
       if DotTyp in [10,12,15,18,21,24,29,32,38] then nSetFillColor(7)
                                                 else nSetFillColor(gcol);
       ResX:=Abs(MaxX0-MinX0)/SizeX*DGSYS.Resolution;
       ResY:=Abs(MaxY0-MinY0)/SizeY*DGSYS.Resolution;
       dotX:=Abs(MaxX0-MinX0)*Mm2dot(DotSize)/Sizex/2;
       dotY:=(MaxY0-MinY0)*Mm2dot(DotSize)/Sizey/2;
       dottedX:=Abs(MaxX0-MinX0)*Mm2dot(DottedSize)/Sizex;
       dottedY:=Abs(MaxY0-MinY0)*Mm2dot(DottedSize)/Sizey;
       case gattr of
	  1: begin
	       dottype[0]:=1;
	       dottype[1]:=1;
	       dottype[2]:=1;
	       dottype[3]:=1;
             end;
	  2: begin
	       dottype[0]:=3;
	       dottype[1]:=1;
	       dottype[2]:=3;
	       dottype[3]:=1;
             end;
	  3: begin
	       dottype[0]:=3;
	       dottype[1]:=1;
	       dottype[2]:=1;
	       dottype[3]:=1;
	     end;
	  else begin
	       dottype[0]:=0;
	       dottype[1]:=0;
	       dottype[2]:=0;
	       dottype[3]:=0;
          end;
       end;
       case DotTyp of
	  0,1: begin
                 NewData:=True;
                 Repeat
                   GetD:=GetData(x0,y0,Lin,NAN);
                   if KeyCheck then Exit;
                   if GetD and not NAN then begin
                     if NewData then begin
                       NewData:=False;
                       x1:=x0;
                       y1:=y0;
                       MoveOut(x0,y0)
                     end else LineOut(x0,y0);
                   end else begin
                     if (DotTyp=1) and not NewData then LineOut(x1,y1);
                     NewData:=True;
                   end;
                 until not GetD;
               end;

          2,3,4:
               begin
                   Num:=0;
                   Repeat
                     GetD:=GetData(x0,y0,Lin,NAN);
                     if KeyCheck then Exit;
                     if GetD and not NAN and (Num<DGSYS.SPMaximData) then begin
                       spx^[Num]:=x0;
                       spy^[Num]:=y0;
                       Inc(Num);
                     end else if Num>=2 then begin
                         if (Num>=DGSYS.SPMaximData) and GetD and not NAN then ErrorDisp('Warning: Too large Data Size');
                         case DotTyp of
                           2: begin
                                for j:=0 to Num-1 do spz^[j]:=j;
                                cond:=SpLine(spz^,spx^,c1^,c2^,c3^,Num,2,2,0,0);
                                if cond then cond:=SpLine(spz^,spy^,c4^,c5^,c6^,Num,2,2,0,0);
                              end;
                           3: begin
                                if (spx^[Num-1]<>spx^[0]) or (spy^[Num-1]<>spy^[0]) then begin
                                  spx^[Num]:=spx^[0];
                                  spy^[Num]:=spy^[0];
                                  Inc(Num);
                                end;
                                for j:=0 to Num-1 do spz^[j]:=j;
                                if Num>=3 then begin
                                  cond:=SpLine(spz^,spx^,c1^,c2^,c3^,Num,3,0,0,0);
                                  if cond then cond:=SpLine(spz^,spy^,c4^,c5^,c6^,Num,3,0,0,0);
                                end else cond:=True;
                              end;
                           4: cond:=SpLine(spx^,spy^,c1^,c2^,c3^,Num,2,2,0,0);
                         end;
                         if not cond then errordisp('Error: SpLine interpolation')
                         else if (DotTyp<>3) or (Num>=3) then begin
                           Curvef:=False;
                           j:=0;
                           Repeat
                             Coe[1]:=c1^[j];
                             Coe[2]:=c2^[j];
                             Coe[3]:=c3^[j];
                             if DotTyp<>4 then begin
                               Coe[4]:=c4^[j];
                               Coe[5]:=c5^[j];
                               Coe[6]:=c6^[j];
                             end;
                             Inc(j);
                           until not Curve(spx^[j-1],spy^[j-1],spx^[j]-spx^[j-1]) or (j>Num-2);
                         end;
                         if GetD and not NAN and (Num>=DGSYS.SPMaximData) then begin
                           if DotTyp=3 then begin
                             spx^[0]:=spx^[Num-2];
                             spy^[0]:=spy^[Num-2];
                           end else begin
                             spx^[0]:=spx^[Num-1];
                             spy^[0]:=spy^[Num-1];
                           end;
                           spx^[1]:=x0;
                           spy^[1]:=y0;
                           Num:=2;
                         end else Num:=0;
                     end else Num:=0;
                   until not GetD;
               end;
            5: begin
                 Repeat
                   Num:=0;
                   Repeat
                     GetD:=GetData(x0,y0,Lin,NAN);
                     if KeyCheck then Exit;
                     if GetD and not NAN and (Num<7) then begin
                       BS1[Num]:=x0;
                       BS2[Num]:=y0;
                       Inc(Num);
                     end;
                   until not GetD or NAN or (Num>=7);
                   if Num>=7 then begin
                     Cv:=False;
                     Curvef:=False;
                     i:=0;
                     Repeat
                       BSpLine(i+1,BS1[i],Coe[1]);
                       BSpLine(i+1,BS2[i],Coe[5]);
                       Inc(i);
                       Cv:=Curve(Coe[1],Coe[5],0);
                     until not Cv or (i>1);
                     if Cv then begin
                       Repeat
                         GetD:=GetData(x0,y0,Lin,NAN);
                         if KeyCheck then Exit;
                         if GetD and not NAN then begin
                           for i:=1 to 6 do begin
                               BS1[i-1]:=BS1[i];
                               BS2[i-1]:=BS2[i];
                           end;
                           BS1[6]:=x0;
                           BS2[6]:=y0;
                           BSpLine(0,BS1[1],Coe[1]);
                           BSpLine(0,BS2[1],Coe[5]);
                           Cv:=Curve(Coe[1],Coe[5],0);
                         end;
                       until not GetD or NAN or not Cv;
                       if Cv then begin
                         i:=0;
                         Repeat
                           BSpLine(i+3,BS1[i+2],Coe[1]);
                           BSpLine(i+3,BS2[i+2],Coe[5]);
                           Inc(i);
                         until not Curve(Coe[1],Coe[5],0) or (i>1);
                       end;
                     end;
                   end;
                 until not GetD;
               end;

            6: begin
                 Repeat
                   Num:=1;
                   Repeat
                     GetD:=GetData(x0,y0,Lin,NAN);
                     if KeyCheck then Exit;
                     if GetD and not NAN and (Num<4) then begin
                       BS1[Num]:=x0;
                       BS2[Num]:=y0;
                       BS3[Num]:=x0;
                       BS4[Num]:=y0;
                       Inc(Num);
                     end;
                   until not GetD or NAN or (Num>=4);
                   if Num>=4 then begin
                     Cv:=False;
                     Curvef:=False;
                     Repeat
                       GetD:=GetData(x0,y0,Lin,NAN);
                       if KeyCheck then Exit;
                       if GetD and not NAN then begin
                           for i:=1 to 3 do begin
                             BS1[i-1]:=BS1[i];
                             BS2[i-1]:=BS2[i];
                           end;
                           BS1[3]:=x0;
                           BS2[3]:=y0;
                           BSpLine(0,BS1[0],Coe[1]);
                           BSpLine(0,BS2[0],Coe[5]);
                           Cv:=Curve(Coe[1],Coe[5],0);
                       end;
                     until not GetD or NAN or not Cv;
                     if Cv then begin
                       i:=0;
                       Repeat
                         BS1[4+i]:=BS3[1+i];
                         BS2[4+i]:=BS4[1+i];
                         BSpLine(0,BS1[i+1],Coe[1]);
                         BSpLine(0,BS2[i+1],Coe[5]);
                         Inc(i);
                       until not Curve(Coe[1],Coe[5],0) or (i>2);
                     end;
                   end;
                 until not GetD;
               end;

        34: begin
              NAN:=True;
              if not GetData(x0,y0,Lin,NAN0) then Exit;
              Repeat
                cond:=GetData(x1,y1,Lin,NAN1);
                if not cond then NAN1:=True;
                if KeyCheck then Exit;
                if not NAN0 and not NAN1 then begin
                    wd:=(y1-y0)*0.5;
                    if NAN then begin
                        MoveOut(0,y0-wd);
                        LineOut(x0,y0-wd);
                    end;
                    LineOut(x0,y0+wd);
                    LineOut(x1,y0+wd);
                end else if not NAN0 and NAN1 then begin
                    if not NAN then begin
                        LineOut(x0,y0+wd);
                        LineOut(0,y0+wd);
                    end;
                end;
                x0:=x1;
                y0:=y1;
                NAN:=NAN0;
                NAN0:=NAN1;
              until not cond;
            end;

        35: begin
              NAN:=True;
              if not GetData(x0,y0,Lin,NAN0) then Exit;
              Repeat
                cond:=GetData(x1,y1,Lin,NAN1);
                if not cond then NAN1:=True;
                if KeyCheck then Exit;
                if not NAN0 and not NAN1 then begin
                    wd:=(x1-x0)*0.5;
                    if NAN then begin
                        MoveOut(x0-wd,0);
                        LineOut(x0-wd,y0);
                    end;
                    LineOut(x0+wd,y0);
                    LineOut(x0+wd,y1);
                end else if not NAN0 and NAN1 then begin
                    if not NAN then begin
                        LineOut(x0+wd,y0);
                        LineOut(x0+wd,0);
                    end;
                end;
                x0:=x1;
                y0:=y1;
                NAN:=NAN0;
                NAN0:=NAN1;
              until not cond;
            end;

    36..39: While GetData(x0,y0,Lin,NAN0) do
		  if GetData(x1,y1,Lin,NAN1) then begin
  		    if KeyCheck then Exit;
                    if not NAN0 and not NAN1 then begin
			if DotTyp=36 then nLine(x0,y0,x1,y1)
                        else if DotTyp=37 then nRectAngle(x0,y0,x1,y1,True)
                        else if DotTyp=38 then begin
                            nRectAngle(x0,y0,x1,y1,True);
                            nRectAngle(x0,y0,x1,y1,False);
                        end else if DotTyp=39 then nRectAngle(x0,y0,x1,y1,False);
                    end;
		  end;

	40: While GetData(x0,y0,Lin,NAN0) do
		  if GetData(x1,y1,Lin,NAN1) then begin
		    if KeyCheck then Exit;
                    if not NAN0 and not NAN1 then begin
 		        nLine(x0,y0,x1,y1);
                        nLine(x0-dotX,y0,x0+dotX,y0);
                        nLine(x1-dotX,y1,x1+dotX,y1);
                     end;
		  end;
	41: While GetData(x0,y0,Lin,NAN0) do
		  if GetData(x1,y1,Lin,NAN1) then begin
		    if KeyCheck then Exit;
                    if not NAN0 and not NAN1 then begin
                        nLine(x0,y0,x1,y1);
                        nLine(x0,y0-dotY,x0,y0+dotY);
                        nLine(x1,y1-dotY,x1,y1+dotY);
                    end;
		  end;

    42..50: begin
             LSQPar.Typ:=DotTyp-42;
	     LeastSqr(LMode,xp,yp);
	     if KeyCheck then Exit;
	     if LSQPar.ExitCode=0 then Exit
	     else if LSQPar.ExitCode<0 then begin
		  DataNum:=-1;
		  Exit;
	     end else if (LSQPar.Typ=0) and (ScTypex<>1) and (ScTypey<>1) then begin
                  MoveOut(Minx0,LSQPar.Coe[2]*Minx0+LSQPar.Coe[1]);
                  LineOut(Maxx0,LSQPar.Coe[2]*Maxx0+LSQPar.Coe[1]);
	     end else CurveLSQ;
             if DGSYS.Device=0 then begin
                 LSQDispFirst;
                 LSQDispNext(0);
                 Verify(1,THeight,HitAny);
                 CloseWindow;
             end;
           end;

       51: begin
             LSQPar.Typ:=9;
	     LeastSqr(LMode,xp,yp);
	     if KeyCheck then begin
                 CloseWindow;
                 Exit;
             end;
	     if LSQPar.ExitCode<0 then begin
		  DataNum:=-1;
		  Exit;
	     end else CurveLSQ;
             if DGSYS.Device=0 then Verify(1,THeight,HitAny);
             CloseWindow;
           end;

	else
	   While GetData(x0,y0,Lin,NAN) do begin
	     if KeyCheck then Exit;
             if not NAN then begin
		 case DotTyp of
		    7 : nPutPixel(x0,y0);
		    8 : nCircle(x0,y0,dotx/1.4142135623731,True);
		    9 : nCircle(x0,y0,dotx,True);
		   10 : begin
                          nCircle(x0,y0,dotx,True);
                          nCircle(x0,y0,dotx,False);
                        end;
		   11 : nCircle(x0,y0,dotx,False);
                   12 : begin
                          nCircle(x0,y0,dotx,True);
                          nCircle(x0,y0,dotx,False);
                          nCircle(x0,y0,dotx/1.4142135623731,False);
                        end;
                   13 : begin
                          nCircle(x0,y0,dotx,False);
                          nCircle(x0,y0,dotx/1.4142135623731,False);
                        end;
		   14 : nSquare(X0-dotx,Y0-dotY,X0+dotX,Y0+dotY,True);
		   15 : begin
                          nSquare(X0-dotx,Y0-dotY,X0+dotX,Y0+dotY,True);
                          nSquare(X0-dotx,Y0-dotY,X0+dotX,Y0+dotY,False);
                        end;
		   16 : nSquare(X0-dotx,Y0-dotY,X0+dotX,Y0+dotY,False);
 	     17,18,19 : begin
			  PolyPoints[1].x:=x0;                      PolyPoints[1].y:=y0+dotY*1.4142135623731;
			  PolyPoints[2].x:=x0+dotx*1.4142135623731; PolyPoints[2].y:=y0;
			  PolyPoints[3].x:=x0;                      PolyPoints[3].y:=y0-dotY*1.4142135623731;
			  PolyPoints[4].x:=x0-dotx*1.4142135623731; PolyPoints[4].y:=y0;
			  PolyPoints[5].x:=x0;                      PolyPoints[5].y:=y0+dotY*1.41421;
			  PolyPoints[6].x:=x0;                      PolyPoints[6].y:=y0;
                          if DotTyp=17 then nDrawPoly(5,PolyPoints,True)
			  else if DotTyp=18 then begin
                              nDrawPoly(5,PolyPoints,True);
                              nDrawPoly(5,PolyPoints,False);
                          end else nDrawPoly(5,PolyPoints,False);
			end;
	     20,21,22 : begin
			  PolyPoints[1].x:=x0;       PolyPoints[1].y:=y0+dotY*1.15470;
			  PolyPoints[2].x:=x0-dotx;  PolyPoints[2].y:=y0-dotY*0.57735;
			  PolyPoints[3].x:=x0+dotx;  PolyPoints[3].y:=y0-dotY*0.57735;
			  PolyPoints[4].x:=x0;       PolyPoints[4].y:=y0+dotY*1.15470;
			  PolyPoints[5].x:=x0;       PolyPoints[5].y:=y0;
			  if DotTyp=20 then nDrawPoly(4,PolyPoints,True)
			  else if DotTyp=21 then begin
                              nDrawPoly(4,PolyPoints,True);
                              nDrawPoly(4,PolyPoints,False);
                          end else nDrawPoly(4,PolyPoints,False);
			end;
             23,24,25 : begin
			  PolyPoints[1].x:=x0;       PolyPoints[1].y:=y0-dotY*1.15470;
			  PolyPoints[2].x:=x0-dotx;  PolyPoints[2].y:=y0+dotY*0.57735;
			  PolyPoints[3].x:=x0+dotx;  PolyPoints[3].y:=y0+dotY*0.57735;
			  PolyPoints[4].x:=x0;       PolyPoints[4].y:=y0-dotY*1.15470;
			  PolyPoints[5].x:=x0;       PolyPoints[5].y:=y0;
			  if DotTyp=23 then nDrawPoly(4,PolyPoints,True)
			  else if DotTyp=24 then begin
                              nDrawPoly(4,PolyPoints,True);
                              nDrawPoly(4,PolyPoints,False);
                          end else nDrawPoly(4,PolyPoints,False);
			end;
		   26 : begin
			 nMarkLine(X0-dotX,Y0,X0+dotX,Y0);
			 nMarkLine(X0,Y0-dotY,X0,Y0+dotY);
			end;
		   27 : begin
			 nMarkLine(X0-dotX*0.7071,Y0-dotY*0.7071,X0+dotX*0.7071,Y0+dotY*0.7071);
			 nMarkLine(X0+dotX*0.7071,Y0-dotY*0.7071,X0-dotX*0.7071,Y0+dotY*0.7071)
			end;
		   28 : nRectAngle(x0-dotX,0,x0+dotX,y0,True);
                   29 : begin
                            nRectAngle(x0-dotX,0,x0+dotX,y0,True);
                            nRectAngle(x0-dotX,0,x0+dotX,y0,False);
                        end;
                   30 : nRectAngle(x0-dotX,0,x0+dotX,y0,False);
		   31 : nRectAngle(0,y0-dotY,x0,y0+dotY,True);
                   32 : begin
                            nRectAngle(0,y0-dotY,x0,y0+dotY,True);
                            nRectAngle(0,y0-dotY,x0,y0+dotY,False);
                        end;
                   33: nRectAngle(0,y0-dotY,x0,y0+dotY,False);
		 end;
	      end;
          end;
	end;
end;

end.
