(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* C̑̕`葱 *)

unit GDraw;

interface

uses Crt,DOSCALL,PullMenu,Math,Gra2Crt,GraGraph,Variable,Data,DataScal,Display,
     DotDraw,GRAMerge,IOProc,ChildExe;

Type Real=Double;

procedure AxisOut(Var AxisP:AxisParType);
procedure CommentPosition(No:Integer;var x,y:Integer);
procedure CommentPosition2(No:Integer;x,y:Integer);
procedure CommentOut(Clear:Boolean;Fst:Integer;OutSet:ByteSet);
procedure RemarkOut(Clear:Boolean;Fst:Integer;OutSet:ByteSet);
procedure ArrowOut(Clear:Boolean;OutSet:ByteSet);
procedure DotOut(Clear:Boolean;OutSet:ByteSet);
procedure PlotOut(OutSet:ByteSet;Var AxisP:AxisParType);
procedure MergeIn;
function  Draw(Fst:Integer;OutSet:ByteSet;Wait:Boolean):Boolean;

implementation

const
    NORMAL  =0;
    LOGSMALL=1;
    LOGNORM =2;
    LOGBIG  =3;
    INVERSE =4;

var AxisNo,AxisType:Integer;
    PosSt,PosEd,AMin,AMax,ASc:Real;
    PosL,PosM,DPosL,DPosM,DPosS:Real;
    CountS,CountM,CountSEnd,CountMEnd,CountNum:Integer;
    AxisPosx,AxisPosy:Integer;
    AxisPP:^AxisParBody;

var NumW1,NumW2:Integer;
    NumPosx,NumPosy,NumPosy0:Integer;
    NumStart,NumEnd,NumStep,NumCount,NumCount2:Integer;
    NumCon:Boolean;
    NumNorm:Real;
    NumNormStr:String;
procedure GetAxisPositionIni(Axis:Integer;Var AxisP:AxisParType);
var D,code,i:Integer;
    min1,max1,sc1:Real;
begin
  AxisPP:=@AxisP[Axis];
  min1:=AxisPP^.Min;
  max1:=AxisPP^.Max;
  sc1:=AxisPP^.Scale;
  AxisNo:=Axis;
  With AxisPP^ do begin
    if ScType=1 then begin
        if Abs(sc1)=1 then AxisType:=LOGNORM
        else if sc1=0 then begin
            AxisType:=LOGSMALL;
            sc1:=1
        end else AxisType:=LOGBIG;
    end else if (min1*max1>0) and (ScType=2) then begin
         AxisType:=INVERSE;
         min1:=1/min1;
         max1:=1/max1;
         sc1:=1/sc1;
    end else AxisType:=NORMAL;
    if max1<min1 then sc1:=-sc1;
  end;
  AMin:=min1;
  AMax:=max1;
  ASc:=sc1;
  if AxisType<>INVERSE then begin
       PosSt:=Amin+(Amax-Amin)*AxisPP^.ScPosS/10000;
       PosEd:=Amin+(Amax-Amin)*AxisPP^.ScPosE/10000;
  end else begin
       PosSt:=1/(1/Amin+(1/Amax-1/Amin)*AxisPP^.ScPosS/10000);
       PosEd:=1/(1/Amin+(1/Amax-1/Amin)*AxisPP^.ScPosE/10000);
  end;
end;

procedure GetAxisPositionFirst;
var D,code,i:Integer;
    min,max,sc:Real;
begin
    if AxisType in [NORMAL,LOGBIG] then begin
         if AxisPP^.ScDiv[1]='A' then begin
           if NGRAPH.GraphTyp<>0 then begin
               if CountNum<=2 then CountSEnd:=10
               else if CountNum<=3 then CountSEnd:=5
               else if CountNum<=6 then CountSEnd:=2
               else CountSEnd:=1;
           end else begin
               if CountNum<=6 then CountSEnd:=10
               else if CountNum<=11 then CountSEnd:=5
               else if CountNum<=21 then CountSEnd:=2
               else CountSEnd:=1;
           end;
         end else begin
             Val(AxisPP^.ScDiv,D,code);
             CountSEnd:=D;
         end;
         DPosL:=Asc*10;
         PosL:=MainMin(PosSt,DPosL)-DPosL;
         DPosM:=Asc;
         PosM:=MainMin(PosSt,DPosM)-DPosM;
         CountMEnd:=10;
         CountM:=Round((MainMin(PosSt,DPosM)-PosL)/DPosM);
         DPosS:=DPosM/CountSEnd;
         CountS:=1;
    end else if AxisType=INVERSE then begin
         if (Amax>Amin) and (Amin>0) or (Amax<Amin) and (Amin<0) then begin
             max:=Amin;
             min:=Amax;
             sc:=Asc*-1;
         end else begin
             min:=Amin;
             max:=Amax;
             sc:=Asc;
         end;
         DPosM:=sc;
         PosM:=MainMin(min,DPosM)-DPosM;
         CountMEnd:=Trunc((max-PosM)/DPosM);
         CountM:=1;
         DPosL:=DPosM*CountMEnd;
         PosL:=PosM;
         if AxisPP^.ScDiv[1]='A' then begin
           if NGRAPH.GraphTyp<>0 then begin
               if CountNum<=2 then CountSEnd:=10
               else if CountNum<=3 then CountSEnd:=5
               else if CountNum<=6 then CountSEnd:=2
               else CountSEnd:=1;
           end else begin
               if CountNum<=6 then CountSEnd:=10
               else if CountNum<=11 then CountSEnd:=5
               else if CountNum<=21 then CountSEnd:=2
               else CountSEnd:=1;
           end;
         end else begin
             Val(AxisPP^.ScDiv,D,code);
             CountSEnd:=D;
         end;
         DPosS:=DPosM/CountSEnd;
         CountS:=1;
    end else if AxisType=LOGNORM then begin
         DPosL:=Asc*10;
         PosL:=MainMin(PosSt,DPosL)-DPosL;
         DPosM:=Asc;
         PosM:=MainMin(PosSt,DPosM)-DPosM;
         CountMEnd:=10;
         CountM:=Round((MainMin(PosSt,DPosM)-PosL)/DPosM);
         CountSEnd:=9;
         if DPosM>0 then DPosS:=1
                    else DPosS:=-0.1;
         CountS:=1;
    end else if AxisType=LOGSMALL then begin
         DPosL:=Asc;
         PosL:=MainMin(PosSt,DPosL)-DPosL;
         if DPosL>0 then DPosM:=1
                    else DPosM:=-0.1;
         PosM:=PosL;
         CountMEnd:=9;
         CountM:=1;
         if AxisPP^.ScDiv[1]='A' then begin
           if NGRAPH.GraphTyp<>0 then begin
               if CountNum<=2 then CountSEnd:=10
               else if CountNum<=3 then CountSEnd:=5
               else if CountNum<=6 then CountSEnd:=2
               else CountSEnd:=1;
           end else begin
               if CountNum<=6 then CountSEnd:=10
               else if CountNum<=11 then CountSEnd:=5
               else if CountNum<=21 then CountSEnd:=2
               else CountSEnd:=1;
           end;
         end else begin
             Val(AxisPP^.ScDiv,D,code);
             CountSEnd:=D;
         end;
         DPosS:=1/CountSEnd;
         CountS:=1;
    end;
end;

function GetAxisPosition(var Pos:Real;var x,y:Integer):Integer;
var a:Real;
    gx1,gy1,gx2,gy2,gsizex,gsizey:Integer;
begin
    if CountS>=CountSEnd then begin
        if AxisType in [NORMAL,INVERSE,LOGNORM,LOGBIG] then Pos:=PosM+DPosM
        else if AxisType=LOGSMALL then Pos:=PosL+Log(1+CountM*DPosM);
        PosM:=Pos;
        CountS:=1;
        GetAxisPosition:=2;
        if CountM=CountMEnd then begin
            Pos:=PosL+DPosL;
            PosL:=Pos;
            CountM:=1;
            GetAxisPosition:=3;
            if (AxisType=INVERSE) then begin
                if (DPosM>=0) and (Amin>=0) or (DPosM<0) and (Amin<0) then begin
                    DPosL:=DPosL*10;
                    DPosM:=DPosM*10;
                    DPosS:=DPosS*10;
                end else begin
                    DPosL:=DPosL/10;
                    DPosM:=DPosM/10;
                    DPosS:=DPosS/10;
                end;
                CountMEnd:=-1;
            end;
        end else Inc(CountM);
    end else begin
        GetAxisPosition:=1;
        if AxisType in [NORMAL,INVERSE,LOGBIG] then Pos:=PosM+CountS*DPosS
        else if AxisType=LOGNORM then Pos:=PosM+Log(1+CountS*DPosS)
        else if AxisType=LOGSMALL then Pos:=Log(Pow10(PosM)+CountS*DPosS*Pow10(PosL)*DPosM);
        Inc(CountS);
    end;
    if ABS(Pos/DPosS)<1E-14 then Pos:=0;
    if (Pos-PosSt)*(Pos-PosEd)>0 then begin
        if (DPosM>=0) and ((PosSt<=PosEd) and (Pos<PosSt) or (PosSt>=PosEd) and (Pos<PosEd))
        or (DPosM<=0) and ((PosSt<=PosEd) and (Pos>PosEd) or (PosSt>=PosEd) and (Pos>PosSt)) then begin
            GetAxisPosition:=-1;
        end else begin
            GetAxisPosition:=-2;
        end;
        exit;
    end;
    if AxisType<>INVERSE then a:=(Pos-AMin)/(AMax-AMin)
                         else a:=(1/Pos-1/AMin)/(1/AMax-1/AMin);
    nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
    case AxisNo of
      0,2: begin
             x:=gx1+Round(a*gSizex);
             y:=AxisPosy;
           end;
      1,3: begin
             x:=AxisPosx;
             y:=gy2-Round(a*gSizey);
           end;
    end;
end;

procedure GetNumStrFirst;
var  i,N,code:Integer;
     S,S2:String;
     SetNumNorm:Boolean;
begin
  With AxisPP^ do begin
    NumW1:=Ord(ScFig[1])-Ord('0');
    NumW2:=Ord(ScFig[3])-Ord('0');
    NumPosx:=Mm2dot(ScPosx);
    NumPosy:=Mm2dot(ScPosy);
    SetNumNorm:=False;
    if AxisType=NORMAL then begin
        if (Abs(DPosM)>=Pow10(NumW1))
        or (Abs(DPosM)<Pow10(-NumW2)) then begin
          NumNorm:=Abs(DPosM);
          SetNumNorm:=True;
        end else NumNorm:=1;
    end else NumNorm:=1;
    if SetNumNorm then begin
      if NumNorm/DATASCAL.Scale(NumNorm)<>1 then begin
        Str(NumNorm/DATASCAL.Scale(NumNorm):NumW1:NumW2,S);
        i:=1;
        While S[i]=' ' do Inc(i);
        S:=Copy(S,i,Length(S)-i+1);
        if (ScZero[1]='N') and (Pos('.',S)<>0) then begin
          i:=Length(S);
          While S[i]='0' do Dec(i);
          if S[i]='.' then Dec(i);
          S:=Copy(S,1,i);
        end;
        if ((ScPer[1]='Y') or (ScLR=0)) and (Pos('.',S)=0) then S:=S+'.';
      end else S:='';
      Str(Round(Log(DATASCAL.Scale(NumNorm))),S2);
      NumNormStr:='['+S+'x10^'+S2+'@]';
    end else NumNormStr:='';
    if AxisType in [NORMAL,LOGNORM,LOGBIG] then begin
        if ScStep[1]='A' then begin
            if CountNum=0 then N:=1
                          else N:=Round(Pow10(Trunc(Log(CountNum/2))));
            if CountNum>=10*N then NumStep:=5*N
            else if CountNum>=5*N then NumStep:=2*N
            else NumStep:=N;
        end else Val(ScStep,NumStep,code);
        if ScStart[1]='A' then
            NumStart:=Round(Abs((Mainmin(PosSt,DPosL)-Mainmin(PosSt,DPosM))/DPosM)) mod NumStep+1
        else Val(ScStart,NumStart,code);
    end else if AxisType=INVERSE then begin
        if ScStep[1]='A' then begin
            if CountNum=0 then N:=1
                          else N:=Round(Pow10(Trunc(Log(CountNum/2))));
            if CountNum>=10*N then NumStep:=5*N
            else if CountNum>=5*N then NumStep:=2*N
            else NumStep:=N;
        end else Val(ScStep,NumStep,code);
        if ScStart[1]='A' then
            NumStart:=CountMEnd mod NumStep
        else Val(ScStart,NumStart,code);
    end else if AxisType=LOGSMALL then begin
        if ScStep[1]='A' then begin
            NumStep:=1;
        end else Val(ScStep,NumStep,code);
        if ScStart[1]='A' then NumStart:=1
        else Val(ScStart,NumStart,code);
    end;
    if ScNum[1]='A' then NumEnd:=-1
    else Val(ScNum,NumEnd,code);
    NumCount:=0;
    NumCount2:=0;
  end;
end;

function GetNumStr(x:Real;var NumStr:String):Boolean;
var S:String;
    i:Integer;
begin
  With AxisPP^ do begin
    Inc(NumCount);
    GetNumStr:=False;
    if (NumEnd>=0) and (NumCount2>=NumEnd) then exit;
    if (NumCount<NumStart) or (((NumCount-NumStart) mod NumStep)<>0) then exit;
    GetNumStr:=True;
    Inc(NumCount2);
    if (AxisType=LOGSMALL) or ((AxisType in [LOGNORM,LOGBIG]) and (ScLog=0)) then x:=Pow10(x);
    Str(x/NumNorm:NumW1:NumW2,S);
    i:=1;
    While S[i]=' ' do Inc(i);
    S:=Copy(S,i,Length(S)-i+1);
    if (ScZero[1]='N') and (Pos('.',S)<>0) then begin
        i:=Length(S);
        While S[i]='0' do Dec(i);
        if S[i]='.' then Dec(i);
        S:=Copy(S,1,i);
    end;
    if ((ScPer[1]='Y') or (ScLR=0)) and (Pos('.',S)=0) then S:=S+'.';
    if (ScPlus[1]='Y') then begin
        if (x/NumNorm>0) then S:='+'+S;
    end;
    if (AxisType in [LOGNORM,LOGBIG]) and (ScLog=1) then S:='10^'+S;
    NumStr:=S;
  end;
end;

procedure SetAxis;
var x1,y1,x2,y2,Rcode,Count,i:Integer;
    rx,st,ed:Real;
    ALen:array [1..3] of Integer;
    gx1,gy1,gx2,gy2,gsizex,gsizey:Integer;
begin
  nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
  if NGRAPH.GraphTyp=0 then begin
      if AxisNo in [0,2] then for i:=1 to 3 do ALen[i]:=gSizey
                         else for i:=1 to 3 do ALen[i]:=gSizex;
  end else for i:=1 to 3 do ALen[i]:=Round(AxisPP^.LLen[i]/2100.0*PaperSize);
  GetAxisPositionFirst;
  if (AxisPP^.Scdir<>3) and (not ((AxisNo in [2,3]) and (NGRAPH.GraphTyp=0))) then begin
      if NGRAPH.GraphTyp<>0 then begin
          nSetLineStyle(AxisPP^.Lattr[4],AxisPP^.Lwidth[4],AxisPP^.Lcol[4],0);
      end;
      Repeat
        Rcode:=GetAxisPosition(rx,x1,y1);
        if Rcode>=0 then begin
          if (NGRAPH.GraphTyp<>0) or
          not (  ((AxisNo in [0,2]) and ((x1=gx1) or (x1=gx2))) or
                 ((AxisNo in [1,3]) and ((y1=gy1) or (y1=gy2))) )   then begin
              if NGRAPH.GraphTyp=0 then begin
                  nSetLineStyle(AxisPP^.Lattr[Rcode],AxisPP^.Lwidth[Rcode],AxisPP^.Lcol[Rcode],0);
              end;
              x2:=x1;
              y2:=y1;
              if (NGRAPH.GraphTyp=0) or (AxisPP^.ScDir in [0,2]) then
                  case AxisNo of
                    0: y2:=y2-ALen[Rcode];
                    1: x2:=x2+ALen[Rcode];
                    2: y2:=y2+ALen[Rcode];
                    3: x2:=x2-ALen[Rcode];
                  end;
              if (NGRAPH.GraphTyp<>0) and (AxisPP^.ScDir in [1,2]) then
                  case AxisNo of
                    0: y1:=y1+ALen[Rcode];
                    1: x1:=x1-ALen[Rcode];
                    2: y1:=y1-ALen[Rcode];
                    3: x1:=x1+ALen[Rcode];
                  end;
              nLine2(x1,y1,x2,y2);
          end;
        end;
      until Rcode=-2;
  end;
  nSetLineStyle(AxisPP^.Lattr[0],AxisPP^.Lwidth[0],AxisPP^.Lcol[0],2);
  if AxisPP^.ScFull[1]='Y' then
      case AxisNo of
        0,2: nLine2(gx1,AxisPosy,gx2,AxisPosy);
        1,3: nLine2(AxisPosx,gy2,AxisPosx,gy1);
      end
  else begin
      if AxisType<>INVERSE then begin
          st:=(PosSt-AMin)/(AMax-AMin);
          ed:=(PosEd-AMin)/(AMax-AMin);
      end else begin
          st:=(1/PosSt-1/AMin)/(1/AMax-1/AMin);
          ed:=(1/PosEd-1/AMin)/(1/AMax-1/AMin);
      end;
      case AxisNo of
        0,2: nLine2(gx1+Round(gsizex*st),AxisPosy,gx1+Round(gsizex*ed),AxisPosy);
        1,3: nLine2(AxisPosx,gy2-Round(gsizey*st),AxisPosx,gy2-Round(gsizey*ed));
      end;
  end;
end;

procedure SetNumber;
var Posx,Posy,Rcode:Integer;
    H1,W1,H2,W2,H3,W3,a:Integer;
    NumLenMax,NumLenMax2,NumLenMax3:Integer;
    rx:Real;
    S,S2:String;
    gx1,gy1,gx2,gy2,gsizex,gsizey:Integer;
begin
  nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
  GetAxisPositionFirst;
  GetNumStrFirst;
  if NumEnd=0 then exit;
  NumLenMax:=0;
  NumLenMax2:=0;
  NumLenMax3:=0;
  if AxisNo in [1,3] then
      Repeat
        Rcode:=GetAxisPosition(rx,Posx,Posy);
        if Rcode>=0 then begin
          if (Rcode in [2,3]) and GetNumStr(rx,S) then begin
              nTextSize(H1,W1,S,NGRAPH.Aattr[3+AxisNo],NGRAPH.ASattr[3+AxisNo],0);
              if NumLenMax<W1 then NumLenMax:=W1;
              a:=Pos('.',S);
              if a<>0 then begin
                  S2:=Copy(S,a,Length(S)-a+1);
                  nTextSize(H1,W1,S2,NGRAPH.Aattr[3+AxisNo],NGRAPH.ASattr[3+AxisNo],0);
                  if NumLenMax2<W1 then NumLenMax2:=W1;
              end;
              if a<>0 then S2:=Copy(S,1,Pos('.',S)-1);
              nTextSize(H1,W1,S2,NGRAPH.Aattr[3+AxisNo],NGRAPH.ASattr[3+AxisNo],0);
              if NumLenMax3<W1 then NumLenMax3:=W1;
          end;
        end;
      until Rcode=-2;
  nTextSize(H3,W3,'.',NGRAPH.Aattr[3+AxisNo],NGRAPH.ASattr[3+AxisNo],0);
  GetAxisPositionFirst;
  GetNumStrFirst;
  Repeat
    Rcode:=GetAxisPosition(rx,Posx,Posy);
    if Rcode>=0 then begin
      if (Rcode in [2,3]) and GetNumStr(rx,S) then begin
          nTextSize(H1,W1,S,NGRAPH.Aattr[3+AxisNo],NGRAPH.ASattr[3+AxisNo],0);
          if Pos('.',S)<>0 then S2:=Copy(S,1,Pos('.',S)-1)
                           else S2:=S;
          nTextSize(H2,W2,S2,NGRAPH.Aattr[3+AxisNo],NGRAPH.ASattr[3+AxisNo],0);
          if not ((AxisNo=0) and (rx=0) and (Posx=AxisPosx) and ((AxisPosy<>gy2) or (AxisPosx=gx1)))
             and not ((AxisNo=1) and (rx=0) and (Posy=AxisPosy) and ((AxisPosy=gy2) and (AxisPosx<>gx1)))
              or (not NumCon) then begin
              if (AxisNo=1) and (rx=0) and (Posy=AxisPosy) and not ((AxisPosx<>gx1) xor (AxisPosy<>gy2))
              and (NumCon) then begin
                  Inc(Posy,H1 div 2+NumPosy0);
              end;
              Inc(Posx,NumPosx);
              Inc(Posy,NumPosy);
              case AxisNo of
                  0: Inc(Posy,H1);
                  2: ;
                1,3: Inc(Posy,H1 div 2);
              end;
              case AxisNo of
                0,2: case AxisPP^.ScLR of
                       0: Inc(Posx,-W2-W3 div 2);
                       1: ;
                       2: Inc(Posx,-W1 div 2);
                       3: Inc(Posx,-W1);
                     end;
                  1: case AxisPP^.ScLR of
                       0: Inc(Posx,-NumLenMax2-W2);
                       1: Inc(Posx,-W1);
                       2: Inc(Posx,-NumLenMax div 2-W1 div 2);
                       3: Inc(Posx,-NumLenMax);
                     end;
                  3: case AxisPP^.ScLR of
                       0: Inc(Posx,NumLenMax3-W2);
                       1: Inc(Posx,NumLenMax-W1);
                       2: Inc(Posx,NumLenMax div 2-W1 div 2);
                       3: ;
                     end;
              end;
              nMoveTo2(Posx,Posy);
              nOutString(S,NGRAPH.Aattr[3+AxisNo],NGRAPH.ASattr[3+AxisNo],HorizontalDir,False,0);
          end;
      end;
    end;
  until Rcode=-2;
  if NumNormStr<>'' then begin
      nTextSize(H1,W1,NumNormStr,NGRAPH.Aattr[3+AxisNo],NGRAPH.ASattr[3+AxisNo],0);
      case AxisNo of
        0,2: Posx:=gX2-W1;
          1: Posx:=gX1-W1-NumLenMax;
          3: Posx:=gX2+NumLenMax;
      end;
      case AxisNo of
          0: Posy:=gY2+H3+H1;
          2: Posy:=gY1-H3;
        1,3: Posy:=gY1+H1;
      end;
      Inc(Posx,NumPosx);
      Inc(Posy,NumPosy);
      nMoveTo2(Posx,Posy);
      nOutString(NumNormStr,NGRAPH.Aattr[3+AxisNo],NGRAPH.ASattr[3+AxisNo],HorizontalDir,False,0);
  end;
end;

procedure SetAxisPosition(Axis:Integer;Var AxisP:AxisParType);
var i,D,code,Rcode,x1,y1,gx1,gy1,gx2,gy2,gsizex,gsizey,Count,Apos,CountNumS:Integer;
    rx:Real;
begin
  nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
  for i:=0 to 1 do begin
      GetAxisPositionIni(Axis,AxisP);
      if Axis in [0,2] then AxisPosx:=0
                       else AxisPosy:=0;
      PosSt:=AMin;
      PosEd:=AMax;
      CountNum:=100;
      GetAxisPositionFirst;
      Count:=0;
      case Axis of
        0: apos:=gx1;
        1: apos:=gy2;
        2: apos:=gx2;
        3: apos:=gy1;
      end;
      Val(AxisP[Axis].ScCros,D,code);
      Repeat
        Rcode:=GetAxisPosition(rx,x1,y1);
        if (Rcode>0) and (Rcode in [2,3]) then begin
          Inc(Count);
          if NGRAPH.GraphTyp=2 then begin
              if (Count=1)
              or (AxisP[Axis].ScCros[1]='A') and (rx=0)
              or (AxisP[Axis].ScCros[1]<>'A') and (Count=D) then begin
                  if Axis in [0,2] then apos:=x1
                                   else apos:=y1;
              end;
          end;
        end;
      until Rcode=-2;
      if Axis in [0,2] then AxisPosx:=apos
                       else AxisPosy:=apos;
      if i=0 then CountNumS:=Count;
      if Axis in [0,2] then Inc(Axis)
                       else Dec(Axis);
  end;
  CountNum:=CountNumS;
end;

procedure SetNumber00(Var AxisP:AxisParType);
var i,Posx,Posy,Rcode:Integer;
    rx:Real;
    S:String;
    Con1,Con2:Boolean;
begin
  NumCon:=False;
  if NGRAPH.Con00[1]='N' then Exit;
  if (AxisP[0].ScMode[1]<>'Y') or not (AxisP[0].SetMin and AxisP[0].SetMax and AxisP[0].SetScale)
  or (AxisP[1].ScMode[1]<>'Y') or not (AxisP[1].SetMin and AxisP[1].SetMax and AxisP[1].SetScale) then Exit;
  if (AxisP[0].ScType<>AxisP[1].ScType) then Exit;
  SetAxisPosition(0,AxisP);
  GetAxisPositionIni(0,AxisP);
  GetAxisPositionFirst;
  GetNumStrFirst;
  Con1:=False;
  Repeat
    Rcode:=GetAxisPosition(rx,Posx,Posy);
    if Rcode>=0 then begin
      if (Rcode in [2,3]) and GetNumStr(rx,S) then begin
          if (Posx=AxisPosx) and (rx=0) then Con1:=True;
      end;
    end;
  until Rcode=-2;
  SetAxisPosition(1,AxisP);
  GetAxisPositionIni(1,AxisP);
  GetAxisPositionFirst;
  GetNumStrFirst;
  Con2:=False;
  Repeat
    Rcode:=GetAxisPosition(rx,Posx,Posy);
    if Rcode>=0 then begin
      if (Rcode in [2,3]) and GetNumStr(rx,S) then begin
          if (Posy=AxisPosy) and (rx=0) then Con2:=True;
      end;
    end;
  until Rcode=-2;
  if Con1 and Con2 then NumCon:=True;
  NumPosy0:=Mm2dot(AxisP[0].ScPosy);
end;

procedure AxisOut(Var AxisP:AxisParType);
begin
   nResetViewPort;
   nSetWindowFull;
   nResetTextStyle;
   SetNumber00(AxisP);
   nRemark('Scale(X)');
   With AxisP[0] do begin
       if (ScMode[1]='Y') and SetMin and SetMax and SetScale then begin
           SetAxisPosition(0,AxisP);
           GetAxisPositionIni(0,AxisP);
           SetAxis;
           SetNumber;
       end;
   end;
   nRemark('Scale(Y)');
   With AxisP[1] do begin
       if (ScMode[1]='Y') and SetMin and SetMax and SetScale then begin
           SetAxisPosition(1,AxisP);
           GetAxisPositionIni(1,AxisP);
           SetAxis;
           SetNumber;
       end;
   end;
   if NGRAPH.GraphTyp<>2 then begin
       nRemark('Scale(U)');
       With AxisP[2] do begin
           if (ScMode[1]='Y') and SetMin and SetMax and SetScale then begin
               SetAxisPosition(2,AxisP);
               GetAxisPositionIni(2,AxisP);
               SetAxis;
               SetNumber;
           end;
       end;
       nRemark('Scale(R)');
       With AxisP[3] do begin
           if (ScMode[1]='Y') and SetMin and SetMax and SetScale then begin
               SetAxisPosition(3,AxisP);
               GetAxisPositionIni(3,AxisP);
               SetAxis;
               SetNumber;
           end;
       end;
   end;
end;

procedure CommentPosition(No:Integer;var x,y:Integer);
var gx1,gy1,gx2,gy2,gsizex,gsizey:Integer;
begin
   nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
   case No of
     0,4: begin
             x:=Title[No].x+gX1;
             y:=Title[No].y+gY1;
          end;
   1,2,3: begin
             x:=Title[No].x+gX1;
             y:=Title[No].y+gY2;
          end;
       5: begin
             x:=Title[No].x+gX2;
             y:=Title[No].y+gY2;
          end;
   end;
end;

procedure CommentPosition2(No:Integer;x,y:Integer);
var gx1,gy1,gx2,gy2,gsizex,gsizey:Integer;
begin
   nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
   case No of
     0,4: begin
             Title[No].x:=x-gX1;
             Title[No].y:=y-gY1;
          end;
   1,2,3: begin
             Title[No].x:=x-gX1;
             Title[No].y:=y-gY2;
          end;
       5: begin
             Title[No].x:=x-gX2;
             Title[No].y:=y-gY2;
          end;
   end;
end;

procedure CommentOut(Clear:Boolean;Fst:Integer;OutSet:ByteSet);
var x,y,i:Integer;
begin
    nRemark('Legend(Title)');
    nResetViewPort;
    nSetWindowFull;
    for i:=0 to 5 do if i in OutSet then begin
        if KeyCheck then exit;
        if Length(Title[i].Str)<>0 then begin
            CommentPosition(i,x,y);
            nMoveTo2(x,y);
            case i of
              0,1: nOutString(Title[i].Str,NGRAPH.Aattr[0],NGRAPH.ASattr[0],HorizontalDir,Clear,Fst);
              2,4: nOutString(Title[i].Str,NGRAPH.Aattr[1],NGRAPH.ASattr[1],HorizontalDir,Clear,Fst);
              3,5: nOutString(Title[i].Str,NGRAPH.Aattr[1],NGRAPH.ASattr[1],VerticalDir,Clear,Fst);
            end;
        end;
    end;
end;

procedure RemarkOut(Clear:Boolean;Fst:Integer;OutSet:ByteSet);
var x,y,i:Integer;
begin
   nRemark('Legend(String)');
   nResetViewPort;
   nSetWindowFull;
   for i:=1 to 20 do if i in OutSet then begin
      if KeyCheck then exit;
      if Length(Remark[i].Str)<>0 then begin
          nMoveTo2(Remark[i].x,Remark[i].y);
          nOutString(Remark[i].Str,NGRAPH.Aattr[2],NGRAPH.ASattr[2],Remark[i].dir,Clear,Fst);
      end;
   end;
end;

procedure ArrowOut(Clear:Boolean;OutSet:ByteSet);

        procedure ArrowPosition(x0,y0,x1,y1,Len:Real;var Ax1,Ay1,Ax2,Ay2:Integer);
        var ALen,x,y:Real;
        begin
           ALen:=Sqrt(Sqr(x1-x0)+Sqr(y1-y0));
           if ALen=0 then begin
               Ax1:=Round(x1); Ay1:=Round(y1);
               Ax2:=Round(x1); Ay2:=Round(y1);
           end else begin
               x:=x1+Len*(x0-x1)/ALen;
               y:=y1+Len*(y0-y1)/ALen;
               Ax1:=Round(x+Len/2*(y1-y0)/ALen);
               Ay1:=Round(y+Len/2*(x0-x1)/ALen);
               Ax2:=Round(x-Len/2*(y1-y0)/ALen);
               Ay2:=Round(y-Len/2*(x0-x1)/ALen);
           end;
        end;

var C:Integer;
    i,ax1,ay1,ax2,ay2:Integer;
begin
   nRemark('Legend(Arrow)');
   nResetViewPort;
   nSetWindowFull;
   for i:=1 to 20 do if i in OutSet then begin
      if KeyCheck then exit;
      if Arrow[i].Act then
	  with Arrow[i] do begin
	     ArrowPosition(sx,sy,ex,ey,Len,ax1,ay1,ax2,ay2);
	     if Clear then C:=7
		      else C:=Col;
	     nSetLineStyle(Attr,Width,C,0);
	     nLine(sx,sy,ex,ey);
             nMoveTo(ax1,ay1);
	     nLineTo(ex,ey);
	     nLineTo(ax2,ay2);
	  end;
   end;
end;

procedure DotOut(Clear:Boolean;OutSet:ByteSet);
var C,i,j,a:Integer;
begin
    nRemark('Legend(Dot)');
    nResetViewPort;
    nSetWindowAll;
    for j:=1 to 20 do if j in OutSet then begin
      if KeyCheck then exit;
      if Dot[j].ActivNum>0 then
	  with Dot[j] do begin
             if not UseData(ActivNum) then Exit;
             for i:=0 to ActivNum-1 do begin
	         gx^[i]:=x[i];
	         gy^[i]:=y[i];
                 LPos^[i]:=i+1;
                 gStat^[i]:=0;
             end;
             if Typ in [0..3] then a:=Typ
             else if Typ in [4..24] then a:=Typ+3
             else a:=Typ+11;
             if Clear then C:=7
                      else C:=Col;
             dotset(a,0,0,0,Attr,C,Width,0,0,PaperSize,PaperSize,PaperSize,PaperSize,
                    DotSize,DottedSize,0,0);
             CloseData;
	  end;
    end;
end;

procedure PlotOut(OutSet:ByteSet;Var AxisP:AxisParType);
var S:String;
    i,gx1,gy1,gx2,gy2,gsizex,gsizey:Integer;
begin
  for i:=1 to FilePar.Num do if i in OutSet then begin
      if KeyCheck then exit;
      if  AxisP[FilePar.Body[i].Axisx*2].SetMin
      and AxisP[FilePar.Body[i].Axisx*2].SetMax
      and AxisP[FilePar.Body[i].Axisx*2].SetScale
      and AxisP[FilePar.Body[i].Axisy*2+1].SetMin
      and AxisP[FilePar.Body[i].Axisy*2+1].SetMax
      and AxisP[FilePar.Body[i].Axisy*2+1].SetScale then begin
          Fdisp(i,True);
          if OpenData(i) then begin
              nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
              With FilePar.Body[i] do begin
                 nRemark('Data'+'('+MakeFileName2(FilePar.Body[i].Name)+')');
                 nSetViewPort;
                 nSetWindow(AxisP[Axisx*2].Min,AxisP[Axisy*2+1].Min,AxisP[Axisx*2].Max,AxisP[Axisy*2+1].Max);
                 dotset(DotTyp,LeastMode,Lx,Ly,
                        DotAttr,DotCol,DotWidth,AxisP[Axisx*2].Min,AxisP[Axisy*2+1].Min,
                        AxisP[Axisx*2].Max,AxisP[Axisy*2+1].Max,
                        gSizex,gSizey,DotSize,DottedSize,AxisP[Axisx*2].ScType,AxisP[Axisy*2+1].ScType);
              end;
          end;
          CloseData;
          Fdisp(i,False);
      end;
  end;
end;

procedure MergeIn;
var i:Integer;
begin
    for i:=0 to 9 do begin
      if KeyCheck then Exit;
      if (Length(Merge[i].Fil)<>0) and Find(Merge[i].Fil,True) then begin
        if (DGSYS.Device=1) and (FExpand(DGSYS.GraphicFil)=FExpand(Merge[i].Fil)) then
            ErrorDisp('Error: Merge file is same as output GRA-file -> not merged')
        else begin
            nRemark('Merge'+'('+MakeFileName2(Merge[i].Fil)+')');
            MergeInput(i);
        end;
      end;
    end;
end;


function Draw(Fst:Integer;OutSet:ByteSet;Wait:Boolean):Boolean;

    procedure SetAxisScale(SelFile:ByteSet);
    var i,Axis2:integer;
        Num:Array[0..3] of Integer;
        sminx,sminy,smaxx,smaxy:Real;
        min0,max0:Array[0..3] of Real;
        First:Array[0..3] of Boolean;
        UnSet:Boolean;
    begin
      for i:=0 to 3 do Num[i]:=0;
      for i:=1 to FilePar.Num do if i in SelFile then begin
          if FilePar.Body[i].Axisx=0 then Inc(Num[0])
                                     else Inc(Num[2]);
          if FilePar.Body[i].Axisy=0 then Inc(Num[1])
                                     else Inc(Num[3]);
      end;
      UnSet:=False;
      for i:=0 to 3 do With AxisPar[i] do
          if (Num[i]<>0) and (not SetMin or not SetMax) then UnSet:=True;
      if UnSet then begin
          for i:=0 to 3 do First[i]:=True;
          for i:=FilePar.Num downto 1 do if i in SelFile then begin
              GetMinMax(i,sminx,sminy,smaxx,smaxy);
              if FilePar.Body[i].DotNum>0 then begin
                  if FilePar.Body[i].DotTyp in [28..30] then begin
                      if smaxy*sminy>0 then begin
                            if smaxy>0 then sminy:=0
                                       else smaxy:=0;
                      end;
                  end else if FilePar.Body[i].DotTyp in [31..33] then begin
                      if smaxx*sminx>0 then begin
                            if smaxx>0 then sminx:=0
                                       else smaxx:=0;
                      end;
                  end;
                  if FilePar.Body[i].Axisx=0 then begin
                      if First[0] then begin
                          min0[0]:=sminx;
                          max0[0]:=smaxx;
                          First[0]:=False;
                      end else begin
                          if sminx<min0[0] then min0[0]:=sminx;
                          if smaxx>max0[0] then max0[0]:=smaxx;
                      end;
                  end else begin
                      if First[2] then begin
                          min0[2]:=sminx;
                          max0[2]:=smaxx;
                          First[2]:=False;
                      end else begin
                          if sminx<min0[2] then min0[2]:=sminx;
                          if smaxx>max0[2] then max0[2]:=smaxx;
                      end;
                  end;
                  if FilePar.Body[i].Axisy=0 then begin
                      if First[1] then begin
                          min0[1]:=sminy;
                          max0[1]:=smaxy;
                          First[1]:=False;
                      end else begin
                          if sminy<min0[1] then min0[1]:=sminy;
                          if smaxy>max0[1] then max0[1]:=smaxy;
                      end;
                  end else begin
                      if First[3] then begin
                          min0[3]:=sminy;
                          max0[3]:=smaxy;
                          First[3]:=False;
                      end else begin
                          if sminy<min0[3] then min0[3]:=sminy;
                          if smaxy>max0[3] then max0[3]:=smaxy;
                      end;
                  end;
              end;
          end;
          for i:=0 to 3 do With AxisPar[i] do
              if not First[i] and (Num[i]<>0) then begin
                  SetAutoMinMax(ScType,min0[i],max0[i],Min,Max,SetMin,SetMax,ScAuto[1]);
                  SetMin:=True;
                  SetMax:=True;
              end;
      end;
      for i:=0 to 3 do With AxisPar[i] do
          if SetMin and Setmax and (Num[i]<>0) then begin
              SetAutoScale(ScType,Min,Max,Scale,SetScale);
              SetScale:=True;
          end;
      for i:=0 to 3 do AxisPar2^[i]:=AxisPar[i];

      for i:=0 to 3 do With AxisPar2^[i] do
          if not SetMin or not SetMax or not SetScale then begin
              if i in [0,1] then Axis2:=i+2
                            else Axis2:=i-2;
              ScNum:='   0';
              Min:=AxisPar[Axis2].Min;
              Max:=AxisPar[Axis2].Max;
              Scale:=AxisPar[Axis2].Scale;
              SetMin:=AxisPar[Axis2].SetMin;
              SetMax:=AxisPar[Axis2].SetMax;
              SetScale:=AxisPar[Axis2].SetScale;
              ScType:=AxisPar[Axis2].ScType;
          end;
    end;

var i,k,VAFCode:integer;
    Ch:char;
    Error:Boolean;
label exit1,exit2;
begin
   Draw:=False;
   StartGraph;
   ClrScr2;
   FileDisp2;
   if (DGSYS.Device=1) then begin
       Error:=False;
       for i:=1 to FilePar.Num do
           if (i in OutSet) and (FExpand(DGSYS.GraphicFil)=FExpand(FilePar.Body[i].Name)) then begin
                ErrorDisp('Error: Data file is same as output GRA-file -> not output');
                goto exit2;
           end;
   end;
   nOpenGraph;

//   for i:=0 to 2 do if VAF.draw[i]<>'' then VAFCode:=VAFExec(VAF.draw[i]);

   nRemark('Graphics Begin');
   PutMessage(1,THeight,'        Setting        ',Color2.Message2[2]);
   SetAxisScale(OutSet);
   CloseWindow;

   if KeyCheck then goto exit1;

   PutMessage(1,THeight,'     Drawing Scale     ',Color2.Message2[3]);
   AxisOut(AxisPar2^);
   CloseWindow;

   if KeyCheck then goto exit1;

   for i:=1 to FilePar.Num do FilePar.Body[i].IsRead:=False;
   if NGRAPH.DrawMode[0][1]='Y' then begin
        PutMessage(1,THeight,'Plotting. <ESC> to quit',Color2.Message2[4]);
        PlotOut(OutSet,AxisPar2^);
        CloseWindow;
   end;

   if KeyCheck then goto exit1;

   if NGRAPH.DrawMode[2][1]='Y' then begin
       PutMessage(1,THeight,' Merging. <ESC> to quit',Color2.Message2[6]);
       MergeIn;
       CloseWindow;
   end;

   if KeyCheck then goto exit1;

   if NGRAPH.DrawMode[1][1]='Y' then begin
       PutMessage(1,THeight,'    Writing Legend     ',Color2.Message2[5]);
       OutSet:=[1..20];
       DotOut(False,OutSet);
       ArrowOut(False,OutSet);
       RemarkOut(False,Fst,OutSet);
       OutSet:=[0..5];
       CommentOut(False,Fst,OutSet);
       CloseWindow;
   end;

   Draw:=True;
exit1:
   nReMark('Graphics End');
   nCloseGraph;
   if Wait then Verify(1,THeight,HitAny);
exit2:
   StopGraph;
   if DGSYS.Device=0 then NGRAPH.Drawn:=True;

end;

end.
