(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* GRAR}hCRTɕ`悷葱 @ˑ*)

unit Gra2Crt;

interface

uses Windows,Crt,PullMenu,JcType,SysUtils;

Type CParType = array [1..13] of Integer;

Const
    PaperSize=21000;

    Roman=0;
    Bold=1;
    Italic=2;
    BoldItalic=3;

    Times=0;
    Helvetica=1;
    Mincho=2;
    Gothic=3;
    Courier=4;

    HorizontalDir=0;
    VerticalDir=1;

Var
    CCod:Char;
    CPar:CParType;
    CStr:String;

var   gViewX1:Integer;
      gViewY1:Integer;
      gSize  :Integer;

const GRADC:HDC=0;
      MemDc:HDC=0;
      BitMap:HBITMAP=0;

procedure OpenGra2Crt;
procedure CloseGra2Crt;
procedure ClearView(Col:Word);
function Mm2pixel(r:Real):Integer;
function Pixel2mm(r:Real):Integer;
function Mm2dot(r:Real):Integer;
function Dot2mm(r:Real):Integer;
function Pt2dot(Pt:Real):Integer;
function Dot2pixel(x:Real):Integer;
function Pixel2dot(x:Real):Integer;
function nTextWidth(Font,Typ:Integer;Pt:Real;Ch:Char):Real;
function nTextHeight(Font,Typ:Integer;Pt:Real):Real;
procedure gDraw;
function GetColor2(Col:Integer):LongInt;

implementation

Type FNameType = record
                Name: array[0..lf_FaceSize-1] of Char;
                CharSet: Byte;
                PitchFamily: Byte;
              end;

Const FontName:array [0..4] of FNameType=(
  (Name:'Times New Roman';
   CharSet:Ansi_CharSet;
   PitchFamily:Variable_Pitch or ff_Roman),
  (Name:'Arial';
   CharSet:Ansi_CharSet;
   PitchFamily:Variable_Pitch or ff_Swiss),
  (Name:'Courier';
   CharSet:Ansi_CharSet;
   PitchFamily:Fixed_Pitch or ff_Modern),
  (Name:'lr ';
   CharSet:ShiftJis_CharSet;
   PitchFamily:Fixed_Pitch or ff_Modern),
  (Name:'lr SVbN';
   CharSet:ShiftJis_CharSet;
   PitchFamily:Fixed_Pitch or ff_Modern));

var
       CPX,CPY:Integer;
       TextFont:Integer;
       TextTyp :Integer;
       TextDir :Integer;
       TextTheta:Real;
       TextPt100  :Integer;
       TextSpc100:Integer;
       LType,LWidth,LCol,FCol,CCol:Integer;
       ThePen:HPen;
       TheBrush:HBrush;
       TheFont:HFont;
const FAlign:Boolean=True;
Var
      GraphDriver:Integer;
      GraphMode  :Integer;
      Pixel_Pt:Real;
//      gTextFont:Integer;
//      gColor:Integer;
//      gFillColor:Integer;
//      gLineType:Integer;
//      gLineWidth:Integer;
//      gDefaultSize:Integer;
//      BaseH:Integer;

(* pC|Wf|^ *)
const ImagePattern: array[0..7] of Byte=($FC,$F8,$F8,$FC,$FE,$9F,$0E,$04);
      Image: array[0..27] of Byte=(
                        07,0,07,0,
                        0,0,0,
                        0,0,0,
                        0,0,0,
                        0,0,0,
                        0,0,0,
                        0,0,0,
                        0,0,0,
                        0,0,0 );

      OffSetX:Integer=0;
      OffSetY:Integer=0;


function ToInt(x:Real):Integer;
begin
  if x>MaxInt then x:=MaxInt
  else if x<-MaxInt then x:=-MaxInt;
  ToInt:=Round(x);
end;

function Mm2dot(r:Real):Integer;
begin
    Mm2dot:=ToInt(r/2100*PaperSize);
end;

function Dot2mm(r:Real):Integer;
begin
    Dot2mm:=ToInt(r/PaperSize*2100);
end;

function Mm2pixel(r:Real):Integer;
begin
   Mm2pixel:=ToInt(r/2100*gSize);
end;

function Pixel2mm(r:Real):Integer;
begin
    Pixel2mm:=ToInt(r*gSize/2100);
end;

function Pt2dot(Pt:Real):Integer;
begin
    Pt2dot:=ToInt(Pt/72*25.4/210*PaperSize);
end;

function Dot2pixel(x:Real):Integer;
begin
    Dot2pixel:=ToInt(x*gSize/PaperSize);
end;

function Dot2pixelX(x:Integer):Integer;
begin
    Dot2pixelX:=ToInt(x/PaperSize*gSize)+OffSetX;
end;

function Dot2pixelY(y:Integer):Integer;
begin
    Dot2pixelY:=ToInt(y/PaperSize*gSize)+OffSetY;
end;

function Pixel2dot(x:Real):Integer;
begin
    Pixel2dot:=ToInt(x/gSize*PaperSize);
end;

function Pixel2dotX(x:Real):Integer;
begin
    Pixel2dotX:=ToInt((x-OffSetX)/gSize*PaperSize);
end;

function Pixel2dotY(y:Real):Integer;
begin
    Pixel2dotY:=ToInt((y-OffSetY)/gSize*PaperSize);
end;

procedure OpenGra2Crt;
var Brush:HBrush;
    rect:TRect;
begin
   gSize:=FHeight*THeight;
   gViewX1:=FWidth*TWidth-gSize;
   gViewY1:=0;
   Pixel_Pt:=(gSize+1)/(210/25.4*72);
   if (MemDC=0) then begin
     MemDC:=CreateCompatibleDC(0);
     if (MemDC<>0) then begin
       BitMap:=CreateBitmap(gSize,gSize,GetDeviceCaps(MEMDC,PLANES),GetDeviceCaps(MEMDC,BITSPIXEL),NIL);
       SetBkMode(MEMDC,TRANSPARENT);
       SelectObject(MemDC,BitMap);
       Brush:=CreateSolidBrush(RGB(255,255,255));
       rect.left:=0;
       rect.top:=0;
       rect.right:=gSize;
       rect.bottom:=gSize;
       FillRect(MEMDC,rect,brush);
       DeleteObject(Brush);
     end;
   end;
end;

procedure CloseGra2Crt;
begin
  if (MemDC<>0) then DeleteDC(MemDC);
  if (BitMap<>0) then DeleteObject(BitMap);
  MemDC:=0;
  BitMap:=0;
end;

procedure ClearView(Col:Word);
begin
(*    SetGraphMode(GraphMode);
    if not DisplayGraph then StopGraph;
    SetVisualPage(0);
    SetActivePage(0);
    SetViewPort(0,0,GetMaxx,GetMaxy,true);
    SetBkColor(Graph.Black);
    ClearViewPort;
    SetFillStyle(SolidFill,Col);
    Bar(gViewX1,gViewY1,gViewX1+gSize,gViewY1+gSize); *)
end;

function nTextWidth(Font,Typ:Integer;Pt:Real;Ch:Char):Real;
Const HelveticaSet: array [$20..$7E] of Integer=
          (278,278,355,556,556,889,667,222,333,333,389,584,278,584,278,278,
           556,556,556,556,556,556,556,556,556,556,278,278,584,584,584,556,
          1015,667,667,722,722,667,611,778,722,278,500,667,556,833,722,778,
           667,778,722,667,611,722,667,944,667,667,611,278,278,278,469,556,
           222,556,556,500,556,556,278,556,556,222,222,500,222,833,556,556,
           556,556,333,500,278,556,500,722,500,500,500,334,260,334,584);
      HelveticaBoldSet: array [$20..$7E] of Integer=
          (278,333,474,556,556,889,722,278,333,333,389,584,278,584,278,278,
           556,556,556,556,556,556,556,556,556,556,333,333,584,584,584,611,
           975,722,722,722,722,667,611,778,722,278,556,722,611,833,722,778,
           667,778,722,667,611,722,667,944,667,667,611,333,278,333,584,556,
           278,556,611,556,611,556,333,611,611,278,278,556,278,889,611,611,
           611,611,389,556,333,611,556,778,556,556,500,389,280,389,584);
      TimesRomanSet: array [$20..$7E] of Integer=
          (250,333,408,500,500,833,778,333,333,333,500,564,250,564,250,278,
           500,500,500,500,500,500,500,500,500,500,278,278,564,564,564,444,
           921,722,667,667,722,611,556,722,722,333,389,722,611,889,722,722,
           556,722,667,556,611,722,722,944,722,722,611,333,278,333,469,500,
           333,444,500,444,500,444,333,500,500,278,278,500,278,778,500,500,
           500,500,333,389,278,500,500,722,500,500,444,480,200,480,541);
      TimesBoldSet: array [$20..$7E] of Integer=
          (250,333,555,500,500,1000,833,333,333,333,500,570,250,570,250,278,
           500,500,500,500,500,500,500,500,500,500,333,333,570,570,570,500,
           930,722,667,722,722,667,611,778,778,389,500,778,667,944,722,778,
           611,778,722,556,667,722,722,1000,722,722,667,333,278,333,581,500,
           333,500,556,444,556,444,333,500,556,278,333,556,278,833,556,500,
           556,556,444,389,333,556,500,722,500,500,444,394,220,394,520);
      TimesItalicSet: array [$20..$7E] of Integer=
          (250,333,420,500,500,833,778,333,333,333,500,675,250,675,250,278,
           500,500,500,500,500,500,500,500,500,500,333,333,675,675,675,500,
           920,611,611,667,722,611,611,722,722,333,444,667,556,833,667,722,
           611,722,611,500,556,722,611,833,611,556,556,389,278,389,422,500,
           333,500,500,444,500,444,278,500,500,278,278,444,278,722,500,500,
           500,500,389,389,278,500,444,667,444,444,389,400,275,400,541);
      TimesBoldItalicSet: array [$20..$7E] of Integer=
          (250,389,555,500,500,833,778,333,333,333,500,570,250,570,250,278,
           500,500,500,500,500,500,500,500,500,500,333,333,570,570,570,500,
           832,667,667,667,722,667,667,722,778,389,500,667,611,889,722,722,
           611,722,667,556,611,722,667,889,667,611,611,333,278,333,570,500,
           333,500,500,444,500,444,333,500,556,278,278,500,278,778,556,500,
           500,500,389,389,278,556,444,667,500,444,389,348,220,348,570);
begin
   Pt:=Pt*1E-3;
   if Font in [Mincho,Gothic] then nTextWidth:=Pt*1000
   else begin
     if ($20>Ord(Ch)) or (Ord(Ch)>$7E) then Ch:=' ';
     if Font=Helvetica then begin
         if (Typ=Roman) or (Typ=Italic) then nTextWidth:=Pt*HelveticaSet[Ord(Ch)]
         else if (Typ=Bold) or (Typ=BoldItalic) then nTextWidth:=Pt*HelveticaBoldSet[Ord(Ch)];
     end else if Font=Times then begin
         if (Typ=Roman) then nTextWidth:=Pt*TimesRomanSet[Ord(Ch)]
         else if (Typ=Bold) then nTextWidth:=Pt*TimesBoldSet[Ord(Ch)]
         else if (Typ=Italic) then nTextWidth:=Pt*TimesItalicSet[Ord(Ch)]
         else if (Typ=BoldItalic) then nTextWidth:=Pt*TimesBoldItalicSet[Ord(Ch)];
     end else if Font=Courier then nTextWidth:=Pt*600;
   end;
end;

function nTextHeight(Font,Typ:Integer;Pt:Real):Real;
begin
   if Font=Mincho then nTextheight:=Pt*0.80681
   else if Font=Gothic then nTextHeight:=Pt*0.79106
   else if Font=Helvetica then begin
       if (Typ=Roman) or (Typ=Italic) then nTextHeight:=Pt*0.72831
       else if (Typ=Bold) or (Typ=BoldItalic) then nTextHeight:=Pt*0.728185;
   end else if Font=Times then begin
       if (Typ=Roman) then nTextHeight:=Pt*0.661436
       else if (Typ=Bold) then nTextHeight:=Pt*0.68156
       else if (Typ=Italic) then nTextHeight:=Pt*0.65906
       else if (Typ=BoldItalic) then nTextHeight:=Pt*0.66106;
   end else if Font=Courier then begin
       if (Typ=Roman) or (Typ=Italic) then nTextHeight:=Pt*0.541686
       else if (Typ=Bold) or (Typ=BoldItalic) then nTextHeight:=Pt*0.532686;
   end;
end;

function GetColor2(Col:Integer):LongInt;
begin
   case Col of
       0: GetColor2:=RGB(0,0,0);
       1: GetColor2:=RGB(0,0,255);
       2: GetCOlor2:=RGB(0,255,0);
       3: GetColor2:=RGB(0,255,255);
       4: GetColor2:=RGB(255,0,0);
       5: GetColor2:=RGB(255,0,255);
       6: GetColor2:=RGB(255,255,0);
       7: GetColor2:=RGB(255,255,255);
   end;
 end;

procedure gDraw;

var i:Integer;
    S:String[2];
    W,x0,y0,csin,ccos:Real;
    Points:array[1..10] of TPoint;
    TmpPen:HPen;
    TmpBrush:HBrush;
    TmpFont:HFont;
    IDFont:TLogFont;
    FontN:Integer;
    PStr:array[0..256] of Char;
    Theta1,Theta2:Real;
    x,y,x1,y1:Integer;
    hClip:HRGN;
    R,G,B:COLORREF;
begin
  case CCod of
    'I','E': begin
               OffSetX:=0;
               OffSetY:=0;
             end;
    '%': ;
    'X': begin
           case CPar[1] of
             1: begin
                  if (Cpar[2]=1) then begin
                    SetRop2(GRADC,R2_XORPEN);
                    SetRop2(MEMDC,R2_XORPEN);
                  end else begin
                    SetRop2(GRADC,R2_COPYPEN);
                    SetRop2(MEMDC,R2_COPYPEN);
                  end;
                end;
             2: begin
                  if (CPar[4] and 4)<>0 then G:=255
                  else G:=0;
                  if (CPar[4] and 2)<>0 then R:=255
                  else R:=0;
                  if (CPar[4] and 1)<>0 then B:=255
                  else B:=0;
                  TmpPen:=CreatePen(ps_Solid,0,RGB(R,G,B));
                  SelectObject(GRADC,TmpPen);
                  x:=Dot2PixelX(Cpar[2]);
                  y:=Dot2PixelX(Cpar[3]);
                  MoveToEx(GRADC,x,y,NIL);
                  LineTo(GRADC,x+FWidth,y+FWidth);
                  MoveToEx(GRADC,x,y,NIL);
                  LineTo(GRADC,x+FWidth*2 div 3,y+FWidth div 4);
                  MoveToEx(GRADC,x,y,NIL);
                  LineTo(GRADC,x+FWidth div 4,y+FWidth*2 div 3);
                  SelectObject(GRADC,ThePen);
                  DeleteObject(TmpPen);
                end;
           end;
         end;
    'V': begin
           OffSetX:=0;
           OffSetY:=0;
           if (CPar[1]>=5) and (CPar[6]=0) then begin
             SelectClipRgn(GRADC,0);
             SelectClipRgn(MEMDC,0);
           end else begin
             x:=Dot2pixelX(CPar[2]);
             y:=Dot2pixelY(CPar[3]);
             x1:=Dot2pixelX(CPar[4]);
             y1:=Dot2pixelY(CPar[5]);
             if x<0 then begin
               x:=0;
             end;
             if y<0 then begin
               y:=0;
             end;
             if x1<0 then x1:=1;
             if y1<0 then y1:=1;
             if x>gSize then x:=gSize-1;
             if y>gSize then y:=gSize-1;
             if x1>gSize then x1:=gSize;
             if y1>gSize then y1:=gSize;
             hClip:=CreateRectRgn(x,y,x1,y1);
             SelectClipRgn(GRADC,hClip);
             SelectClipRgn(MEMDC,hClip);
             DeleteObject(hClip);
           end;
           OffSetX:=Dot2PixelX(CPar[2]);
           OffSetY:=Dot2PixelY(CPar[3]);
         end;
    'A': begin
           LWidth:=Dot2Pixel(CPar[3])-1;
           case CPar[2] of
               0: LType:=ps_Solid;
	       1: LType:=ps_Dot;
	       2: LType:=ps_Dash;
	       3: LType:=ps_Dashdotdot;
           end;
           LCol:=CPar[4];
	   TmpPen:=CreatePen(LType,LWidth,GetColor2(LCol));
           SelectObject(GRADC,TmpPen);
           SelectObject(MEMDC,TmpPen);
           DeleteObject(ThePen);
           ThePen:=TmpPen;
         end;
    'O': begin
           FCol:=CPar[2];
           TmpBrush:=CreateSolidBrush(GetColor2(FCol));
           SelectObject(GRADC,TmpBrush);
           SelectObject(MEMDC,TmpBrush);
           DeleteObject(TheBrush);
           TheBrush:=TmpBrush;
         end;
    'M': begin
           CPX:=CPar[2];
           CPY:=CPar[3];
           MoveToEx(GRADC,Dot2PixelX(CPar[2]),Dot2PixelY(CPar[3]),NIL);
           MoveToEx(MEMDC,Dot2PixelX(CPar[2]),Dot2PixelY(CPar[3]),NIL);
         end;
    'N': begin
           CPX:=CPX+CPar[2];
           CPY:=CPY+CPar[3];
         end;
    'L': begin
           MoveToEx(GRADC,Dot2PixelX(CPar[2]),Dot2PixelY(CPar[3]),NIL);
           MoveToEx(MEMDC,Dot2PixelX(CPar[2]),Dot2PixelY(CPar[3]),NIL);
           LineTo(GRADC,Dot2PixelX(CPar[4]),Dot2PixelY(CPar[5]));
           LineTo(MEMDC,Dot2PixelX(CPar[4]),Dot2PixelY(CPar[5]));
         end;
    'T': begin
           LineTo(GRADC,Dot2PixelX(CPar[2]),Dot2PixelY(CPar[3]));
           LineTo(MEMDC,Dot2PixelX(CPar[2]),Dot2PixelY(CPar[3]));
           CPX:=CPar[2];
           CPY:=CPar[3];
         end;
    'C': begin
           if CPar[1]<5 then CPar[6]:=CPar[4];
           if CPar[1]<=5 then begin
             if CPar[5]=1 then begin
               TmpPen:=CreatePen(ps_Solid,0,GetColor2(FCol));
               SelectObject(GRADC,TmpPen);
               SelectObject(MEMDC,TmpPen);
               Ellipse(GRADC,Dot2PixelX(CPar[2]-CPar[4]),Dot2PixelY(CPar[3]-CPar[6]),
                             Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]+CPar[6]));
               Ellipse(MEMDC,Dot2PixelX(CPar[2]-CPar[4]),Dot2PixelY(CPar[3]-CPar[6]),
                             Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]+CPar[6]));
               SelectObject(GRADC,ThePen);
               SelectObject(MEMDC,ThePen);
               DeleteObject(TmpPen);
             end else begin
               Arc(GRADC,Dot2PixelX(CPar[2]-CPar[4]),Dot2PixelY(CPar[3]-CPar[6]),
                              Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]+CPar[6]),
                              Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]),
                              Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]));
               Arc(MEMDC,Dot2PixelX(CPar[2]-CPar[4]),Dot2PixelY(CPar[3]-CPar[6]),
                              Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]+CPar[6]),
                              Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]),
                              Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]));
             end;
           end else begin
             Theta1:=CPar[7]/1800*Pi;
             Theta2:=CPar[8]/1800*Pi;
             if CPar[5]=1 then begin
               TmpPen:=CreatePen(ps_Solid,0,GetColor2(FCol));
               SelectObject(GRADC,TmpPen);
               SelectObject(MEMDC,TmpPen);
               Pie(GRADC,Dot2PixelX(CPar[2]-CPar[4]),Dot2PixelY(CPar[3]-CPar[6]),
                         Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]+CPar[6]),
                         Dot2PixelX(CPar[2]+Round(CPar[4]*cos(Theta1))),
                         Dot2PixelY(CPar[3]-Round(CPar[6]*sin(Theta1))),
                         Dot2PixelX(CPar[2]+Round(CPar[4]*cos(Theta2))),
                         Dot2PixelY(CPar[3]-Round(CPar[6]*sin(Theta2))));
               Pie(MEMDC,Dot2PixelX(CPar[2]-CPar[4]),Dot2PixelY(CPar[3]-CPar[6]),
                         Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]+CPar[6]),
                         Dot2PixelX(CPar[2]+Round(CPar[4]*cos(Theta1))),
                         Dot2PixelY(CPar[3]-Round(CPar[6]*sin(Theta1))),
                         Dot2PixelX(CPar[2]+Round(CPar[4]*cos(Theta2))),
                         Dot2PixelY(CPar[3]-Round(CPar[6]*sin(Theta2))));
               SelectObject(GRADC,ThePen);
               SelectObject(MEMDC,ThePen);
               DeleteObject(TmpPen);
             end else begin
               Arc(GRADC,Dot2PixelX(CPar[2]-CPar[4]),Dot2PixelY(CPar[3]-CPar[6]),
                         Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]+CPar[6]),
                         Dot2PixelX(CPar[2]+Round(CPar[4]*cos(Theta1))),
                         Dot2PixelY(CPar[3]-Round(CPar[6]*sin(Theta1))),
                         Dot2PixelX(CPar[2]+Round(CPar[4]*cos(Theta2))),
                         Dot2PixelY(CPar[3]-Round(CPar[6]*sin(Theta2))));
               Arc(MEMDC,Dot2PixelX(CPar[2]-CPar[4]),Dot2PixelY(CPar[3]-CPar[6]),
                         Dot2PixelX(CPar[2]+CPar[4]),Dot2PixelY(CPar[3]+CPar[6]),
                         Dot2PixelX(CPar[2]+Round(CPar[4]*cos(Theta1))),
                         Dot2PixelY(CPar[3]-Round(CPar[6]*sin(Theta1))),
                         Dot2PixelX(CPar[2]+Round(CPar[4]*cos(Theta2))),
                         Dot2PixelY(CPar[3]-Round(CPar[6]*sin(Theta2))));
             end;
           end;
         end;
    'D': if CPar[3]=1 then begin
           for i:=1 to CPar[2]-1 do begin
               Points[i].x:=Dot2PixelX(CPar[i*2+2]);
               Points[i].y:=Dot2PixelY(CPar[i*2+3]);
           end;
           TmpPen:=CreatePen(ps_Solid,0,GetColor2(FCol));
           SelectObject(GRADC,TmpPen);
           SelectObject(MEMDC,TmpPen);
           Polygon(GRADC,Points,CPar[2]-1);
           Polygon(MEMDC,Points,CPar[2]-1);
           SelectObject(GRADC,ThePen);
           SelectObject(MEMDC,ThePen);
           DeleteObject(TmpPen);
         end else begin
           for i:=1 to CPar[2] do begin
               Points[i].x:=Dot2PixelX(CPar[i*2+2]);
               Points[i].y:=Dot2PixelY(CPar[i*2+3]);
           end;
           PolyLine(GRADC,Points,CPar[2]);
           PolyLine(MEMDC,Points,CPar[2]);
         end;
    'B': if CPar[6]=1 then begin
           TmpPen:=CreatePen(ps_Solid,0,GetColor2(FCol));
           SelectObject(GRADC,TmpPen);
           SelectObject(MEMDC,TmpPen);
           RectAngle(GRADC,Dot2PixelX(CPar[2]),Dot2PixelY(CPar[3]),Dot2PixelX(CPar[4]),Dot2PixelY(CPar[5]));
           RectAngle(MEMDC,Dot2PixelX(CPar[2]),Dot2PixelY(CPar[3]),Dot2PixelX(CPar[4]),Dot2PixelY(CPar[5]));
           SelectObject(GRADC,ThePen);
           SelectObject(MEMDC,ThePen);
           DeleteObject(TmpPen);
         end else begin
           Points[1].x:=Dot2PixelX(CPar[2]);
           Points[1].y:=Dot2PixelY(CPar[3]);
           Points[2].x:=Dot2PixelX(CPar[4]);
           Points[2].y:=Points[1].y;
           Points[3].x:=Points[2].x;
           Points[3].y:=Dot2PixelY(CPar[5]);
           Points[4].x:=Points[1].x;
           Points[4].y:=Points[3].y;
           Points[5].x:=Points[1].x;
           Points[5].y:=Points[1].y;
           PolyLine(GRADC,Points,5);
           PolyLine(MEMDC,Points,5);
         end;
    'P': begin
           SetPixel(GRADC,Dot2PixelX(CPar[2]),Dot2PixelY(CPar[3]),GetColor2(LCol));
           SetPixel(MEMDC,Dot2PixelX(CPar[2]),Dot2PixelY(CPar[3]),GetColor2(LCol));
         end;
    'F': begin
           TextFont:=CPar[2];
           TextTyp:=CPar[3];
           if CPar[1]>=8 then begin
             TextPt100:=CPar[8];
             TextSpc100:=CPar[9];
           end else begin
             TextPt100:=CPar[4]*100;
             TextSpc100:=CPar[5]*100;
           end;
           CCol:=CPar[6];
           IDFont.lfHeight:=-Round(TextPt100/100*Pixel_Pt);
           IDFont.lfWidth:=0;
           if CPar[7]=VerticalDir then begin
             TextTheta:=900;
             TextDir:=VerticalDir
           end else if CPar[7]=HorizontalDir then begin
             TextTheta:=0;
             TextDir:=HorizontalDir
           end else begin
             While CPar[7]<=-3600 do Inc(CPar[7],3600);
             While CPar[7]>0 do Dec(CPar[7],3600);
             TextTheta:=-CPar[7];
             TextDir:=HorizontalDir;
           end;
           IDFont.lfEscapement:=Round(TextTheta);
           TextTheta:=TextTheta/1800*Pi;
           IDFont.lfOrientation:=0;
           IDFont.lfUnderline:=0;
           IDFont.lfStrikeOut:=0;
           case TextTyp of
             Roman: begin
                      IDFont.lfWeight:=fw_Normal;
                      IDFont.lfItalic:=0;
                    end;
             Bold:  begin
                      IDFont.lfWeight:=fw_Bold;
                      IDFont.lfItalic:=0;
                    end;
             Italic:begin
                      IDFont.lfWeight:=fw_Normal;
                      IDFont.lfItalic:=1;
                    end;
             BoldItalic: begin
                      IDFont.lfWeight:=fw_Bold;
                      IDFont.lfItalic:=1;
                    end;
           end;

           case TextFont of
             Times:     FontN:=0;
             Helvetica: FontN:=1;
             Courier:   FontN:=2;
             Mincho:    FontN:=3;
             Gothic:    FontN:=4;
           end;

           if FontName[FontN].Name[0]=Chr(0) then begin
               if TextFont=Gothic then begin
                   IDFont.lfPitchAndFamily:=Fixed_Pitch or ff_Modern;
                   IDFont.lfCharset:=ShiftJIS_CharSet;
               end else if TextFont=Mincho then begin
                   IDFont.lfPitchAndFamily:=Fixed_Pitch or ff_Roman;
                   IDFont.lfCharset:=ShiftJIS_CharSet;
               end else if TextFont=Times then begin
                   IDFont.lfPitchAndFamily:=Variable_Pitch or ff_Roman;
                   IDFont.lfCharset:=ANSI_CharSet;
               end else if TextFont=Helvetica then begin
                   IDFont.lfPitchAndFamily:=Variable_Pitch or ff_Swiss;
                   IDFont.lfCharset:=ANSI_CharSet;
               end else if TextFont=Courier then begin
                   IDFont.lfPitchAndFamily:=Fixed_Pitch or ff_Modern;
                   IDFont.lfCharset:=OEM_CharSet;
               end;
           end else begin
               IDFont.lfPitchAndFamily:=FontName[FontN].PitchFamily;
               IDFont.lfCharset:=FontName[FontN].Charset;
           end;

           IDFont.lfOutPrecision:=Out_Default_Precis;
           IDFont.lfClipPrecision:=Clip_Default_Precis;
           IDFont.lfQuality:=PROOF_QUALITY;
           StrCopy(@IDFont.lfFaceName,@FontName[FontN].Name);
	   TmpFont:=CreateFontIndirect(IDFont);
           SelectObject(GRADC,TmpFont);
           SelectObject(MEMDC,TmpFont);
           DeleteObject(TheFont);
           TheFont:=TmpFont;
           SetTextAlign(GRADC,ta_BaseLine or ta_Left);
           SetTextAlign(MEMDC,ta_BaseLine or ta_Left);
           SetTextColor(GRADC,GetColor2(CCol));
           SetTextColor(MEMDC,GetColor2(CCol));
           if not FAlign then begin
             SetTextCharacterExtra(GRADC,Round(TextSpc100/100*Pixel_Pt));
             SetTextCharacterExtra(MEMDC,Round(TextSpc100/100*Pixel_Pt));
           end else begin
             SetTextCharacterExtra(GRADC,0);
             SetTextCharacterExtra(MEMDC,0);
           end;
         end;
    'S','K':
         begin
           if not FAlign then begin
               StrPCopy(@PStr,CStr);
               TextOut(GRADC,CPX,CPY,@PStr,StrLen(@PStr));
               TextOut(MEMDC,CPX,CPY,@PStr,StrLen(@PStr));
           end;
           i:=1;
           x0:=CPX;
           y0:=CPY;
           csin:=sin(TextTheta);
           ccos:=cos(TextTheta);
           While i<=Length(CStr) do begin
               if CCod='K' then S:=Copy(CStr,i,2)
               else S:=CStr[i];
               W:=nTextWidth(TextFont,TextTyp,TextPt100/100,S[1])*Pixel_Pt;
               if FAlign then begin
                 StrPCopy(@PStr,S);
                 TextOut(GRADC,Dot2PixelX(Round(x0)),Dot2PixelY(Round(y0)),@PStr,StrLen(@PStr));
                 TextOut(MEMDC,Dot2PixelX(Round(x0)),Dot2PixelY(Round(y0)),@PStr,StrLen(@PStr));
               end;
               x0:=x0+Pixel2Dot(W+TextSpc100/100*Pixel_Pt)*ccos;
               y0:=y0-Pixel2Dot(W+TextSpc100/100*Pixel_Pt)*csin;
               Inc(i);
               if CCod='K' then Inc(i);
           end;
           CPX:=Round(x0);
           CPY:=Round(y0);
         end;
    end;
end;

end.
