(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I|oC葱C}|W *)

unit GRAMerge;

interface

uses GRA2CRT,GraGraph,Display,Variable,IOProc;

Type Real=Double;

procedure MergeInput(Fil:Integer);

implementation

Var TopMarginSave,LeftMarginSave,RegionSizeSave:Integer;

procedure GraphicInput(Fil:Integer;Str:String);

            function Trans(x:Real):Integer;
            begin
              Trans:=Round(x*Mm2dot(Merge[Fil].Size)/RegionSizeSave);
            end;

            function GetPar(Num:Integer):Boolean;
            var i,code:Integer;
                Pos1,Pos2:Integer;
                S:String;
            begin
              Pos1:=2;
              GetPar:=False;
              for i:=1 to Num do begin
                  Pos2:=0;
                  Inc(Pos1);
                  While (Str[Pos1]=' ') or (Str[Pos1]=',') do Inc(Pos1);
                  while (Pos1<=Length(Str)) and (Str[Pos1]<>',') and (Str[Pos1]<>' ') do begin
                      Inc(Pos2);
                      S[Pos2]:=Str[Pos1];
                      Inc(Pos1);
                  end;
                  S[0]:=Chr(Pos2);
                  Val(S,CPar[i],code);
                  if code<>0 then Exit;
              end;
              GetPar:=True;
            end;

var i:Integer;
    S:String;
    Error:Boolean;
begin
  Error:=False;
  if (Length(Str)=0) then Exit;
  if not (Str[1] in ['I','E','X','L','T','C','D','B','V','A','O','M','N','P','F','S','K','%']) 
  or not GetPar(1) then Error:=True;
  if not Error then begin
    CCod:=Str[1];
    if CPar[1]=-1 then begin
        S:=Copy(Str,6,Length(Str)-5);
        if S[Length(S)]=',' then S:=Copy(S,1,Length(S)-1);
        CStr:='';
        i:=1;
        While (i<=Length(S)) do begin
            if (S[i]='\') and (i<Length(S)) then begin
                if S[i+1]='n' then CStr:=CStr+Chr($0D)
                else if S[i+1]='r' then CStr:=CStr+Chr($0A)
                else CStr:=CStr+S[i+1];
                Inc(i);
            end else CStr:=CStr+S[i];
            Inc(i);
        end;
    end else if not GetPar(CPar[1]+1) then Error:=True;
  end;
  if Error then begin
    CCod:='%';
    CPar[1]:=-1;
    CStr:='Error: '+Str+',';
  end;
  case CCod of
    '%','O','S': ;
    'X': Exit;
    'E': Exit;
    'I': begin
           LeftMarginSave:=CPar[2];
           TopMarginSave:=CPar[3];
           RegionSizeSave:=CPar[4];
           Exit;
         end;
    'V': begin
           CPar[2]:=Trans(CPar[2]-LeftMarginSave)+Mm2dot(Merge[Fil].x);
           CPar[3]:=Trans(CPar[3]-TopMarginSave)+Mm2dot(Merge[Fil].y);
           CPar[4]:=Trans(CPar[4]-LeftMarginSave)+Mm2dot(Merge[Fil].x);
           CPar[5]:=Trans(CPar[5]-TopMarginSave)+Mm2dot(Merge[Fil].y);
         end;
    'A': CPar[3]:=Trans(CPar[3]);
    'L','B':
         begin
           CPar[2]:=Trans(Cpar[2]);
           CPar[3]:=Trans(Cpar[3]);
           CPar[4]:=Trans(Cpar[4]);
           CPar[5]:=Trans(Cpar[5]);
         end;
    'T','M','N','P':
         begin
           CPar[2]:=Trans(Cpar[2]);
           CPar[3]:=Trans(Cpar[3]);
         end;
    'C': begin
           CPar[2]:=Trans(Cpar[2]);
           CPar[3]:=Trans(Cpar[3]);
           CPar[4]:=Trans(Cpar[4]);
           if CPar[1]>=5 then CPar[6]:=Trans(CPar[6]);
         end;
    'D': for i:=1 to CPar[2]*2 do CPar[i+3]:=Trans(CPar[i+3]);
    'F': begin
           if CPar[1]>=8 then begin
             CPar[8]:=Trans(Cpar[8]);
             CPar[9]:=Trans(Cpar[9]);
             CPar[4]:=Trans(Cpar[4]);
             CPar[5]:=Trans(Cpar[5]);
           end else begin
             CPar[1]:=8;
             CPar[8]:=Trans(Cpar[4]*100);
             CPar[9]:=Trans(Cpar[5]*100);
             CPar[4]:=Trans(Cpar[4]);
             CPar[5]:=Trans(Cpar[5]);
           end;
         end;
  end;
  nDraw;
end;

procedure MergeInput(Fil:Integer);
var Fp:Text;
    S:String;
    Error:Boolean;
begin
    Assign(Fp,Merge[Fil].Fil);
    Reset(Fp);
    ReadLn(Fp,S);
    if S=DGSYS.Main+DGSYS.GRAtitle then begin
        ReadLn(Fp,S);
        While not EOF(FP) and (not KeyCheck) do begin
            S:='E,0,';
            ReadLn(Fp,S);
            GraphicInput(Fil,S);
        end;
    end else ErrorDisp('Error: Incompatible GRA file('+Merge[Fil].Fil+')');
    Close(fp);
    Error:=IOErrorCheck;
end;

end.