(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* ʎ葱 *)

unit IOProc;

interface

uses SysUtils,Display,Variable;

Type Real=Double;

function  IOErrorCheck:Boolean;
function  Find(fil:string;errmes:boolean):boolean;

implementation

function IOErrorCheck:Boolean;
var  IOR     :Word;
     IORMes  :String;
begin
    IOR:=IOResult;
    if IOR<>0 then begin
        case IOR of
          100: IORMes:='Disk read';
          101: IORMes:='Disk write';
          102: IORMes:='File not assigned';
          103: IORMes:='File not open';
          104: IORMes:='File not open for input';
          105: IORMes:='File not open for output';
          106: IORMes:='Invalid numeric format';
          else Str(IOR,IORMes);
        end;
        Errordisp('Error: I/O operation ('+IORMes+')');
        IOErrorCheck:=True;
    end else IOErrorCheck:=False;
end;

function Find(fil:string;errmes:boolean):boolean;
var dat:TSearchRec;
    Error:Integer;
begin
   Error:=FindFirst(fil,faReadOnly or faHidden or faSysFile or faArchive,dat);
   If Error=0 then Find:=true
   else begin
      Find:=false;
      if errmes then ErrorDisp('Error: File ('+fil+') not found');
   end;
   FindClose(dat);
end;

end.
