unit MainWnd;

interface

uses
  Windows,Messages,SysUtils,
  PullMenu,Variable,Display,Crt,Jctype,Gra2Crt,DosCall,PrmOut,
  MFile,MScale,MAxis,MGraph,MLegend,MOption,MDebug,MDraw,MPrint,ChildExe;

procedure OpenWindowM;

implementation


Const

   MainMenu : array [0..6] of String[8]= ('Add-in  ',
                                          'File    ',
					  'Scale   ',
					  'Graph   ',
					  'Option  ',
					  'Draw    ',
					  'Print   ' );

   AddInMenu : array [0..2] of String[14]= ('Select menue  ',
                                            'Registration  ',
                                            'Ngraph for Win');

   FileMenu : array [0..11] of String[9]=('Open     ',
                                          'New      ',
					  'Close    ',
					  'Update   ',
                                          'Move     ',
					  'List     ',
					  'Edit     ',
                                          'Read file',
					  'Directory',
					  'Shell    ',
                                          'About... ',
					  'Quit     '  );

   ScaleMenu : array [0..6] of String[8]= ('X-axis  ',
					   'Y-axis  ',
                                           'U-axis  ',
                                           'R-axis  ',
                                           'Zooming ',
					   'Trimming',
					   'Clear   ' );

   GraphMenu: array [0..4] of String[8]=  ('Type    ',
                                            'Position',
                                            'Axis    ',
                                            'Font    ',
                                            'Switch  ' );

   OptionMenu : array [0..3] of String[14]=('Legend        ',
                                            'Data          ',
					    'Read parameter',
					    'Save parameter' );

   DrawMenu : array [0..4] of String[6]= ('Run   ',
					  'Clear ',
					  'Watch ',
					  'Debug ',
                                          'Merge ');

   PrintMenu : array [0..3] of String[7]= ('Region ',
                                           'Driver ',
                                           'Connect',
					   'Output ' );

   Sel:Integer=1;
   Sel2:Integer=-1;
   Sel3:Integer=0;
   WinPosition:array[0..6] of Integer=(0,0,0,0,0,0,0);
   WinX:array[0..6] of Integer=(10,20,30,40,50,60,70);
   WinLine:array[0..6] of Integer=(3,12,7,5,4,5,4);
   WinLen:array[0..6] of Integer=(14,9,8,8,14,6,7);
   WinMenu:array[0..6] of ByteArrayPo=(@AddinMenu,@FileMenu,@ScaleMenu,@GraphMenu,@OptionMenu,@DrawMenu,@PrintMenu);
   MenuOpen:Boolean=False;
   KeyLoop:Boolean=False;

procedure WMPaint(dc:HDC);
var i,j:Integer;
    orgfont:HFONT;
    ps:TPaintStruct;
    rc:TRECT;
    rect:TRect;
    brush:HBrush;
begin
    if not Graphic then begin
      XShift:=9;
      for i:=0 to MainWin.Height-1 do
        for j:=0 to MainWin.Row-1 do
          DgSdisp(dc,@MainWin,i*MainWin.Row+j,0);
      DgSdisp(dc,@MainWin,MainWin.Position-MainWin.Start,1);
      XShift:=0;
      SetTextAlign(dc,TA_BOTTOM or TA_LEFT);
      SetTextCharacterExtra(dc,WinEnv.TExtra);
      orgfont:=SelectObject(dc,MainWin.Font);
      MakeFrameXY2(dc,1,3,78,maxfil,Color2.FileDisp.Frame,Color2.FileDisp.Title,Color2.FileDisp.Title2,Color2.FileDisp.Shadow,
                  '---DATA FILE-----X-Y-D-C-AX-AY-SKP-STP-FIN-D---NUM----------1ST LINE----------','');
      ClearFrameXY2(dc,2,4,78,maxfil,Color2.FileDisp.Back);
      Fdisp3(False,True);
      FileParamDisp(dc);
      FileParamDisp2(dc);
      ClearFrameXY2(dc,1,2,80,1,Color2.FileDisp.Frame);
      ClearFrameXY2(dc,1,25,80,1,Color2.FileDisp.Frame);
      PullWriteXY2(dc,1,1,'         ',Color2.MainMenu.Back);
      PullWriteXY2(dc,80,1,' ',Color2.MainMenu.Back);
      SelectObject(dc,orgfont);
    end else begin
      brush:=CreateSolidBrush(RGB(0,0,0));
      rect.left:=0;
      rect.top:=0;
      rect.right:=FWidth*TWidth+1;
      rect.bottom:=FHeight*THeight+1;
      FillRect(dc,rect,brush);
      DeleteObject(brush);
      if (BriefMode) then begin
        SetTextAlign(dc,TA_BOTTOM or TA_LEFT);
        SetTextCharacterExtra(dc,WinEnv.TExtra);
        orgfont:=SelectObject(dc,MainWin.Font);
        MakeFrameXY2(dc,1,3,24,FilePar.Num,Color2.FileDisp.Frame,Color2.FileDisp.Title,Color2.FileDisp.Title2,Color2.FileDisp.Shadow,
                     '---DATA FILE-----X-Y-D-C','');
        ClearFrameXY2(dc,2,4,24,FilePar.Num,Color2.FileDisp.Back);
        Fdisp3(False,False);
        FileParamDisp(dc);
        SelectObject(dc,orgfont);
      end;
    end;
end;

procedure WMKeyDown(iMessage:UINT;ParamW:WParam;ParamL:LParam);
var Shift:Boolean;
    Po:Integer;
    x,y,row,line,len,maxnum:Integer;
    Win:DgWinPo;
    Redraw,Open,Select:Boolean;
    i,j:Integer;
    Buf:ByteArrayPo;
    NewData    :Boolean;
    rect:TRect;
    Command,Fil:String;
begin
  if KeyLoop then begin
    Win:=GetDgWindow;
    if Win<>NIL then PostMessage(Win^.Wnd,WM_KEYDOWN,ParamW,ParamL);
    exit;
  end;
  KeyLoop:=True;
  MainWin.KeyCode:=ParamW;
  Po:=MainWin.Position;
  Redraw:=False;
  Open:=False;
  Select:=False;
  rect.left:=0;
  rect.right:=FWidth*TWidth;
  rect.top:=0;
  rect.bottom:=FHeight;
  case MainWin.KeyCode of
  VK_LEFT:
    begin
      if MainWin.Position>0 then Dec(MainWin.Position)
      else MainWin.Position:=MainWin.Maxnum-1;
      InvalidateRect(MainWin.Wnd,@rect,False);
    end;
  VK_RIGHT:
    begin
      if MainWin.Position<MainWin.Maxnum-1 then Inc(MainWin.Position)
      else MainWin.Position:=0;
      InvalidateRect(MainWin.Wnd,@rect,False);
    end;
  VK_UP:
    begin
      if MenuOpen then begin
        if WinPosition[Po]>0 then Dec(WinPosition[Po])
        else WinPosition[Po]:=WinLine[Po]-1;
        Redraw:=True;
      end;
    end;
  VK_DOWN:
    begin
      if not MenuOpen then begin
        MenuOpen:=True;
        Open:=True;
      end else begin
        if WinPosition[Po]<WinLine[Po]-1 then Inc(WinPosition[Po])
        else WinPosition[Po]:=0;
        Redraw:=True;
      end;
    end;
  VK_ESCAPE:
    begin;
      CloseWindow();
      MenuOpen:=False;
    end;
  VK_RETURN:
    begin
      if not MenuOpen then begin
        MenuOpen:=True;
        Open:=True;
      end else Select:=True;
    end;
  else begin
    if not MenuOpen then begin
      Buf:=MainWin.Menu;
      i:=0;
      j:=MainWin.Position+1;
      if j>=MainWin.Line then j:=0;
      while (Char(MainWin.KeyCode)<>UpCase(Char(Buf^[j*(MainWin.Len+1)+1]))) and (i<MainWin.Maxnum) do begin
        Inc(i);
        Inc(j);
        if j>=MainWin.Maxnum then j:=0;
      end;
      if i<>MainWin.Maxnum then begin
        InvalidateRect(MainWin.Wnd,@rect,False);
        MenuOpen:=True;
        Open:=True;
        MainWin.Position:=j;
      end;
    end else begin
      Buf:=WinMenu[Po];
      i:=0;
      j:=WinPosition[Po]+1;
      if j>=WinLine[Po] then j:=0;
      while (Char(MainWin.KeyCode)<>UpCase(Char(Buf^[j*(WinLen[Po]+1)+1]))) and (i<WinLine[Po]) do begin
        Inc(i);
        Inc(j);
        if j>=WinLine[Po] then j:=0;
      end;
      if i<>WinLine[Po] then begin
        Redraw:=True;
        Select:=True;
        WinPosition[Po]:=j;
      end;
    end;
  end;
  end;
  if (MenuOpen) then begin
    if Po<>MainWin.Position then begin
      CloseWindow();
      Po:=MainWin.Position;
      Open:=True;
    end;
    if Open or Redraw then begin
      case Po of
      0: begin
           for i:=0 to 1 do SelMenu(i,14,AddinMenu)
         end;
      1: begin
           if FilePar.Num=0 then for i:=2 to 6 do SelMenu(i,9,FileMenu)
                            else for i:=2 to 6 do ClrMenu(i,9,FileMenu);
           if FilePar.Num=maxfil then for i:=0 to 1 do SelMenu(i,9,FileMenu)
                                 else for i:=0 to 1 do ClrMenu(i,9,FileMenu);
         end;
      2: begin
         end;
      3: begin
         end;
      4: begin
         end;
      5: begin
           if FilePar.Num=0 then SelMenu(3,6,DrawMenu)
                            else ClrMenu(3,6,DrawMenu);
           if not NGRAPH.Drawn then begin
               SelMenu(1,6,DrawMenu);
               SelMenu(2,6,DrawMenu);
           end else begin
               ClrMenu(1,6,DrawMenu);
               ClrMenu(2,6,DrawMenu);
           end;
         end;
      6: begin
         end;
      end;
    end;

    if Open then begin
      PullColor:=Color2.Menu;
      SelectMode(True,True,True,True);
      OpenWindow(WinX[Po]-1,2,(WinLen[Po]+2),WinLine[Po]);
      Win:=GetDgWindow;
      if Win<>NIL then begin
        Win^.Start:=0;
        Win^.Position:=WinPosition[Po];
        Win^.Menu:=WinMenu[Po];
        Win^.Row:=1;
        Win^.Line:=WinLine[Po];
        Win^.Len:=WinLen[Po];
        Win^.MaxNum:=WinLine[Po];
      end;
    end;
    if Redraw then begin
      Win:=GetDgWindow;
      if Win<>NIL then begin
        Win^.Position:=WinPosition[Po];
        InvalidateRect(Win^.Wnd,NIL,False);
      end;
    end;
  end;
  if Select then begin
    Sel3:=WinPosition[Po];
    case Po of
    0: begin
         if (Sel3>=0) and (Sel3 in [0,1]) then
           Verify(PWinX,PWinY+Sel3+1,'Add-in ̋@\͎gpł܂')
         else if (Sel3=2) then begin
           Command:=GetEnv('NGRAPHWIN');
           if Command='' then Command:='Ngraph';
           Fil:=DGSYS.GRADIR+DGSYS.TEMPNAME+'.PRM';
           ParamOut(Fil);
	   ExitCode:=Child(Command,Fil,False,False);
	 end;
       end;
    1: begin
         NewData:=False;
         if (Sel3>=0) and (Sel3 in [0,1]) and (FilePar.Num=maxfil) then
             Verify(PWinX,PWinY+Sel3+1,'ȏt@C̐ݒ͂ł܂')
         else if (Sel3>=2) and (Sel3<=6) and (FilePar.Num=0) then Verify(PWinX,PWinY+Sel3+1,MustBeSet)
         else if Sel3>=0 then NewData:=SetFileBody(Sel3);
         if NewData then FileDisp;
       end;
    2: begin
         ScalingBody(Sel3);
       end;
    3: begin
         NewData:=False;
         if Sel3=2 then AxisBody
         else if Sel3>=0 then NewData:=FormatBody(Sel3);
         if NewData then FileDisp;
       end;
    4: begin
         NewData:=False;
         if Sel3=0 then LegendBody
         else if Sel3>=0 then NewData:=OptionBody(Sel3);
         if NewData then FileDisp;
       end;
    5: begin
         NewData:=False;
         if (Sel3=3) and (FilePar.Num=0) then Verify(PWinX,PWinY+Sel3+1,MustBeSet)
         else if Sel3=3 then NewData:=DebugBody
         else if (Sel3>=0) then NewData:=DrawBody(Sel3,False);
         if NewData then FileDisp;
       end;
    6: begin
         NewData:=False;
         if Sel3>=0 then NewData:=PrintingBody(Sel3);
         FileDisp;
       end;
    end;
    Redraw:=True;
  end;
  if (MenuOpen) then begin
    case Po of
    0: begin
         for i:=0 to 1 do SelMenu(i,14,AddinMenu)
       end;
    1: begin
         if FilePar.Num=0 then for i:=2 to 6 do SelMenu(i,9,FileMenu)
                          else for i:=2 to 6 do ClrMenu(i,9,FileMenu);
         if FilePar.Num=maxfil then for i:=0 to 1 do SelMenu(i,9,FileMenu)
                               else for i:=0 to 1 do ClrMenu(i,9,FileMenu);
       end;
    2: begin
       end;
    3: begin
       end;
    4: begin
       end;
    5: begin
         if FilePar.Num=0 then SelMenu(3,6,DrawMenu)
                          else ClrMenu(3,6,DrawMenu);
         if not NGRAPH.Drawn then begin
             SelMenu(1,6,DrawMenu);
             SelMenu(2,6,DrawMenu);
         end else begin
             ClrMenu(1,6,DrawMenu);
             ClrMenu(2,6,DrawMenu);
         end;
       end;
    6: begin
       end;
    end;
    if Redraw then begin
      Win:=GetDgWindow;
      if Win<>NIL then begin
        InvalidateRect(Win^.Wnd,NIL,False);
      end;
    end;
  end;
  KeyLoop:=False;
end;

function DgWinProcM(Wnd:HWND;iMessage:UINT;ParamW:WPARAM;ParamL:LPARAM): LRESULT; stdcall;
var rc:TRECT;
    ps:TPaintStruct;
    dc:HDC;
    brush:HBrush;
    rect:Trect;
begin
  DgWinProcM:=0;
  case iMessage of
  WM_PAINT:
    begin
      if GetUpdateRect(Wnd,rc,FALSE) then begin
        dc:=BeginPaint(Wnd,ps);
        WMPaint(dc);
        EndPaint(Wnd,ps);
      end;
    end;
  WM_KEYDOWN:
    begin
      WMKeyDown(iMessage,ParamW,ParamL);
    end;
  WM_CLOSE:
    begin
      PullQuit;
    end;
  else begin
    DgWinProcM:=DefWindowProc(Wnd,iMessage,ParamW,ParamL);
  end;
  end;
end;

const szDgClassNameM:PChar='DGWINM';
var DgWcM:TWndClass;

procedure OpenWindowM;
var dwStyle:DWORD;
    winx,winy,winwidth,winheight:Integer;
    orgfont:HFONT;
    tm:TTextMetric;
    rect:TRect;
    Width2,Height2:Integer;
    dc:HDC;
    IDFont:TLogFont;
    DgWc:TWndClass;
begin
  winx:=CW_USEDEFAULT;
  winy:=CW_USEDEFAULT;
  winwidth:=CW_USEDEFAULT;
  winheight:=CW_USEDEFAULT;
  DgWc.style      :=0;
  DgWc.lpfnWndProc:=@DgWinProcM;
  DgWc.cbClsExtra :=0;
  DgWc.cbWndExtra :=0;
  DgWc.hInstance  :=hInstance;
  DgWc.hIcon      :=LoadIcon(hInstance,MAKEINTRESOURCE(1));
  DgWc.hCursor    :=LoadCursor(0,IDC_NO);
  DgWc.hbrBackground:=0;
  DgWc.lpszMenuName:=NIL;
  DgWc.lpszClassName:=szDgClassNameM;
  if RegisterClass(DgWc)=0 then exit;
  dwStyle:=WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX or WS_CLIPCHILDREN;
  MainWin.Wnd:=CreateWindow(szDgClassNameM,'Ngraph',dwStyle,
                           winx,winy,winwidth,winheight,
                           HWND_DESKTOP,0,hInstance,NIL);
  if MainWin.Wnd=0 then exit;
  with MainWin do begin
    Next:=NIL;
    Edit:=False;
    X:=1;
    Y:=1;
    Width:=(8+2)*7;
    Height:=1;
    with PullMode do begin
      Roll:=True;
      Letter:=True;
      UpDownOnly:=False;
      Frame:=False;
    end;
    Color:=Color2.MainMenu;
    Start:=0;
    Position:=1;
    Row:=7;
    Line:=1;
    Len:=8;
    Menu:=@MainMenu;
    Title1:='';
    Title2:='';
    Maxnum:=7;
    if (WinEnv.TFont='') or (WinEnv.TSize<=0) then begin
      Font:=GetStockObject(OEM_FIXED_FONT);
    end else begin
      IDFont.lfHeight:=WinEnv.TSize;
      IDFont.lfWidth:=0;
      IDFont.lfEscapement:=0;
      IDFont.lfOrientation:=0;
      IDFont.lfUnderline:=0;
      IDFont.lfStrikeOut:=0;
      IDFont.lfWeight:=fw_Normal;
      IDFont.lfItalic:=0;
      IDFont.lfPitchAndFamily:=Fixed_Pitch or ff_Modern;
      IDFont.lfCharset:=ShiftJIS_CharSet;
      IDFont.lfOutPrecision:=Out_Default_Precis;
      IDFont.lfClipPrecision:=Clip_Default_Precis;
      IDFont.lfQuality:=PROOF_QUALITY;
      StrCopy(@IDFont.lfFaceName,@WinEnv.TFont);
      Font:=CreateFontIndirect(IDFont);
    end;
    Crt.Font:=Font;
    dc:=GetDC(HWND_DESKTOP);
    orgfont:=SelectObject(dc,Font);
    GetTextMetrics(dc,tm);
    SelectObject(dc,orgfont);
    ReleaseDC(HWND_DESKTOP,dc);
    MainWin.FHeight:=tm.tmHeight+tm.tmDescent+tm.tmExternalLeading;
    MainWin.FWidth:=tm.tmAveCharWidth+WinEnv.TExtra;
    GetWindowRect(MainWin.Wnd,rect);
    winx:=rect.left;
    winy:=rect.top;
    winwidth:=MainWin.FWidth*TWidth+GetSystemMetrics(SM_CXFRAME)*2-1;
    winheight:=MainWin.FHeight*THeight+GetSystemMetrics(SM_CYFRAME)+GetSystemMetrics(SM_CYCAPTION);
    MoveWindow(Wnd,x,y,winwidth,winheight,True);
    ShowWindow(Wnd,SW_SHOW);
  end;
  FWidth:=MainWin.FWidth;
  FHeight:=MainWin.FHeight;
end;

end.
