(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* |Graph|Axis| j| *)

unit MAxis;

interface

uses PullMenu,Gra2Crt,GraGraph,Variable,Display,GUI;

Type Real=Double;

procedure AxisBody;

implementation

Const

AxisMenu: array [0..1] of String[9] =
   ('Gauge    ',
    'Numbering');
ScaleMenu3:array [0..5] of String[15+5]=
       ('`͈͐ݒ ',
        't`:',
        'ڐ    :',
        'ʒu    :',
        '-Ľ-ٗ]L :',
        'EEڐ');
ScDirMenu :array [0..3] of String[4]=
       ('',
        'O',
        '',
        'Ȃ');
AxisLenMenu : array [0..7] of String[19+5]=
       ('             ',
        '()         ',
        '()         ',
        '()         ',
        'ڐ       @    ',
        'ڐ()(.1mm):',
        'ڐ()(.1mm):',
        'ڐ()(.1mm):');
AxisLenMenu2 : array [0..2] of String[13+8]=
       ('CJ|:',
        'C`  :',
        'C    :');

NumMenu :array [0..4] of String[6]=
   ('X-axis',
    'Y-axis',
    'U-axis',
    'R-axis',
    'Common');
NumMenu2:array [0..10] of String[17+5]=
   ('ڐ    :',
    'ڐn_    :',
    'ڐԊu    :',
    'ڐ    :',
    '_ǉ      :',
    '0     ǉ      :',
    '+     \      :',
    'OOt  :',
    'ʒu킹  :',
    'EVtg(.1mm):',
    'Vtg(.1mm):');

ScaleLRMenu :array [0..3] of String[6]=
   ('_',
    'El  ',
    '@',
    'l  ');
ScLogMenu :array [0..1] of String[4]=
   ('ʏ',
    'w');
CommonMenu : array [0..0] of String[14+5]=
   ('(0,0)̕\:');

procedure AxisBody;
var a,i,Sel0,Sel2,Sel3,Sel4,Sel5,Sel6:Integer;
    H,W:Integer;
    gx1,gy1,gx2,gy2,gsizex,gsizey:Integer;
    sx,sy,ex,ey:Integer;
    Str0:String;
begin
    SelectMode(True,True,False,True);
    PullColor:=Color2.Menu2;
    SelectMenuSFirst(PWinX,PWinY+3,1,5,6,4,5);
    SelectMode(True,False,False,True);
    repeat
        Sel2:=SelectMenuSNext(NumMenu,'','');
        case Sel2 of
          0..3:With AxisPar[Sel2] do begin
              PullColor:=Color2.Menu3;
              SelectMenuSFirst(PWinX,PWinY+Sel2+1,1,2,9,0,2);
              repeat
                Sel0:=SelectMenuSNext(AxisMenu,'','');
                case Sel0 of
                  0:begin
                      PullColor:=Color2.Setting;
                      SelectMenuSFirst(PWinX,PWinY+1,1,6,15+5,0,6);
                      repeat
                        PullColor:=Color2.Setting2;
                        SetMenuVal(1,15+5,ScaleMenu3,ScFull,5,0);
                        SetMenuVal(2,15+5,ScaleMenu3,ScDirMenu[ScDir],5,0);
                        SetMenuVal(3,15+5,ScaleMenu3,ScCros,5,0);
                        SetMenuVal(4,15+5,ScaleMenu3,ScAuto,5,0);
                        Sel3:=SelectMenuSNext(ScaleMenu3,'','');
                        case Sel3 of
                          0: begin
                               ClrScr2;
                               StartGraph;
                               i:=0;
                               nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
                               case Sel2 of
                                 0: gy1:=gy2;
                                 1: gx2:=gx1;
                                 2: gy2:=gy1;
                                 3: gx1:=gx2;
                               end;
                               if Sel2 in [0,2] then begin
                                     sx:=Round(Mm2dot(NGRAPH.Sizex)/10000*ScPosS)+gx1;
                                     ex:=Round(Mm2dot(NGRAPH.Sizex)/10000*ScPosE)+gx1;
                                     sy:=gy1;
                                     ey:=gy1;
                               end else begin
                                     sx:=gx1;
                                     ex:=gx1;
                                     sy:=Round(Mm2dot(NGRAPH.Sizey)/10000*(10000-ScPosS))+gy1;
                                     ey:=Round(Mm2dot(NGRAPH.Sizey)/10000*(10000-ScPosE))+gy1;
                               end;
                               repeat
                                   if i=0 then a:=InputPos('ڐw',False,False,False,sx,sy,ex,ey,3,
                                                           gx1,gy1,gx2,gy2)
                                          else a:=InputPos('ڐw',False,False,True,ex,ey,sx,sy,3,
                                                           gx1,gy1,gx2,gy2);
                                   if (a=-2) and (i>0) then Dec(i)
                                   else if a>0 then Inc(i);
                               until (a=-1) or (i=2);
                               if (a<>-1) then begin
                                    if Sel2 in [0,2] then begin
                                        if (sx>ex) then begin
                                            a:=sx;sx:=ex;ex:=a;
                                        end;
                                        ScPosS:=Round((sx-gx1)/Mm2dot(NGRAPH.Sizex)*10000);
                                        ScPosE:=Round((ex-gx1)/Mm2dot(NGRAPH.Sizex)*10000);
                                    end else begin
                                        if (sy>ey) then begin
                                            a:=sy;sy:=ey;ey:=a;
                                        end;
                                        ScPosS:=10000-Round((ey-gy1)/Mm2dot(NGRAPH.Sizey)*10000);
                                        ScPosE:=10000-Round((sy-gy1)/Mm2dot(NGRAPH.Sizey)*10000);
                                    end;
                                    if ScPosS=ScPosE then Inc(ScPosE);
                               end;
                               StopGraph;
                             end;
                          1: toggle(ScFull);
                          2: begin
                               Sel4:=SelectAMenu(PWinX+16,PWinY+3,1,4,4,ScDir,4,ScDirMenu,'','');
                               if Sel4>=0 then ScDir:=Sel4;
                             end;
                          3: ValInput(PWinX+16,PWinY+4,'Incriment̔{ 1~50 <A>uto',ScCros,5,1,50);
                          4: toggle(ScAuto);
                          5: begin
                               PullColor:=Color2.Setting;
                               SelectMenuSFirst(PWinX+16,PWinY+6,1,8,19+5,0,8);
                               repeat
                                   for i:=0 to 2 do SetMenuVal(i+5,19+5,AxisLenMenu,LLen[i+1],1,0);
                                   Sel4:=SelectMenuSNext(AxisLenMenu,'','');
                                   case Sel4 of
                                     0..4: begin
                                             PullColor:=Color2.Setting;
                                             SelectMenuSFirst(PWinX+20,PWinY+Sel4+1,1,3,13+8,0,3);
                                             repeat
                                                 Str0:=Copy(ColMenu[LCol[Sel4]],3,8);
                                                 SetMenuVal(0,13+8,AxisLenMenu2,Str0,6,8);
                                                 Str0:=Copy(LineMenu[LAttr[Sel4]],3,8);
                                                 SetMenuVal(1,13+8,AxisLenMenu2,Str0,6,8);
                                                 SetMenuVal(2,13+8,AxisLenMenu2,LWidth[Sel4],1,0);
                                                 Sel5:=SelectMenuSNext(AxisLenMenu2,'','');
                                                 PullColor:=Color2.Setting2;
                                                 case Sel5 of
                                                   0:begin
                                                       Sel6:=SelectAMenu(PWinX+14,PWinY+1,1,8,10,LCol[Sel4],8,
                                                                         ColMenu,'','');
                                                       if Sel6>=0 then LCol[Sel4]:=Sel6;
                                                     end;
                                                   1:begin
                                                       Sel6:=SelectAMenu(PWinX+14,PWinY+2,1,4,10,LAttr[Sel4],4,
                                                                         LineMenu,'','');
                                                       if Sel6>=0 then LAttr[Sel4]:=Sel6;
                                                     end;
                                                   2:begin
                                                       if LWidth[Sel4]=20 then a:=0
                                                       else if LWidth[Sel4]=40 then a:=1
                                                       else a:=2;
                                                       Sel6:=SelectAMenu(PWinX+14,PWinY+3,1,3,10,a,3,WidthMenu,'','');
                                                       if Sel6>=0 then
                                                           case Sel6 of
                                                             0: LWidth[Sel4]:=20;
                                                             1: LWidth[Sel4]:=40;
                                                             2: ValInput(PWinX+14,PWinY+3,'NEW VALUE(0~1000/0.01mm)',
                                                                LWidth[Sel4],1,0,1000);
                                                           end;
                                                     end;
                                                 end;
                                             until (Sel5<0);
                                             SelectMenuSEnd;
                                           end;
                                     5..7: ValInput(PWinX+20,PWinY+Sel4+1,'NEW VALUE(0~2100/0.1mm)',
                                                    LLen[Sel4-4],1,0,2100);
                                   end;
                               until (Sel4<0);
                               SelectMenuSEnd;
                             end;
                        end;
                      until (Sel3<0);
                      SelectMenuSEnd;
                    end;

                  1:begin
                      PullColor:=Color2.Setting;
                      SelectMenuSFirst(PWinX,PWinY+2,1,11,17+5,0,11);
                      repeat
                        PullColor:=Color2.Setting2;
                        SetMenuVal(0,17+5,NumMenu2,ScNum,5,0);
                        SetMenuVal(1,17+5,NumMenu2,ScStart,5,0);
                        SetMenuVal(2,17+5,NumMenu2,ScStep,5,0);
                        SetMenuVal(3,17+5,NumMenu2,ScFig,5,0);
                        SetMenuVal(4,17+5,NumMenu2,ScPer,5,0);
                        SetMenuVal(5,17+5,NumMenu2,ScZero,5,0);
                        SetMenuVal(6,17+5,NumMenu2,ScPlus,5,0);
                        SetMenuVal(7,17+5,NumMenu2,ScLogMenu[Sclog],5,0);
                        SetMenuVal(8,17+5,NumMenu2,ScaleLRMenu[ScLR],6,4);
                        SetMenuVal(9,17+5,NumMenu2,ScPosx,1,0);
                        SetMenuVal(10,17+5,NumMenu2,ScPosy,1,0);
                        Sel3:=SelectMenuSNext(NumMenu2,'','');
                        case Sel3 of
                          0: ValInput(PWinX+18,PWinY+1,'NEW VALUE(0~50 <A>uto)',ScNum,5,0,50);
                          1: ValInput(PWinX+18,PWinY+2,'Incriment̔{(1~50 <A>uto)',ScStart,5,1,50);
                          2: ValInput(PWinX+18,PWinY+3,'Incriment̔{(1~50 <A>uto)',ScStep,5,1,50);
                          3: begin
                               H:=Ord(ScFig[1])-Ord('0');
                               W:=Ord(ScFig[3])-Ord('0');
                               ValInput(PWinX+18,PWinY+4,'(0~9)',H,1,0,9);
                               ValInput(PWinX+18,PWinY+5,'(0~9)',W,1,0,9);
                               ScFig[1]:=Chr(H+Ord('0'));
                               ScFig[3]:=Chr(W+Ord('0'));
                             end;
                          4: toggle(ScPer);
                          5: toggle(ScZero);
                          6: toggle(ScPlus);
                          7: if ScLog=0 then ScLog:=1
                                        else ScLog:=0;
                          8: begin
                               Sel4:=SelectAMenu(PWinX+18,PWinY+9,1,4,6,ScLR,4,ScaleLRMenu,'','');
                               if Sel4>=0 then ScLR:=Sel4;
                             end;
                          9: ValInput(PWinX+18,PWinY+10,'NEW VALUE(-100~100/0.1mm)',ScPosx,1,-100,100);
                         10: ValInput(PWinX+18,PWinY+11,'NEW VALUE(-100~100/0.1mm)',ScPosy,1,-100,100);
                        end;
                      until (Sel3<0);
                      SelectMenuSEnd;
                    end;
                end;
              until Sel0<0;
              SelectMenuSEnd;
            end;
          4:begin
              PullColor:=Color2.Setting;
              SelectMenuSFirst(PWinX,PWinY+5,1,1,14+5,0,1);
              repeat
                  PullColor:=Color2.Setting2;
                  SetMenuVal(0,14+5,CommonMenu,NGRAPH.Con00,5,0);
                  Sel3:=SelectMenuSNext(CommonMenu,'','');
                  case Sel3 of
                       0: toggle(NGRAPH.Con00);
                  end;
              until (Sel3<0);
              SelectMenuSEnd;
            end;
        end;
    until (Sel2<0);
    SelectMenuSEnd;
end;

end.
