(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* |Draw|Run|Debug| 葱 *)

unit MDebug;

interface

uses Crt,PullMenu,Clip,Gra2Crt,GraGraph,Math,Data,
     Variable,GUI,Dialog,Display,DataScal,DosCall;

Type Real=Double;

function DebugBody:Boolean;

implementation

Const
   DebugMenu : array [0..5] of String[13]= ('Evaluation   ',
	 				    'Mask point   ',
                                            'Mask region  ',
                                            'Unchange data',
                                            'Unmask point ',
                                            'Unmask region');

function DebugBody:Boolean;
var i,j,k,Sel2,Sel3,InPos:Integer;
    MaskMenu : array [1..21] of String[53];
    MaskMenu2: array [1..21] of String[76];
    DDR      : array [0..20] of Real;
    Mask2 : MaskType;
    S1,S2,S3,S4,S5,S6:String[15];
    x,y,r,x1,y1,x2,y2:Real;
    lin:Longint;
    Ov,IsNotRead,Change:Boolean;
    gx1,gy1,gx2,gy2,gsizex,gsizey:Integer;
    sx,sy,ex,ey:Integer;
    SelFile:ByteSet;
    Error,NAN,Point,Found:Boolean;

const
    MaskTitle='--#--FILE NAME----LINE--------X---------------Y--------';
    Path:PathStr='*.GRA';
    MaskTitle2='--#--FILE NAME-------Min.(X)--------Min.(Y)--------Max.(X)--------Max.(Y)-----';

               procedure SetMaskMenu(var M:MaskType;Mes:String);
               var i:Integer;
               begin
                   for i:=1 to M.Num do begin
                       Str(M.Body[i].Fil:2,S1);
                       S2:=MakeFileName(FilePar.Body[M.Body[i].Fil].Name);
                       Str(M.Body[i].Lin:6,S3);
                       Str(M.Body[i].x:15,S4);
                       Str(M.Body[i].y:15,S5);
                       MaskMenu[i]:=S1+' '+S2+S3+' '+S4+' '+S5;
                   end;
                   MaskMenu[M.Num+1]:=Mes;
               end;

begin
     DebugBody:=False;
     SelectMode(True,False,False,True);
     nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
     PullColor:=Color2.Menu2;
     IsNotRead:=True;
     for i:=1 to FilePar.Num do IsNotRead:=IsNotRead and (not FilePar.Body[i].IsRead);
     Sel2:=SelectAMenu(PWinX,PWinY+4,1,6,13,0,6,DebugMenu,'','');
     if (Sel2>=0) and (Sel2 in [0,1]) and (not NGRAPH.Drawn or IsNotRead) then Verify(PWinX,PWinY+4,MustBeDrawn)
     else if (Sel2=3) and (ChgData.Num=0) or (Sel2=4) and (Mask.Num=0) or (Sel2=5) and (MaskReg.Num=0)
            then Verify(PWinX,PWinY+4,' No Masked/Changed Data ')
     else begin
         case Sel2 of
         0,1: begin
                ClrScr2;
                FileDisp2;
                StartGraph;
                Sx:=gX1+gSizex div 2;
                Sy:=gY1+gSizey div 2;
                Repeat
                  Mask2.Num:=0;
                  i:=0;
                  repeat
                      Ex:=Sx;
                      Ey:=Sy;
                      if i=0 then InPos:=InputPos('CR ݂̂Ŕ͈͎w',False,True,False,Sx,Sy,0,0,2,0,0,PaperSize,PaperSize)
                             else InPos:=InputPos('͈͎w',False,False,True,Ex,Ey,Sx,Sy,0,0,0,PaperSize,PaperSize);
                      if (InPos=-2) and (i>0) then Dec(i)
                      else if (InPos>0) then Inc(i);
                  until (InPos=-1) or (InPos=2) and (i=1) or (i=2);
                  if Inpos<>-1 then begin
                      if i=2 then Point:=False
                             else Point:=True;
                      Ex:=Ex-Sx;
                      Ey:=Ey-Sy;
                      for i:=1 to FilePar.Num do With FilePar.Body[i] do
                        if IsRead and (DotNum>=0) and OpenData(i) then begin
                          fDisp(i,True);
                          if not KeyCheck then begin
                              nSetWindow(AxisPar[Axisx*2].Min,AxisPar[Axisy*2+1].Min,
                                         AxisPar[Axisx*2].Max,AxisPar[Axisy*2+1].Max);
                              While GetData(x,y,Lin,NAN) and not KeyCheck do begin
                                  if not NAN and WInXY(x,y) then begin
                                     x1:=XToG(x)-Sx+gX1;
                                     y1:=YToG(y)-Sy+gY1;
                                     r:=Sqr(x1)+Sqr(y1);
                                     if AxisPar[Axisx*2].SetMin and AxisPar[Axisx*2].SetMax 
                                     and AxisPar[Axisy*2+1].SetMin and AxisPar[Axisy*2+1].SetMax
                                     and ( Point and (r<=30000)
                                     or not Point and (x1*(x1-Ex)<=0) and (y1*(y1-Ey)<=0)) then begin
                                         j:=1;
                                         While (j<=Mask2.Num) and (DDR[j]<=r) do Inc(j);
                                         if (j<=20)
                                           and ConvData(False,AxisPar[Axisx*2].ScType,x)
                                           and ConvData(False,AxisPar[Axisy*2+1].ScType,y) then begin
                                             for k:=Mask2.Num downto j do if k<20 then begin
                                                 Mask2.Body[k+1].Fil:=Mask2.Body[k].Fil;
                                                 Mask2.Body[k+1].Lin:=Mask2.Body[k].Lin;
                                                 Mask2.Body[k+1].x:=Mask2.Body[k].x;
                                                 Mask2.Body[k+1].y:=Mask2.Body[k].y;
                                                 DDR[k+1]:=DDR[k];
                                             end;
                                             Mask2.Body[j].Fil:=i;
                                             Mask2.Body[j].Lin:=Lin;
                                             Mask2.Body[j].x:=x;
                                             Mask2.Body[j].y:=y;
                                             DDR[j]:=r;
                                             if Mask2.Num<20 then Mask2.Num:=Mask2.Num+1;
                                         end;
                                     end;
                                  end;
                              end;
                          end;
                          CloseData;
                          fDisp(i,False);
                      end;
                      if Mask2.Num>0 then begin
                          StopGraph;
                          PullColor:=Color2.Setting;
                          case Sel2 of
                            0: begin
                                 SetMaskMenu(Mask2,'ALL DATA');
                                 Sel3:=SelectMenuS(PWinX,1,1,Mask2.Num+1,53,0,Mask2.Num+1,MaskMenu,MaskTitle,
                                                   'Select Data',Mask2.Num);
                                 if (Sel3>=0) then begin
                                   if Sel3=Mask2.Num then begin
                                     for i:=1 to Mask2.Num do SelMenu(i-1,53,MaskMenu);
                                     Sel3:=0;
                                   end;
                                   nSetWindow(AxisPar[FilePar.Body[Mask2.Body[Sel3+1].Fil].Axisx*2].Min,
                                              AxisPar[FilePar.Body[Mask2.Body[Sel3+1].Fil].Axisy*2+1].Min,
                                              AxisPar[FilePar.Body[Mask2.Body[Sel3+1].Fil].Axisx*2].Max,
                                              AxisPar[FilePar.Body[Mask2.Body[Sel3+1].Fil].Axisy*2+1].Max);
                                   if ConvData(True,AxisPar[FilePar.Body[Mask2.Body[Sel3+1].Fil].Axisx*2].ScType,
                                          Mask2.Body[Sel3+1].x)
                                   and ConvData(True,AxisPar[FilePar.Body[Mask2.Body[Sel3+1].Fil].Axisy*2+1].ScType,
                                          Mask2.Body[Sel3+1].y) then begin
                                     Ex:=XToG(Mask2.Body[Sel3+1].x)+gX1;
                                     Ey:=YToG(Mask2.Body[Sel3+1].y)+gY1;
                                     SetLineXor(Ex,gY1,Ex,gY2);
                                     SetLineXor(gX1,Ey,gX2,Ey);
                                     Sx:=Ex;
                                     Sy:=Ey;
                                     StartGraph;
                                     if (InputYN(1,THeight,'Change Data? (Y/N)') in ['Y','y']) then begin
                                       Change:=False;
                                       Ov:=False;
                                       if InputPos('ړ̎w',False,False,False,Sx,Sy,0,0,2,0,0,PaperSize,PaperSize)>0 then
                                       for j:=1 to Mask2.Num do
                                        if Menued(j-1,53,MaskMenu) then With FilePar.Body[Mask2.Body[j].Fil] do
                                         if not (DotTyp in [36..41]) then begin
                                           nSetWindow(AxisPar[Axisx*2].Min,AxisPar[Axisy*2+1].Min,
                                                      AxisPar[Axisx*2].Max,AxisPar[Axisy*2+1].Max);
                                           x:=GToX(Sx-gX1);
                                           y:=GToY(Sy-gY1);
                                           if ConvData(False,AxisPar[Axisx*2].ScType,x)
                                           and ConvData(False,AxisPar[Axisy*2+1].ScType,y) or True then begin
                                             Found:=False;
                                             i:=1;
                                             While (i<=ChgData.Num) and not Found do begin
                                               if (ChgData.Body[i].Fil=Mask2.Body[j].Fil)
                                               and (ChgData.Body[i].Lin=Mask2.Body[j].Lin) then Found:=True
                                               else Inc(i);
                                             end;
                                             if Found or (ChgData.Num<20) then begin
                                               DebugBody:=True;
                                               if not Found then begin
                                                   Inc(ChgData.Num);
                                                   i:=ChgData.Num;
                                               end;
                                               ChgData.Body[i].Fil:=Mask2.Body[j].Fil;
                                               ChgData.Body[i].Lin:=Mask2.Body[j].Lin;
                                               ChgData.Body[i].x:=x;
                                               ChgData.Body[i].y:=y;
                                               Change:=True;
                                             end else Ov:=True;
                                           end;
                                       end;
                                       if Ov then ErrorDisp('Warning: Change Table Overflow ---> Rounded ');
                                       if Change then begin
                                         SetLineXor(Ex,gY1,Ex,gY2);
                                         SetLineXor(gX1,Ey,gX2,Ey);
                                         Ex:=Sx;
                                         Ey:=Sy;
                                         SetLineXor(Ex,gY1,Ex,gY2);
                                         SetLineXor(gX1,Ey,gX2,Ey);
                                         Verify(1,THeight,'Changed Data');
                                       end;
                                       StopGraph;
                                     end;
                                     SetLineXor(Ex,gY1,Ex,gY2);
                                     SetLineXor(gX1,Ey,gX2,Ey);
                                    end;
                                 end;
                               end;
                            1: begin
                                 SetMaskMenu(Mask2,'ALL MASKS');
                                 Sel3:=SelectMenuS(PWinX,1,1,Mask2.Num+1,53,0,Mask2.Num+1,MaskMenu,MaskTitle,
                                                   'Select Mask',Mask2.Num);
                                 if Sel3>=0 then begin
                                     DebugBody:=True;
                                     if Sel3=Mask2.Num then for i:=1 to Mask2.Num do SelMenu(i-1,53,MaskMenu);
                                     Ov:=False;
                                     for i:=1 to Mask2.Num do if Menued(i-1,53,MaskMenu) then begin
                                         if Mask.Num<20 then begin
                                             Inc(Mask.Num);
                                             Mask.Body[Mask.Num]:=Mask2.Body[i];
                                         end else Ov:=True;
                                     end;
                                     if Ov then ErrorDisp('Warning: Mask Table Overflow ---> Rounded ');
                                 end;
                               end;
                          end;
                          StartGraph;
                      end else Verify(1,THeight,'Not Specified');
                  end;
                until InPos=-1;
                StopGraph;
              end;
           2: begin
                ClrScr2;
                FileDisp2;
                StartGraph;
                nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
                sx:=gX1;
                sy:=gY1;
                ex:=gX2;
                ey:=gY2;
                Repeat
                  i:=0;
                  repeat
                      if i=0 then InPos:=InputPos('}XN͈͎w(1)',False,False,False,sx,sy,ex,ey,0,0,0,PaperSize,PaperSize)
                             else InPos:=InputPos('}XN͈͎w(2)',False,False,True,ex,ey,sx,sy,0,0,0,PaperSize,PaperSize);
                      if (InPos=-2) and (i>0) then Dec(i)
                      else if InPos>0 then Inc(i);
                  until (InPos=-1) or (i=2);
                  if (InPos<>-1) then begin
                     if (SelectFile(False,SelFile,'MASK REGION')>0) then begin
                       Ov:=False;
                       for i:=1 to FilePar.Num do if (i in SelFile) then begin
                           if  AxisPar[FilePar.Body[i].Axisx*2].SetMin
                           and AxisPar[FilePar.Body[i].Axisx*2].SetMax
                           and AxisPar[FilePar.Body[i].Axisy*2+1].SetMin
                           and AxisPar[FilePar.Body[i].Axisy*2+1].SetMax then begin
                               x1:=AxisPar[FilePar.Body[i].Axisx*2].Min
                                  +(AxisPar[FilePar.Body[i].Axisx*2].Max-AxisPar[FilePar.Body[i].Axisx*2].Min)
                                  /gSizex*(sx-gX1);
                               x2:=AxisPar[FilePar.Body[i].Axisx*2].Min
                                  +(AxisPar[FilePar.Body[i].Axisx*2].Max-AxisPar[FilePar.Body[i].Axisx*2].Min)
                                  /gSizex*(ex-gX1);
                               y1:=AxisPar[FilePar.Body[i].Axisy*2+1].Min
                                  +(AxisPar[FilePar.Body[i].Axisy*2+1].Max-AxisPar[FilePar.Body[i].Axisy*2+1].Min)
                                  /gSizey*(gY2-sy);
                               y2:=AxisPar[FilePar.Body[i].Axisy*2+1].Min
                                  +(AxisPar[FilePar.Body[i].Axisy*2+1].Max-AxisPar[FilePar.Body[i].Axisy*2+1].Min)
                                  /gSizey*(gY2-ey);
                               if  ConvData(False,AxisPar[FilePar.Body[i].Axisx*2].ScType,x1)
                               and ConvData(False,AxisPar[FilePar.Body[i].Axisx*2].ScType,x2)
                               and ConvData(False,AxisPar[FilePar.Body[i].Axisy*2+1].ScType,y1)
                               and ConvData(False,AxisPar[FilePar.Body[i].Axisy*2+1].ScType,y2) then begin
                                 if x1>x2 then begin
                                   x:=x1; x1:=x2; x2:=x;
                                 end;
                                 if y1>y2 then begin
                                   y:=y1; y1:=y2; y2:=y;
                                 end;
                                 if MaskReg.Num<20 then begin
                                   Inc(MaskReg.Num);
                                   With MaskReg.Body[MaskReg.Num] do begin
                                       Mx1:=x1;
                                       My1:=y1;
                                       Mx2:=x2;
                                       My2:=y2;
                                       Fil:=i;
                                   end;
                                   DebugBody:=True;
                                 end else Ov:=True;
                               end;
                           end else begin
                               Str(i,S1);
                               ErrorDisp('File('+S1+')XP|ݒĂ');
                           end;
                         end;
                         if Ov then ErrorDisp('Warning: Mask Table Overflow ---> Rounded ');
                       end;
                  end;
                until InPos=-1;
                StopGraph;
              end;
           3: begin
                SetMaskMenu(ChgData,'ALL DATA');
                PullColor:=Color2.Setting;
                Sel3:=SelectMenuS(PWinX,2,1,ChgData.Num+1,53,0,ChgData.Num+1,MaskMenu,MaskTitle,
                                  'Select Unchange',ChgData.Num);
                if Sel3>=0 then begin
                  DebugBody:=True;
                  if Sel3=ChgData.Num then for i:=1 to ChgData.Num do SelMenu(i-1,53,MaskMenu);
                  for i:=ChgData.Num downto 1 do if Menued(i-1,53,MaskMenu) then begin
                      for j:=i to ChgData.Num-1 do ChgData.Body[j]:=ChgData.Body[j+1];
                      ChgData.Body[ChgData.Num]:=ChgData.Body[0];
                      Dec(ChgData.Num);
                  end;
                end;
              end;
           4: begin
                SetMaskMenu(Mask,'ALL MASKS');
                PullColor:=Color2.Setting;
                Sel3:=SelectMenuS(PWinX,2,1,Mask.Num+1,53,0,Mask.Num+1,MaskMenu,MaskTitle,
                                  'Select Unmask point',Mask.Num);
                if Sel3>=0 then begin
                  DebugBody:=True;
                  if Sel3=Mask.Num then for i:=1 to Mask.Num do SelMenu(i-1,53,MaskMenu);
                  for i:=Mask.Num downto 1 do if Menued(i-1,53,MaskMenu) then begin
                      for j:=i to Mask.Num-1 do Mask.Body[j]:=Mask.Body[j+1];
                      Mask.Body[Mask.Num]:=Mask.Body[0];
                      Dec(Mask.Num);
                  end;
                end;
              end;
           5: begin
                for i:=1 to MaskReg.Num do begin
                    Str(MaskReg.Body[i].Fil:2,S1);
                    S2:=MakeFileName(FilePar.Body[MaskReg.Body[i].Fil].Name);
                    Str(MaskReg.Body[i].Mx1:14,S3);
                    Str(MaskReg.Body[i].Mx2:14,S5);
                    Str(MaskReg.Body[i].My1:14,S4);
                    Str(MaskReg.Body[i].My2:14,S6);
                    MaskMenu2[i]:=S1+' '+S2+' '+S3+' '+S4+' '+S5+' '+S6;
                end;
                MaskMenu2[MaskReg.Num+1]:='ALL MASKS';
                PullColor:=Color2.Setting;
                Sel3:=SelectMenuS(PWinX,2,1,MaskReg.Num+1,76,0,MaskReg.Num+1,MaskMenu2,
                                  MaskTitle2,'Select Unmask region',MaskReg.Num);
                if Sel3>=0 then begin
                  DebugBody:=True;
                  if Sel3=MaskReg.Num then for i:=1 to MaskReg.Num do SelMenu(i-1,76,MaskMenu2);
                  for i:=MaskReg.Num downto 1 do if Menued(i-1,76,MaskMenu2) then begin
                      for j:=i to MaskReg.Num-1 do MaskReg.Body[j]:=MaskReg.Body[j+1];
                      MaskReg.Body[MaskReg.Num]:=MaskReg.Body[0];
                      Dec(MaskReg.Num);
                  end;
                end;
              end;
         end;
     end;
end;

end.
