(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(*  I|oC葱C|Draw|j| *)

unit MDraw;

interface

uses Crt,PullMenu,GRA2Crt,Variable,Dialog,Display,GDraw,GUI,DosCall;

Type Real=Double;

function DrawBody(Sel:Integer;Auto:Boolean):Boolean;

implementation

Const

   MergeMenu: array [0..5] of String[18+8] =
       ('Left margin(.1mm):',
        'Top  margin(.1mm):',
        'Region size(.1mm):',
        'Determine all     ',
        'Merge GRA file   :',
        'Delete            ');

function DrawBody(Sel:Integer;Auto:Boolean):Boolean;

var
    i,Fst,Sel2,Sel3,InPos:Integer;
    OutSet:ByteSet;
    Dr:Boolean;
    S1:String[15];
    MergeFil : array [0..9] of String[14];
    Fil:PathStr;
    xx,yy:array [0..1] of Integer;

const
    Path:PathStr='*.GRA';

begin
     SelectMode(True,False,False,True);
     DrawBody:=False;
     case Sel of

       0: begin
             DGSYS.Device:=0;
             if Auto and (FilePar.Num<>0) then begin
                 Fst:=1;
                 OutSet:=[1..FilePar.Num];
             end else if FilePar.Num<>0 then begin
                 Fst:=SelectFile(False,OutSet,'DRAW');
                 if Fst<=0 then Fst:=-1;
             end else begin
                 Fst:=0;
                 OutSet:=[];
             end;
             if Fst>=0 then Dr:=Draw(Fst,OutSet,True);
          end;

       1: begin
            ClearScreen;
            StartGraph;
            ClrScr2;
            StopGraph;
          end;

       2: begin
            StartGraph;
            ClrScr2;
            FileDisp2;
            Verify(1,THeight,HitAny);
            StopGraph;
          end;

       3: begin
          end;

       4: begin
            PullColor:=Color2.Menu2;
            SelectMenuSFirst(PWinX,PWinY+5,1,10,14,0,10);
            repeat
               for i:=0 to 9 do begin
                   Str(i:1,S1);
                   MergeFil[i]:=S1+':'+MakeFileName(Merge[i].Fil);
               end;
               Sel2:=SelectMenuSNext(MergeFil,'','');
               if Sel2>=0 then begin
                   PullColor:=Color2.Setting;
                   SelectMenuSFirst(PWinX,PWinY+Sel2+1,1,6,18+8,4,6);
                   repeat
                       SetMenuVal(0,18+8,MergeMenu,Merge[Sel2].X,1,0);
                       SetMenuVal(1,18+8,MergeMenu,Merge[Sel2].Y,1,0);
                       SetMenuVal(2,18+8,MergeMenu,Merge[Sel2].Size,1,0);
                       Fil:=MakeFileName(Merge[Sel2].Fil);
                       SetMenuVal(4,18+8,MergeMenu,Fil,6,8);
                       Sel3:=SelectMenuSNext(MergeMenu,'','');
                       case Sel3 of
                         0:  ValInput(PWinX+19,PWinY+1,'NEW VALUE(0~2100/0.1mm)',Merge[Sel2].X,1,0,2100);
                         1:  ValInput(PWinX+19,PWinY+2,'NEW VALUE(0~2100/0.1mm)',Merge[Sel2].Y,1,0,2100);
                         2:  ValInput(PWinX+19,PWinY+3,'NEW VALUE(1~2100/0.1mm)',Merge[Sel2].Size,1,1,2100);
                         3:  begin
                               ClrScr2;
                               StartGraph;
                               SetGauge;
                               xx[0]:=Mm2dot(Merge[Sel2].x);
                               yy[0]:=Mm2dot(Merge[Sel2].y);
                               xx[1]:=Mm2dot(Merge[Sel2].Size);
                               yy[1]:=Mm2dot(Merge[Sel2].Size);
                               i:=0;
                               repeat
                                   if i=0 then InPos:=InputPos('ʒuw',False,False,False,xx[0],yy[0],xx[1],yy[1],1,
                                                               0,0,PaperSize,PaperSize)
                                          else InPos:=InputPos('TCYw',False,False,True,xx[1],yy[1],xx[0],yy[0],5,
                                                               0,0,PaperSize,PaperSize);
                                   if (InPos=-2) and (i>0) then Dec(i)
                                   else if InPos>0 then Inc(i);
                               until (InPos=-1) or (i=2);
                               if (InPos<>-1) then begin
                                    Merge[Sel2].x:=Dot2mm(xx[0]);
                                    Merge[Sel2].y:=Dot2mm(yy[0]);
                                    Merge[Sel2].Size:=Dot2mm(xx[1]);
                               end;
                               SetGauge;
                               StopGraph;
                            end;
                         4: if GetFileName(PWinX+19,PWinY+5,Fil,Path,'.GRA','GRA FILE') then Merge[Sel2].Fil:=Fil;
                         5: Merge[Sel2]:=Merge[10];
                       end;
                       if Merge[Sel2].x+Merge[Sel2].Size>2100 then Merge[Sel2].Size:=2100-Merge[Sel2].x;
                       if Merge[Sel2].y+Merge[Sel2].Size>2100 then Merge[Sel2].Size:=2100-Merge[Sel2].y;
                       if Merge[Sel2].Size<=0 then Merge[Sel2].Size:=1;
                   until (Sel3<0) or (Sel3=5);
                   SelectMenuSEnd;
                end;
            until (Sel2<0);
            SelectMenuSEnd;
          end;

     end;
end;

end.
