(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I|oC葱C|Graph|j| *)

unit Mgraph;

interface

uses PullMenu,Gra2Crt,GraGraph,Variable,GUI,Display;

Type Real=Double;

function  FormatBody(Sel:Integer):Boolean;

implementation

const
StyleMenu : array [0..2] of String[7]=
   ('Section',
    'Frame  ',
    'Cross  ' );
PositionMenu: array [0..4] of String[18+5] =
   ('Left margin(.1mm):',
    'Top  margin(.1mm):',
    'X    width (.1mm):',
    'Y    width (.1mm):',
    'Determine all     ' );
CharMenu :array [0..13] of String[21+20]=
   ('Graph title (normal):',
    'Axis  title (normal):',
    'Legend str  (normal):',
    'Scale(Xaxis)(normal):',
    'Scale(Yaxis)(normal):',
    'Scale(Uaxis)(normal):',
    'Scale(Raxis)(normal):',
    'Graph title (script):',
    'Axis  title (script):',
    'Legend str  (script):',
    'Scale(Xaxis)(script):',
    'Scale(Yaxis)(script):',
    'Scale(Uaxis)(script):',
    'Scale(Raxis)(script):' );
Char2Menu :array [0..5] of String[10+10]=
   ('Font     :',
    ' :',
    'Size (pt):',
    'Space(pt):',
    'Attribute:',
    'Color    :');
FontMenu :array [0..2] of String[10]=
   ('Times     ',
    'Helvetica ',
    'Courier   ');
JpnFontMenu :array [0..1] of String[10]=
   ('      ',
    '޼     ');
BoldMenu :array [0..3] of String[10]=
   ('Roman     ',
    'Bold      ',
    'Italic    ',
    'BoldItalic');
SizeMenu :array [0..7] of String[6]=
   ('10 pt ',
    '12 pt ',
    '16 pt ',
    '20 pt ',
    '24 pt ',
    '30 pt ',
    '36 pt ',
    'Manual');

SwitchMenu:array [0..6] of String[13+5]=
   ('Draw X-axis :',
    'Draw Y-axis :',
    'Draw U-axis :',
    'Draw R-axis :',
    'Plot data   :',
    'Write legend:',
    'Merge graph :');

function FormatBody(Sel:Integer):Boolean;

var a,i,Sel0,Sel2,Sel3,Sel4,Sel5,Sel6:Integer;
    xx,yy:array [0..1] of Integer;
    SelFile :ByteSet;
    Font,JFont,FSize,Space,Typ,Col:Integer;
    XlogSave,YlogSave:Boolean;
    Str0:String;
begin
    if Sel in [0,2] then SelectMode(True,True,False,True)
                    else SelectMode(True,False,False,True);
    FormatBody:=False;
    case Sel of
        0: begin
             PullColor:=Color2.Menu2;
             Sel2:=SelectAMenu(PWinX,PWinY+1,1,3,7,NGRAPH.GraphTyp,3,StyleMenu,'','');
             if Sel2>=0 then NGRAPH.GraphTyp:=Sel2;
           end;
        1: begin
             PullColor:=Color2.Setting;
             SelectMenuSFirst(PWinX,PWinY+2,1,5,18+5,0,5);
             repeat
                SetMenuVal(0,18+5,PositionMenu,NGRAPH.ViewX1,1,0);
                SetMenuVal(1,18+5,PositionMenu,NGRAPH.ViewY1,1,0);
                SetMenuVal(2,18+5,PositionMenu,NGRAPH.Sizex,1,0);
                SetMenuVal(3,18+5,PositionMenu,NGRAPH.Sizey,1,0);
                Sel2:=SelectMenuSNext(PositionMenu,'','');
                case Sel2 of
                  0:  ValInput(PWinX+19,PWinY+1,'NEW VALUE(0~2100/0.1mm)',NGRAPH.ViewX1,1,0,2100);
                  1:  ValInput(PWinX+19,PWinY+2,'NEW VALUE(0~2100/0.1mm)',NGRAPH.ViewY1,1,0,2100);
                  2:  ValInput(PWinX+19,PWinY+3,'NEW VALUE(1~2100/0.1mm)',NGRAPH.Sizex,1,1,2100);
                  3:  ValInput(PWinX+19,PWinY+4,'NEW VALUE(1~2100/0.1mm)',NGRAPH.Sizey,1,1,2100);
                  4:  begin
                        ClrScr2;
                        StartGraph;
                        SetGauge;
                        i:=0;
                        xx[0]:=Mm2dot(NGRAPH.Viewx1);
                        yy[0]:=Mm2dot(NGRAPH.Viewy1);
                        xx[1]:=Mm2dot(NGRAPH.Sizex);
                        yy[1]:=Mm2dot(NGRAPH.Sizey);
                        repeat
                            if i=0 then a:=InputPos('Otʒuw(1)',False,False,False,xx[0],yy[0],xx[1],yy[1],1,
                                                    0,0,PaperSize,PaperSize)
                                   else a:=InputPos('Otʒuw(2)',False,False,True,xx[1],yy[1],xx[0],yy[0],4,
                                                    0,0,PaperSize,PaperSize);
                            if (a=-2) and (i>0) then Dec(i)
                            else if a>0 then Inc(i);
                        until (a=-1) or (i=2);
                        if (a<>-1) then begin
                             NGRAPH.ViewX1:=Dot2mm(xx[0]);
                             NGRAPH.ViewY1:=Dot2mm(yy[0]);
                             NGRAPH.Sizex:=Dot2mm(xx[1]);
                             NGRAPH.Sizey:=Dot2mm(yy[1]);
                        end;
                        SetGauge;
                        StopGraph;
                     end;
                end;
                if NGRAPH.ViewX1+NGRAPH.Sizex>2100 then NGRAPH.Sizex:=2100-NGRAPH.ViewX1;
                if NGRAPH.ViewY1+NGRAPH.Sizey>2100 then NGRAPH.Sizey:=2100-NGRAPH.ViewY1;
                if NGRAPH.Sizex<=0 then NGRAPH.Sizex:=1;
                if NGRAPH.Sizey<=0 then NGRAPH.Sizey:=1;
             until (Sel2<0);
             SelectMenuSEnd;
          end;
        2:begin
          end;
        3:begin
            PullColor:=Color2.Menu2;
            SelectMenuSFirst(PWinX,PWinY+4,1,14,21+20,0,14);
            repeat
                for i:=0 to 6 do begin
                   SetMenuVal(i,21+20,CharMenu,NGRAPH.Aattr[i],6,20);
                   SetMenuVal(i+7,21+20,CharMenu,NGRAPH.ASattr[i],6,20);
                end;
                Sel2:=SelectMenuSNext(CharMenu,'','');
                if Sel2>=0 then begin
                    PullColor:=Color2.Setting;
                    SelectMenuSFirst(PWinX,PWinY+Sel2+1,1,6,10+10,0,6);
                    if Sel2<=6 then a:=nGetTextStyle(NGRAPH.Aattr[Sel2],Font,JFont,FSize,Space,Typ,Col)
                               else a:=nGetTextStyle(NGRAPH.ASattr[Sel2-7],Font,JFont,FSize,Space,Typ,Col);
                    repeat
                        if Font in [Times,Helvetica] then SetMenuVal(0,10+10,Char2Menu,FontMenu[Font],6,10)
                        else if Font=Courier then SetMenuVal(0,10+10,Char2Menu,FontMenu[2],6,10);
                        SetMenuVal(1,10+10,Char2Menu,JpnFontMenu[JFont-2],6,10);
                        SetMenuVal(2,10+10,Char2Menu,FSize,1,0);
                        SetMenuVal(3,10+10,Char2Menu,Space,1,0);
                        SetMenuVal(4,10+10,Char2Menu,BoldMenu[Typ],6,10);
                        Str0:=Copy(ColMenu[Col],3,8);
                        SetMenuVal(5,10+10,Char2Menu,Str0,6,8);
                        Sel3:=SelectMenuSNext(Char2Menu,'','');
                        case Sel3 of
                          0: begin
                               PullColor:=Color2.Setting2;
                               if Font in [Times,Helvetica] then 
                                   Sel4:=SelectAMenu(PWinX+11,PWinY+1,1,3,10,Font,3,FontMenu,'','')
                               else if Font=Courier then 
                                   Sel4:=SelectAMenu(PWinX+11,PWinY+1,1,3,10,2,3,FontMenu,'','');
                               if (Sel4>=0) then begin
                                   if Sel4 in [0,1] then Font:=Sel4
                                   else if Sel4=2 then Font:=4;
                               end;
                             end;
                          1: begin
                               PullColor:=Color2.Setting2;
                               Sel4:=SelectAMenu(PWinX+11,PWinY+2,1,2,10,JFont-2,2,JpnFontMenu,'','');
                               if (Sel4>=0) then JFont:=Sel4+2;
                             end;
                          2: begin
                               PullColor:=Color2.Setting2;
                               case FSize of
                                   10: a:=0;
                                   12: a:=1;
                                   16: a:=2;
                                   20: a:=3;
                                   24: a:=4;
                                   30: a:=5;
                                   36: a:=6;
                                   else a:=7;
                                end;
                                Sel4:=SelectAMenu(PWinX+11,PWinY+3,1,8,6,a,8,SizeMenu,'','');
                                if (Sel4>=0) then
                                    case Sel4 of
                                       0: FSize:=10;
                                       1: FSize:=12;
                                       2: FSize:=16;
                                       3: FSize:=20;
                                       4: FSize:=24;
                                       5: FSize:=30;
                                       6: FSize:=36;
                                       7: ValInput(PWinX+11,PWinY+3,'SIZE(Pt)',FSize,1,1,99);
                                    end;
                             end;
                          3: ValInput(PWinX+11,PWinY+4,'SPACE(Pt)',Space,1,-99,99);
                          4: begin
                               PullColor:=Color2.Setting2;
                               Sel4:=SelectAMenu(PWinX+11,PWinY+5,1,4,10,Typ,4,BoldMenu,'','');
                               if (Sel4>=0) then Typ:=Sel4;
                             end;
                          5: begin
                               PullColor:=Color2.Setting2;
                               Sel4:=SelectAMenu(PWinX+11,PWinY+6,1,8,10,Col,8,ColMenu,'','');
                               if Sel4>=0 then Col:=Sel4;
                             end;
                        end;
                    until (Sel3<0);
                    SelectMenuSEnd;
                    Str0:=nGetTextCode(Font,JFont,FSize,Space,Typ,Col);
                    if Sel2<=6 then NGRAPH.Aattr[Sel2]:=Str0
                               else NGRAPH.ASattr[Sel2-7]:=Str0;
                end;
            until (Sel2<0);
            SelectMenuSEnd;
          end;
        4:begin
            PullColor:=Color2.Setting;
            SelectMenuSFirst(PWinX,PWinY+5,1,7,13+5,0,7);
            repeat
                for i:=0 to 3 do SetMenuVal(i,13+5,SwitchMenu,AxisPar[i].ScMode,5,0);
                for i:=0 to 2 do SetMenuVal(i+4,13+5,SwitchMenu,NGRAPH.DrawMode[i],5,0);
                Sel2:=SelectMenuSNext(SwitchMenu,'','');
                case Sel2 of
                  0..3: toggle(AxisPar[Sel2].ScMode);
                  4..6: toggle(NGRAPH.DrawMode[Sel2-4]);
                end;
            until (Sel2<0);
            SelectMenuSEnd;
          end;
    end;
end;

end.
