(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I|oC葱 |Option|Legend|j| *)

unit MLegend;

interface

uses Crt,Gra2Crt,GraGraph,PullMenu,Variable,GUI,GDraw,Display;

Type Real=Double;

procedure LegendBody;

implementation

const
LegendMenu: array [0..3] of String[6]  =
   ('Title ',
    'String',
    'Dot   ',
    'Arrow ');
TitleMenu : array [0..6] of String[9]=
   ('Graph-1  ',
    'Graph-2  ',
    'X-axis   ',
    'Y-axis   ',
    'U-axis   ',
    'R-axis   ',
    'All clear');
RemarkMenu  : array [0..4] of String[13+8]=
   ('eLXg:',
    '`    :',
    ' u  ',
    ' Q    ',
    ' ~@@');
RemarkMenu2  : array [0..1] of String[4]=
   ('',
    '' );
LegendDotMenu: array [0..8] of String[13+10] =
   ('hbg^Cv:',
    'CJ|:',
    'C`  :',
    'C    :',
    'hbgTCY:',
    '_Ԋu    :',
    ' u  ',
    ' Q    ',
    ' ~@@  ');
LegendDotMenu2 : array [0..28] of String[14] =
   ('A:     | ',
    'B: p `  ',
    'C: Spline  ` ',
    'D: Spline  Z ',
    'H:   _      ',
    'I:     E ',
    'J:      ',
    'K:@    ',
    'L:  @ E',
    'M:d  ',
    'N:d E',
    'O: l p  ',
    'P: l p  ',
    'Q: l p E',
    'R: H `  ',
    'S: H `  ',
    'T: H ` E',
    'U: O p  ',
    'V: O p  ',
    'W: O p E',
    'X: t O  ',
    'Y: t O  ',
    'Z: t O E',
    'a:\@   { ',
    'b:    _ ~ ',
    'c: p  ^ ',
    'l:  `  ',
    'm:  `  ',
    'n:  ` E');
ArrowMenu: array [0..6] of String[13+8] =
   ('[(.1mm):',
    'CJ|:',
    'C`  :',
    'C    :',
    ' u  ',
    ' Q    ',
    ' ~@@  ');

procedure LegendBody;
var    Remark2 : array[1..22] of String[30];

      procedure SetStringMenu;
      var i:Integer;
      begin
        for i:=1 to 20 do begin
                Str(i:2,Remark2[i]);
                Remark2[i]:=Remark2[i]+':'+Remark[i].Str;
        end;
        Remark2[21]:='ALL CLEAR';
      end;

      procedure SetDotMenu;
      var i,a:Integer;
          Str1,Str2:String[6];
      begin
        for i:=1 to 20 do begin
            Str(i:2,Remark2[i]);
            Remark2[i]:=Remark2[i]+':';
            if Dot[i].ActivNum>0 then begin
                Remark2[i]:=Remark2[i]+LegendDotMenu2[Dot[i].Typ];
                Str(Dot[i].x[0]/100:3:0,Str1);
                Str(Dot[i].y[0]/100:3:0,Str2);
                Remark2[i]:=Remark2[i]+'('+Str1+'mm,'+Str2+'mm)';
            end;
        end;
        Remark2[21]:='ALL CLEAR';
      end;

      procedure SetArrowMenu;
      var i:Integer;
          Str1,Str2,Str3,Str4:String[6];
      begin
        for i:=1 to 20 do begin
            Str(i:2,Remark2[i]);
            Remark2[i]:=Remark2[i]+':';
            if Arrow[i].Act then begin
                Str(Arrow[i].sx/100:3:0,Str1);
                Str(Arrow[i].ex/100:3:0,Str2);
                Str(Arrow[i].sy/100:3:0,Str3);
                Str(Arrow[i].ey/100:3:0,Str4);
                Remark2[i]:=Remark2[i]+'('+Str1+'mm,'+Str2+'mm)-('+Str3+'mm,'+Str4+'mm)';
            end;
        end;
        Remark2[21]:='ALL CLEAR';
      end;

var
    Sel2,Sel3,Sel4,Sel5,i,j,a,InPos:Integer;
    H,W,Len:Integer;
    xx,yy:array [0..9] of Integer;
    Str0:String;
    Ref:Boolean;
    Remark0:RemarkTypeBody;
    Dot0:DotTypeBody;
    Arrow0:ArrowTypeBody;
    WInput:Boolean;
    OutSet:ByteSet;

const Position1:Integer=0;
      Position2:Integer=0;
      Position3:Integer=0;
      Position4:Integer=0;
begin
    SelectMode(True,True,False,True);
    PullColor:=Color2.Menu2;
    SelectMenuSFirst(PWinX,PWinY+1,1,4,6,0,4);
    SelectMode(True,False,False,True);
    repeat
        Sel2:=SelectMenuSNext(LegendMenu,'','');
        PullColor:=Color2.Menu3;
        case Sel2 of
            0:begin
                SelectMenuSFirst(PWinX,PWinY+1,1,7,9,Position1,7);
                repeat
                    Sel3:=SelectMenuSNext(TitleMenu,'','');
                    if (Sel3>=0) and (Sel3<>6) then begin
                      Str0:=Title[Sel3].Str;
                      OutSet:=[Sel3];
                      repeat
                        PullColor:=Color2.WindowInput;
                        Winput:=WindowInput(PWinX,PWinY+Sel3+1,40,Str0,'TITLE','');
                        if Winput then begin
                            if Length(Str0)=0 then begin
                                CommentOut(True,1,OutSet);
                                Title[Sel3].Str:='';
                            end else begin
                                CommentOut(False,1,OutSet);
                                ClrScr2;
                                StartGraph;
                                SetGauge;
                                CommentPosition(Sel3,xx[0],yy[0]);
                                if (Sel3 in [0,1]) then a:=0
                                else if (Sel3 in [2..5]) then a:=1;
                                nTextSize(H,W,Str0,NGRAPH.Aattr[a],NGRAPH.ASattr[a],1);
                                if Sel3 in [0..2,4] then begin
                                    xx[1]:=W;
                                    yy[1]:=-H
                                end else begin
                                    xx[1]:=-H;
                                    yy[1]:=-W;
                                end;
                                InPos:=InputPos('eLXgʒuw',False,False,False,xx[0],yy[0],xx[1],yy[1],1,
                                                0,0,PaperSize,PaperSize);
                                if InPos<>-1 then begin
                                    CommentOut(True,1,OutSet);
                                    CommentPosition2(Sel3,xx[0],yy[0]);
                                    Title[Sel3].Str:=Str0;
                                    CommentOut(False,1,OutSet);
                                    Verify(1,THeight,HitAny);
                                end;
                                SetGauge;
                                StopGraph;
                            end;
                        end;
                      until not Winput or (Length(Str0)=0) or (Inpos>=0);
                      Position1:=Sel3;
                    end else if (Sel3=6) and (InputYN(PWinX,PWinY+Sel3+1,'Really All Clear? (Y/N)') in ['Y','y'])
                    then begin
                        for i:=0 to 5 do begin
                            OutSet:=[i];
                            CommentOut(True,1,OutSet);
                            Title[i].Str:='';
                        end;
                        Position1:=0;
                    end;
                until Sel3<0;
                SelectMenuSEnd;
              end;

            1:begin
                SelectMenuSFirst(PWinX,PWinY+1,1,21,30,Position2,21);
                repeat
                   SetStringMenu;
                   Sel3:=SelectMenuSNext(Remark2,'Legend String','');
                   if (Sel3>=0) and (Sel3<>20) then begin
                       Ref:=False;
                       OutSet:=[Sel3+1];
                       PullColor:=Color2.Setting;
                       SelectMenuSFirst(PWinX,PWinY+Sel3+1,1,5,13+8,0,5);
                       Remark0:=Remark[Sel3+1];
                       repeat
                           SetMenuVal(0,13+8,RemarkMenu,Remark0.Str,6,8);
                           SetMenuVal(1,13+8,RemarkMenu,RemarkMenu2[Remark0.Dir],6,4);
                           Sel4:=SelectMenuSNext(RemarkMenu,'','');
                           case Sel4 of
                             0: begin
                                  PullColor:=Color2.WindowInput;
                                  WInput:=WindowInput(PWinX+14,PWinY+1,40,Remark0.Str,'STRING','');
                                end;
                             1: if Remark0.Dir=0 then Remark0.Dir:=1
                                                 else Remark0.Dir:=0;
                             2: begin
                                  ClrScr2;
                                  StartGraph;
                                  SetGauge;
                                  nTextSize(H,W,Remark0.Str,NGRAPH.Aattr[2],NGRAPH.ASattr[2],1);
                                  if Remark0.dir=0 then begin
                                       xx[1]:=W;
                                       yy[1]:=-H
                                  end else begin
                                       xx[1]:=-H;
                                       yy[1]:=-W;
                                  end;
                                  InPos:=InputPos('eLXgʒuw',False,False,False,Remark0.x,Remark0.y,xx[1],yy[1],1,
                                                  0,0,PaperSize,PaperSize);
                                end;
                             3: begin
                                  PullColor:=Color2.Menu3;
                                  SetStringMenu;
                                  Sel5:=SelectAMenu(PWinX+14,PWinY+5,1,20,30,Sel3,20,Remark2,'Legend String','');
                                  if Sel5>=0 then Remark0:=Remark[Sel5+1];
                                end;
                             4: Remark0:=Remark[0];
                           end;
                           if (Sel4<0) or (Sel4=4) or (Sel4=3) and (Sel5>=0) or (Sel4=2) and (InPos<>-1) then begin
                               if not Ref then RemarkOut(True,1,OutSet)
                                          else Ref:=False;
                               Remark[Sel3+1]:=Remark0;
                               RemarkOut(False,1,OutSet);
                               if (Sel4=2) then Verify(1,THeight,HitAny)
                               else if (Sel4=3) and (Sel5<>Sel3) then Ref:=True;
                           end;
                           if (Sel4=2) then begin
                               SetGauge;
                               StopGraph;
                           end;
                       until (Sel4<0) or (Sel4=4);
                       SelectMenuSEnd;
                       Position2:=Sel3;
                   end else if (Sel3=20) and (InputYN(PWinX,PWinY+21,'Really All Clear? (Y/N)') in ['Y','y']) then begin
                       for i:=1 to 20 do begin
                           OutSet:=[i];
                           RemarkOut(True,1,OutSet);
                           Remark[i]:=Remark[0];
                       end;
                       Position2:=0;
                   end;
                until Sel3<0;
                SelectMenuSEnd;
              end;

            2:begin
                SelectMenuSFirst(PWinX,PWinY+1,1,21,30,Position4,21);
                repeat
                   SetDotMenu;
                   Sel3:=SelectMenuSNext(Remark2,'Legend Dot','');
                   if (Sel3>=0) and (Sel3<>20) then begin
                       OutSet:=[Sel3+1];
                       PullColor:=Color2.Setting;
                       SelectMenuSFirst(PWinX,PWinY+Sel3+1,1,9,13+10,0,9);
                       Dot0:=Dot[Sel3+1];
                       Ref:=False;
                       repeat
                           PullColor:=Color2.Setting2;
                           SetMenuVal(0,13+10,LegendDotMenu,LegendDotMenu2[Dot0.Typ],6,10);
                           Str0:=Copy(ColMenu[Dot0.Col],3,8);
                           SetMenuVal(1,13+10,LegendDotMenu,Str0,6,8);
                           Str0:=Copy(LineMenu[Dot0.Attr],3,8);
                           SetMenuVal(2,13+10,LegendDotMenu,Str0,6,8);
                           SetMenuVal(3,13+10,LegendDotMenu,Dot0.Width,1,0);
                           SetMenuVal(4,13+10,LegendDotMenu,Dot0.DotSize,1,0);
                           SetMenuVal(5,13+10,LegendDotMenu,Dot0.DottedSize,1,0);
                           Sel4:=SelectMenuSNext(LegendDotMenu,'','');
                           case Sel4 of
                             0: begin
                                  SelectMode(False,False,False,True);
                                  Sel5:=SelectAMenu(PWinX+14,PWinY+1,1,10,14,Dot0.Typ,29,LegendDotMenu2,'','');
                                  SelectMode(True,False,False,True);
                                  if Sel5>=0 then Dot0.Typ:=Sel5;
                                end;
                             1:begin
                                  Sel5:=SelectAMenu(PWinX+14,PWinY+2,1,8,10,Dot0.Col,8,ColMenu,'','');
                                  if Sel5>=0 then Dot0.Col:=Sel5;
                               end;
                             2: begin
                                  Sel5:=SelectAMenu(PWinX+14,PWinY+3,1,4,10,Dot0.Attr,4,LineMenu,'','');
                                  if Sel5>=0 then Dot0.Attr:=Sel5;
                                end;
                             3: begin
                                  if Dot0.Width=20 then a:=0
                                  else if Dot0.Width=40 then a:=1
                                  else a:=2;
                                  Sel5:=SelectAMenu(PWinX+14,PWinY+4,1,3,10,a,3,WidthMenu,'','');
                                  if Sel5>=0 then begin
                                      case Sel5 of
                                        0: Dot0.Width:=20;
                                        1: Dot0.Width:=40;
                                        2: ValInput(PWinX+14,PWinY+4,'NEW VALUE(1~1000/0.01mm)',Dot0.Width,1,1,1000);
                                      end;
                                  end;
                               end;
                             4: ValInput(PWinX+14,PWinY+5,'NEW VALUE(1~2000/0.1mm)',Dot0.DotSize,1,1,2000);
                             5: ValInput(PWinX+14,PWinY+6,'NEW VALUE(1~1000/0.1mm)',Dot0.DottedSize,1,1,1000);
                             6:begin
                                ClrScr2;
                                StartGraph;
                                SetGauge;
                                for i:=0 to 9 do begin
                                    xx[i]:=Dot0.x[i];
                                    yy[i]:=PaperSize-Dot0.y[i];
                                end;
                                i:=0;
                                if Dot0.Typ in [0..3] then begin
                                    repeat
                                        if (i>=2) then SetLineXor(xx[i-1],yy[i-1],xx[i-2],yy[i-2]);
                                        if i=0 then InPos:=InputPos('CR ݂̂Ŏwp',False,True,False,xx[0],
                                                                    yy[0],0,0,2,0,0,PaperSize,PaperSize)
                                               else InPos:=InputPos('CR ݂̂Ŏwp',False,True,True,xx[i],yy[i],xx[i-1],
                                                                    yy[i-1],3,0,0,PaperSize,PaperSize);
                                        if (InPos=-2) and (i>0) then begin
                                            if (i>=2) then SetLineXor(xx[i-1],yy[i-1],xx[i-2],yy[i-2]);
                                            Dec(i);
                                            if (i>=2) then SetLineXor(xx[i-1],yy[i-1],xx[i-2],yy[i-2]);
                                        end else if (InPos>0) or (InPos=-1) then Inc(i);
                                    until (InPos=-1) or (InPos=2) and (i>1) or (i=10);
                                    for j:=i-1 downto 2 do SetLineXor(xx[j-1],yy[j-1],xx[j-2],yy[j-2]);
                                end else if Dot0.Typ in [4..24] then begin
                                    InPos:=InputPos('}|Nʒuw',False,False,False,xx[0],yy[0],0,0,2,
                                                    0,0,PaperSize,PaperSize);
                                    i:=1;
                                end else if Dot0.Typ=25 then begin
                                    repeat
                                        if i=0 then InPos:=InputPos('w(1)',False,False,False,xx[0],yy[0],0,0,2,
                                                                    0,0,PaperSize,PaperSize)
                                               else InPos:=InputPos('w(2)',False,False,True,xx[i],yy[i],xx[i-1],
                                                                    yy[i-1],3,0,0,PaperSize,PaperSize);
                                        if (InPos=-2) and (i>0) then Dec(i)
                                        else if InPos>0 then Inc(i);
                                    until (InPos=-1) or (i=2);
                                end else begin
                                    repeat
                                        if i=0 then InPos:=InputPos('`ʒuw(1)',False,False,False,xx[0],yy[0],xx[1],
                                                                    yy[1],0,0,0,PaperSize,PaperSize)
                                               else InPos:=InputPos('`ʒuw(2)',False,False,True,xx[1],yy[1],xx[0],
                                                                    yy[0],0,0,0,PaperSize,PaperSize);
                                        if (InPos=-2) and (i>0) then Dec(i)
                                        else if InPos>0 then Inc(i);
                                    until (InPos=-1) or (i=2);
                                end;
                                if InPos<>-1 then begin
                                   Dot0.ActivNum:=i;
                                   for j:=Dot0.ActivNum to 9 do begin
                                       Dot0.x[j]:=Dot[0].x[j];
                                       Dot0.y[j]:=Dot[0].y[j];
                                   end;
                                   for i:=0 to Dot0.ActivNum-1 do begin
                                       Dot0.x[i]:=xx[i];
                                       Dot0.y[i]:=PaperSize-yy[i];
                                   end;
                                end;
                               end;
                             7:begin
                                  PullColor:=Color2.Menu3;
                                  SetDotMenu;
                                  Sel5:=SelectAMenu(PWinX+14,PWinY+9,1,20,30,Sel3,20,Remark2,'Legend Dot','');
                                  if Sel5>=0 then Dot0:=Dot[Sel5+1];
                                end;
                             8:Dot0:=Dot[0];
                           end;
                           if (Sel4<0) or (Sel4=8) or (Sel4=7) and (Sel5>=0) or (Sel4=6) and (InPos<>-1) then begin
                               if not Ref then DotOut(True,OutSet)
                                          else Ref:=False;
                               Dot[Sel3+1]:=Dot0;
                               DotOut(False,OutSet);
                               if (Sel4=6) then Verify(1,THeight,HitAny)
                               else if (Sel4=7) and (Sel5<>Sel3) then Ref:=True;
                           end;
                           if (Sel4=6) then begin
                               SetGauge;
                               StopGraph;
                           end;
                       until (Sel4<0) or (Sel4=8);
                       SelectMenuSEnd;
                       Position4:=Sel3;
                   end else if (Sel3=20) and (InputYN(PWinX,PWinY+21,'Really All Clear? (Y/N)') in ['Y','y']) then begin
                       for i:=1 to 20 do begin
                           OutSet:=[i];
                           DotOut(True,OutSet);
                           Dot[i]:=Dot[0];
                       end;
                       Position4:=0;
                   end;
                until Sel3<0;
                SelectMenuSEnd;
              end;

           3: begin
                SelectMenuSFirst(PWinX,PWinY+1,1,21,30,Position3,21);
                repeat
                   SetArrowMenu;
                   Sel3:=SelectMenuSNext(Remark2,'Legend Arrow','');
                   if (Sel3>=0) and (Sel3<>20) then begin
                       OutSet:=[Sel3+1];
                       PullColor:=Color2.Setting;
                       SelectMenuSFirst(PWinX,PWinY+Sel3+1,1,7,13+8,0,7);
                       Arrow0:=Arrow[Sel3+1];
                       Ref:=False;
                       repeat
                           PullColor:=Color2.Setting2;
                           Len:=Dot2mm(Arrow0.Len);
                           SetMenuVal(0,13+8,ArrowMenu,Len,1,0);
                           Str0:=Copy(ColMenu[Arrow0.Col],3,8);
                           SetMenuVal(1,13+8,ArrowMenu,Str0,6,8);
                           Str0:=Copy(LineMenu[Arrow0.Attr],3,8);
                           SetMenuVal(2,13+8,ArrowMenu,Str0,6,8);
                           SetMenuVal(3,13+8,ArrowMenu,Arrow0.Width,1,0);
                           Sel4:=SelectMenuSNext(ArrowMenu,'','');
                           case Sel4 of
                             0: begin
                                  ValInput(PWinX+14,PWinY+1,'NEW VALUE(0~500/0.1mm)',Len,1,0,500);
                                  Arrow0.Len:=Mm2Dot(Len);
                                end;
                             1:begin
                                  Sel5:=SelectAMenu(PWinX+14,PWinY+2,1,8,10,Arrow0.Col,8,ColMenu,'','');
                                  if Sel5>=0 then Arrow0.Col:=Sel5;
                               end;
                             2: begin
                                  Sel5:=SelectAMenu(PWinX+14,PWinY+3,1,4,10,Arrow0.Attr,4,LineMenu,'','');
                                  if Sel5>=0 then Arrow0.Attr:=Sel5;
                                end;
                             3: begin
                                  if Arrow0.Width=20 then a:=0
                                  else if Arrow0.Width=40 then a:=1
                                  else a:=2;
                                  Sel5:=SelectAMenu(PWinX+14,PWinY+4,1,3,10,a,3,WidthMenu,'','');
                                  if Sel5>=0 then begin
                                      case Sel5 of
                                        0: Arrow0.Width:=20;
                                        1: Arrow0.Width:=40;
                                        2: ValInput(PWinX+14,PWinY+4,'NEW VALUE(1~1000/0.01mm)',Arrow0.Width,1,1,1000);
                                      end;
                                  end;
                               end;
                             4:begin
                                 ClrScr2;
                                 StartGraph;
                                 SetGauge;
                                 xx[0]:=Arrow0.sx;
                                 yy[0]:=Arrow0.sy;
                                 xx[1]:=Arrow0.ex;
                                 yy[1]:=Arrow0.ey;
                                 i:=0;
                                 repeat
                                     if i=0 then InPos:=InputPos('n_w',False,False,False,xx[0],yy[0],0,0,2,
                                                                 0,0,PaperSize,PaperSize)
                                            else InPos:=InputPos('I[w',False,False,True,xx[i],yy[i],xx[i-1],yy[i-1],3,
                                                                 0,0,PaperSize,PaperSize);
                                     if (InPos=-2) and (i>0) then Dec(i)
                                     else if InPos>0 then Inc(i);
                                 until (InPos=-1) or (i=2);
                                 if (InPos<>-1) then begin
                                     Arrow0.Act:=True;
                                     Arrow0.sx:=xx[0];
                                     Arrow0.sy:=yy[0];
                                     Arrow0.ex:=xx[1];
                                     Arrow0.ey:=yy[1];
                                 end;
                               end;
                             5:begin
                                  PullColor:=Color2.Menu3;
                                  SetArrowMenu;
                                  Sel5:=SelectAMenu(PWinX+14,PWinY+7,1,20,30,Sel3,20,Remark2,'Legend Arrow','');
                                  if Sel5>=0 then Arrow0:=Arrow[Sel5+1];
                                end;
                             6:Arrow0:=Arrow[0];
                           end;
                           if (Sel4<0) or (Sel4=6) or (Sel4=5) and (Sel5>=0) or (Sel4=4) and (InPos<>-1) then begin
                               if not Ref then ArrowOut(True,OutSet)
                                          else Ref:=False;
                               Arrow[Sel3+1]:=Arrow0;
                               ArrowOut(False,OutSet);
                               if (Sel4=4) then Verify(1,THeight,HitAny)
                               else if (Sel4=5) and (Sel5<>Sel3) then Ref:=True;
                           end;
                           if (Sel4=4) then begin
                               SetGauge;
                               StopGraph;
                           end;
                       until (Sel4<0) or (Sel4=6);
                       SelectMenuSEnd;
                       Position3:=Sel3;
                   end else if (Sel3=20) and (InputYN(PWinX,PWinY+21,'Really All Clear? (Y/N)') in ['Y','y']) then begin
                       for i:=1 to 20 do begin
                           OutSet:=[i];
                           ArrowOut(True,OutSet);
                           Arrow[i]:=Arrow[0];
                       end;
                       Position3:=0;
                   end;
                until Sel3<0;
                SelectMenuSEnd;
              end;
        end;
    until (Sel2<0);
    SelectMenuSEnd;
  end;

end.


