(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* I|oC葱C|Scale|j| *)

unit MScale;

interface

uses Gra2Crt,PullMenu,Data,DataScal,Variable,Display,GUI,GraGraph;

Type Real=Double;

procedure ScalingBody(Sel:Integer);

implementation

const

   ScaleMenu2: array [0..6] of String[10+15]=('Minimum  :',
					      'Maximum  :',
					      'Increment:',
					      'Division :',
                                              'Scaling  :',
                                              'File      ',
					      'Clear     ' );

   ScalingMenu:array [0..2] of String[8]=('0:Linear',
                                          '1:Log   ',
                                          '2:Invert');

   AxisMenu :array[0..4] of String[6]=('X-axis',
                                       'Y-axis',
                                       'U-axis',
                                       'R-axis',
                                       'ALL   ');

procedure ScalingBody(Sel:Integer);

    procedure ScaleSet(Axis:Integer);
    var S:String[15];
        Sel2,Sel3,Sel4,Sel5,Sel6,fst,i,a:Integer;
        SSctype,SSctypex,SSctypey:Integer;
        sminx,sminy,smaxx,smaxy:Real;
        SelFile:ByteSet;
        Str0:String;
        Error,WInput:Boolean;
    begin
       With AxisPar[Sel] do begin
         PullColor:=Color2.Setting;
         SelectMenuSFirst(PWinX,PWinY+Axis+1,1,7,10+15,0,7);
         repeat
           ConvScale(False,ScType,Min,Max,Scale);
           if SetMin then Str(Min:15,S)
                     else S:='---------------';
           SetMenuVal(0,10+15,ScaleMenu2,S,6,15);
           if SetMax then Str(Max:15,S)
                     else S:='---------------';
           SetMenuVal(1,10+15,ScaleMenu2,S,6,15);
           if SetScale then Str(Scale:15,S)
                       else S:='---------------';
           ConvScale(True,ScType,Min,Max,Scale);
           SetMenuVal(2,10+15,ScaleMenu2,S,6,15);
           SetMenuVal(3,10+15,ScaleMenu2,ScDiv,5,0);
           SetMenuVal(4,10+15,ScaleMenu2,ScalingMenu[ScType],6,8);
           Sel2:=SelectMenuSNext(ScaleMenu2,'','');
           case Sel2 of
             0: begin
                  Error:=ConvData(False,ScType,Min);
                  Winput:=WindowInputReal(PWinX+11,PWinY+1,'NEW VALUE',Min,4);
                  Error:=ConvData(True,ScType,Min);
                  if Winput then begin
                      SetMin:=True;
                      CheckMinMax(ScType,Min,Max,SetMin,SetMax);
                      CheckScale(ScType,Min,Max,Scale,SetScale);
                  end;
                end;
             1: begin
                  Error:=ConvData(False,ScType,Max);
                  Winput:=WindowInputReal(PWinX+11,PWinY+2,'NEW VALUE',Max,4);
                  Error:=ConvData(True,ScType,Max);
                  if Winput then begin
                      SetMax:=True;
                      CheckMinMax(ScType,Min,Max,SetMin,SetMax);
                      CheckScale(ScType,Min,Max,Scale,SetScale);
                  end;
                end;
             2: begin
                  Error:=ConvData(False,ScType,Scale);
                  Winput:=WindowInputReal(PWinX+11,PWinY+3,'NEW VALUE',Scale,4);
                  Error:=ConvData(True,ScType,Scale);
                  if Winput then begin
                      SetScale:=True;
                      CheckMinMax(ScType,Min,Max,SetMin,SetMax);
                      CheckScale(ScType,Min,Max,Scale,SetScale);
                  end;
                end;
             3: ValInput(PWinX+11,PWinY+4,'NEW VALUE(1~50 <A>uto)',ScDiv,5,1,50);
             4: begin
                  PullColor:=Color2.Setting2;
                  SScType:=ScType;
                  Sel3:=SelectAMenu(PWinX+11,PWinY+5,1,3,8,ScType,3,ScalingMenu,'','');
                  if Sel3>=0 then ScType:=Sel3;
                  if ScType<>SScType then begin
                      Min:=-1;
                      Max:=1;
                      Scale:=1;
                      SetMin:=False;
                      SetMax:=False;
                      SetScale:=False;
                  end;
                end;
             5: if FilePar.Num>0 then begin
                  fst:=SelectFile(True,SelFile,'SCALING FILE');
                  if fst>=0 then begin
                      SSctypex:=AxisPar[FilePar.Body[fst].Axisx*2].Sctype;
                      SSctypey:=AxisPar[FilePar.Body[fst].Axisy*2+1].Sctype;
                      AxisPar[FilePar.Body[fst].Axisx*2].Sctype:=Sctype;
                      AxisPar[FilePar.Body[fst].Axisy*2+1].Sctype:=Sctype;
                      GetMinMax(fst,sminx,sminy,smaxx,smaxy);
                      AxisPar[FilePar.Body[fst].Axisx*2].Sctype:=SSctypex;
                      AxisPar[FilePar.Body[fst].Axisy*2+1].Sctype:=SSctypey;
                      if DataNum>=0 then begin
                          if Axis in [0,2] then begin
                              SetAutoMinMax(ScType,sminx,smaxx,Min,Max,False,False,ScAuto[1]);
                              SetAutoScale(ScType,Min,Max,Scale,False)
                          end else begin
                              SetAutoMinMax(ScType,sminy,smaxy,Min,Max,False,False,ScAuto[1]);
                              SetAutoScale(ScType,Min,Max,Scale,False);
                          end;
                      end;
                      SetMin:=True;
                      SetMax:=True;
                      SetScale:=True;
                  end;
                end;
             6: begin
                  Min:=-1;
                  Max:=1;
                  Scale:=1;
                  SetMin:=False;
                  SetMax:=False;
                  SetScale:=False;
                end;
           end;
         until (Sel2<0);
         SelectMenuSEnd;
       end;
    end;

var Sel2,i,k:Integer;
    zr,mid,maxim,minim:Real;
    Ch:Char;
    WInput:Boolean;
    a,sx,sy,ex,ey:Integer;
    gx1,gy1,gx2,gy2,gsizex,gsizey:Integer;
begin
      SelectMode(True,False,False,True);

      case Sel of

      0..3: ScaleSet(Sel);
         4: begin
              zr:=2;
              if WIndowInputReal(PWinX,PWinY+5,'Zooming Rate',zr,4) then begin
                  if zr=0 then zr:=1;
                  PullColor:=Color2.Setting;
                  for i:=0 to 4 do ClrMenu(i,6,AxisMenu);
                  Sel2:=SelectMenuS(PWinX,PWinY+5,1,5,6,4,5,AxisMenu,'','',4);
                  if Sel2>=0 then begin
                      if Sel2=4 then for i:=0 to 3 do SelMenu(i,6,AxisMenu);
                      for i:=0 to 3 do if Menued(i,6,AxisMenu) then With AxisPar[i] do begin
                          if SetMin and SetMax then begin
                               mid:=(Max+Min)*0.5;
                               minim:=(Min-mid)*zr+mid;
                               maxim:=(Max-mid)*zr+mid;
                               SetAutoMinMax(ScType,minim,maxim,Min,Max,False,False,'N');
                               SetAutoScale(ScType,Min,Max,Scale,False);
                               SetScale:=True;
                          end;
                      end;
                  end;
              end;
            end;
	 5: begin
		 ClrScr2;
		 StartGraph;
                 nGetGraphPosition(gx1,gy1,gx2,gy2,gsizex,gsizey);
		 sx:=gX1+gSizex Div 4;
		 sy:=gY1+(gSizey Div 4)*3;
		 ex:=gX1+(gSizex Div 4)*3;
		 ey:=gY1+gSizey Div 4;
                 i:=0;
                 repeat
                     if i=0 then a:=InputPos('ݸވʒuw(1)',False,False,False,sx,sy,ex,ey,0,0,0,PaperSize,PaperSize)
                            else a:=InputPos('ݸވʒuw(2)',False,False,True,ex,ey,sx,sy,0,0,0,PaperSize,PaperSize);
                     if (a=-2) and (i>0) then Dec(i)
                     else if a>0 then Inc(i);
                 until (a=-1) or (i=2);
                 if (a<>-1) then begin
                     PullColor:=Color2.Setting;
                     for i:=0 to 4 do ClrMenu(i,6,AxisMenu);
                     Sel2:=SelectMenuS(1,3,1,5,6,4,5,AxisMenu,'','',4);
                     if Sel2>=0 then begin
                         if Sel2=4 then for i:=0 to 3 do SelMenu(i,6,AxisMenu);
                         for i:=0 to 3 do if Menued(i,6,AxisMenu) then With AxisPar[i] do begin
                             if SetMin and SetMax then begin
                                 if i in [0,2] then begin
                                     minim:=Min+(Max-Min)/gSizex*(sx-gX1);
                                     maxim:=Min+(Max-Min)/gSizex*(ex-gX1);
                                 end else begin
                                     minim:=Min+(Max-Min)/gSizey*(gY2-sy);
                                     maxim:=Min+(Max-Min)/gSizey*(gY2-ey);
                                 end;
                                 SetAutoMinMax(ScType,minim,maxim,Min,Max,False,False,'N');
                                 SetAutoScale(ScType,Min,Max,Scale,False);
                                 SetScale:=True;
                             end;
                         end;
                     end;
                 end;
		 StopGraph;
	      end;

	  6:  begin
                PullColor:=Color2.Setting;
                for i:=0 to 4 do ClrMenu(i,6,AxisMenu);
                Sel2:=SelectMenuS(PWinX,PWinY+7,1,5,6,4,5,AxisMenu,'','',4);
                if Sel2>=0 then begin
                    if Sel2=4 then for i:=0 to 3 do SelMenu(i,6,AxisMenu);
                    for i:=0 to 3 do if Menued(i,6,AxisMenu) then With AxisPar[i] do begin
                        Min:=-1;
                        Max:=1;
                        Scale:=1;
                        SetMin:=False;
                        SetMax:=False;
                        SetScale:=False;
                    end;
                end;
	      end;

   end;

end;

end.
