(* Ngraph, draw a graph for PC-9801    *)
(* Copyright (c) S.Ishizaka. 1990-1991 *)

(* v_Ej|葱 *)
(* PullReadKey, ChgPullKey 葱@ˑ(L|R|hH) *)

unit PullMenu;

interface

uses Windows,Messages,Sort,SysUtils,Jctype,Crt,DOSCall;

Type WinEnvType = record
                    TSize:Integer;
                    TExtra:Integer;
                    TFont:String;
                  end;

     PullMenuColor=record
            Frame,Title,Title2,Back,Bar,Sel,SelBar,First,Shadow:Word;
     end;

     PullMenuKey = Record
            ESC,BS,CR,UP,DOWN,LEFT,RIGHT,
            HOME,HOMES,ROLLUP,ROLLDOWN,DEL:Char;
     end;

     CharSet=Set of Char;

     SelectModeType=record
            Roll,Letter,UpDownOnly,Frame:Boolean;
     end;

     ByteArray = array [0..$2000] of Byte;
     ByteArrayPo = ^ ByteArray;
     StringPo = ^ String;

     DgWinPo = ^DgWin;

     DgWin = record
       Wnd:HWND;
       Edit:Boolean;
       Ln:Integer;
       KanjiInput,NewInput:Boolean;
       KanjiByte:Integer;
       X,Y,Width,Height:Integer;
       PullMode:SelectModeType;
       Color:PullMenuColor;
       Start,Position:Integer;
       Row,Line,Len:Integer;
       Select:Integer;
       Shift:Boolean;
       KeyInput:Integer;
       KeyCode:Integer;
       FinCode:set of Char;
       Menu:ByteArrayPo;
       Title1,Title2:String;
       Maxnum:Integer;
       Font:HFONT;
       FHeight,FWidth:Integer;
       Next: DgWinPo;
     end;

     WindowXY = record x,y,h,w:Byte end;

var MainWin:DgWin;
    WinEnv  : WinEnvType;
Const BufferSize = 128;

const PullColor :PullMenuColor=(Frame :White + Reverse ;
                                Title :White + Reverse ;
                                Title2:White + Reverse ;
                                Back  :White + Reverse;
                                Bar   :Yellow + Reverse ;
                                Sel   :Yellow + Reverse ;
                                SelBar:Magenta + Reverse ;
                                First :White ;
                                Shadow:0 );

const PullKey : PullMenuKey = (
                  ESC  :Char($1B);
                  BS   :Char($08);
                  CR   :Char($0D);
                  UP   :Char($05);
                  DOWN :Char($18);
                  LEFT :Char($13);
                  RIGHT:Char($04);
                  HOME :Char($01);
                  HOMES:Char($06);
                  ROLLUP  :Char($12);
                  ROLLDOWN:Char($03);
                  DEL     :Char($07) );

const PullMode:SelectModeType
      =(Roll:True; Letter:True; UpDownOnly:False; Frame:True);

const DgWinRoot:DgWinPo=NIL;

const SetWndClass:Boolean=False;
const szDgClassName:PChar='DGWIN';

const
  FWidth:Integer=0;
  FHeight:Integer=0;
  PullX:Integer=1;
  PullY:Integer=1;
  XSHIFT:Integer=0;

procedure CheckEscape(var Key:Word);
function  PWinX:Integer;
function  PWinY:Integer;
function  PWinH:Integer;
function  PWinW:Integer;
procedure DgSdisp(dc:HDC;Win:DgWinPo;p,mode:Integer);
Procedure DgSelect2(Win:DgWinPo;Code:Integer);
function GetDgWindow:DgWinPo;
procedure SetColor(dc:HDC;Col:Word);
procedure PullReadKey(var Key:Word;var Shift,Ctrl,Grph:Boolean);
//procedure ChgPullKey(Key:Word;var Ch,Ch2:Char);
procedure SetPullColor(Col:PullMenuColor);
procedure FWild(var Path:PathStr;var Dir:DirStr;var Name:NameStr;var Ext:ExtStr;AddExt:ExtStr);
procedure OpenWindow(x,y,Width,Height:Integer);
procedure CloseWindow;
procedure MakeFrame(Title1,Title2:String);
procedure PullWriteXY2(dc:HDC;x,y:Integer;S:String;Col:Word);
procedure PullWrite2(dc:HDC;S:String;Col:Word);
procedure PutStr2(dc:HDC;x,y,len:Integer;S:String;Attr1,Attr2:Word);
procedure MakeFrameXY2(dc:HDC;X,Y,W,H:Integer;FrameCol,TitleCol,TitleCol2,Shadow:Word;Title1,Title2:String);
procedure ClearFrameXY2(dc:HDC;X,Y,W,H,BackCol:Integer);
procedure PullWriteXYW(x,y:Integer;S:String;Col:Word);
procedure PullWrite(S:String;Col:Word);
procedure PutStr(x,y,len:Integer;S:String;Attr1,Attr2:Word);
procedure MakeFrameXY(X,Y,W,H:Integer;FrameCol,TitleCol,TitleCol2,Shadow:Word;Title1,Title2:String);
procedure ClearFrameXY(X,Y,W,H,BackCol:Integer);
procedure ClearFrame;
function  SelectAFile(x,y,Row,Line:Integer;var Path:PathStr;Title:String):PathStr;
procedure SelectFileSFirst(x,y,Row,Line:Integer;PathS:PathStr);
function  SelectFileSNext(var PathS:PathStr;Title:String;var Shift:Boolean):PathStr;
procedure SelectFileSEnd;
procedure SelMenu(Num,Len:Integer;var Menu);
procedure ClrMenu(Num,Len:Integer;var Menu);
function  Menued(Num,Len:Integer;var Menu):Boolean;
procedure SetMenu(Num,Len:Integer;var Menu;Item:String);
procedure SelectMode(RollMode,LetterMode,UpDownOnlyMode,FrameMode:Boolean);
function  SelectAMenu(x,y,Row,Line,Len,Position,Maxnum:Integer;var Menu;Title1,Title2:String):Integer;
function  SelectMenuS(x,y,Row,Line,Len,Position,Maxnum:Integer;var Menu;Title1,Title2:String;Fin:Integer):Integer;
procedure SelectMenuSFirst(x,y,Row,Line,Len,Position,Maxnum:Integer);
function  SelectMenuSNext(var Menu;Title1,Title2:String):Integer;
function  SelectMenuSNextS(var Menu;Title1,Title2:String;Fin:Integer):Integer;
procedure SelectMenuSDisp(Start,Position:Integer;var Menu;Title1,Title2:String);
procedure SelectMenuSEnd;
function  WindowInputChar(x,y:Integer;Str,Title1,Title2:String;Fin:CharSet):Char;
function  WindowInput(x,y,Len:Integer;var Str:String;Title1,Title2:String):Boolean;
procedure PullQuitNull;
procedure SetMenuString(Row,Line,Len,Position,Maxnum:Integer;var Menu);

Var PullQuit:Procedure;

implementation

type FNameStr = String[13];

     DirectoryBuffer=record
       Po    :Pointer;
       Path  :PathStr;
       FileNum:Integer;
       Buf  :array [0..BufferSize-1] of FNameStr;
     end;

     InputBuffer=record
       Po    :Pointer;
       Lin,Leng,Max:Integer;
     end;

const DBufPo   :Pointer=nil;

const CStart:Integer=0;
      CPosition:Integer=0;
      CRow:Integer=1;

function GetColor(Col:Word):COLORREF;
begin
  case Col and $FF of
  Black: GetColor:=RGB(0,0,0);
  Blue: GetColor:=RGB(0,0,255);
  Red: GetColor:=RGB(255,0,0);
  Magenta: GetColor:=RGB(255,0,255);
  Green: GetColor:=RGB(0,255,0);
  Cyan: GetColor:=RGB(0,255,255);
  Yellow: GetColor:=RGB(255,255,0);
  White: GetColor:=RGB(255,255,255);
  else GetColor:=RGB(0,0,0);
  end;
end;

procedure SetColor(dc:HDC;Col:Word);
begin
  if (Col and Reverse)<>0 then begin
    SetTextColor(dc,RGB(0,0,0));
    SetBkColor(dc,GetColor(Col));
  end else begin
    SetTextColor(dc,GetColor(Col));
    SetBkColor(dc,RGB(0,0,0));
  end;
end;

procedure DgSdisp(dc:HDC;Win:DgWinPo;p,mode:Integer);
var rect:TRECT;
    brush:HBRUSH;
    smode:Integer;
    Sel:Boolean;
    FWidth,FHeight:Integer;
    S:Array[0..255] of Char;
    a,x,y,h:Integer;
    Buf:ByteArrayPo;
    Slen:Integer;
    Col:Word;
    orgfont:HFONT;
begin
  SetTextAlign(dc,TA_BOTTOM or TA_LEFT);
  SetTextCharacterExtra(dc,WinEnv.TExtra);
  orgfont:=SelectObject(dc,Win^.Font);
  FWidth:=Win^.FWidth;
  FHeight:=Win^.FHeight;
  if Win^.PullMode.Frame then h:=1
  else h:=0;
  x:=(p mod Win^.Row)*(Win^.Len+2)+h+XShift;
  y:=(p div Win^.Row)+h;
  Buf:=Win^.Menu;
  if (Buf<>NIL) and (p+Win^.Start<Win^.MaxNum) then begin
    a:=(p+Win^.Start)*(Win^.Len+1);
    Sel:=(Buf^[a] and $80)<>0;
    case mode of
    0: if Sel then Col:=Win^.Color.Sel
       else Col:=Win^.Color.Back;
    1: if Sel then Col:=Win^.Color.SelBar
       else Col:=Win^.Color.Bar;
    end;
    SetColor(dc,Col);
    Slen:=Buf^[a] and $7F;
    Move(Buf^[a+1],S[0],Win^.Len);
    FillChar(S[Slen],Win^.Len-Slen,' ');
    rect.top:=FHeight*y;
    rect.bottom:=FHeight*(y+1);
    rect.left:=FWidth*x;
    rect.right:=FWidth*(x+1);
    ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,' ',1,NIL);
    if (mode=0) and not Sel and (Win^.PullMode.Letter) then begin
      SetColor(dc,Win^.Color.First);
      rect.left:=FWidth*(x+1);
      rect.right:=FWidth*(x+2);
      ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,@S,1,NIL);
      SetColor(dc,Col);
      rect.left:=FWidth*(x+2);
      rect.right:=FWidth*(x+1+Win^.Len);
      ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,@S[1],Win^.Len-1,NIL);
    end else begin
      rect.left:=FWidth*(x+1);
      rect.right:=FWidth*(x+1+Win^.Len);
      ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,@S,Win^.Len,NIL);
    end;
    rect.left:=FWidth*(x+1+Win^.Len);
    rect.right:=FWidth*(x+2+Win^.Len);
    ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,' ',1,NIL);
  end else begin
    SetColor(dc,Win^.Color.Back);
    brush:=CreateSolidBrush(GetBkColor(dc));
    rect.left:=FWidth*x;
    rect.right:=FWidth*(x+Win^.Len+2)+1;
    rect.top:=FHeight*y;
    rect.bottom:=FHeight*(y+1);
    FillRect(dc,rect,brush);
    DeleteObject(brush);
  end;
  SelectObject(dc,orgfont);
end;

procedure DgWdisp(dc:HDC;Win:DgWinPo);
var Ch2,Ch3:Char;
    S:StringPo;
    S2:String;
    rect:TRect;
    FHeight,FWidth:Integer;
    pen,spen:HPEN;
    orgfont:HFONT;
begin
  SetTextAlign(dc,TA_BOTTOM or TA_LEFT);
  SetTextCharacterExtra(dc,WinEnv.TExtra);
  orgfont:=SelectObject(dc,Win^.Font);
  FWidth:=Win^.FWidth;
  FHeight:=Win^.FHeight;
  S:=StringPo(Win^.Menu);
  Ch2:=S^[Win^.Start];
  if IsKanji2(S^,Win^.Start) then S^[Win^.Start]:=' ';
  if Win^.Start+Win^.Len<=256 then begin
      Ch3:=S^[Win^.Start+Win^.Len-1];
      if IsKanji2(S^,Win^.Start+Win^.Len) then S^[Win^.Start+Win^.Len-1]:=' ';
  end;
  SetColor(dc,Win^.Color.Back);
  rect.top:=FHeight;
  rect.bottom:=FHeight*2;
  rect.left:=FWidth;
  rect.right:=FWidth*2;
  if Win^.Start<>1 then
    ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,'<',1,NIL)
  else
    ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,' ',1,NIL);
  if not Win^.NewInput then begin
    SetColor(dc,Win^.Color.Sel);
    if Win^.Ln<Win^.Len then begin
      S2:=Copy(S^,Win^.Start,Win^.Ln);
      rect.left:=FWidth*2;
      rect.right:=FWidth*(2+Win^.Ln);
      ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,@S2[1],Win^.Ln,NIL);
      SetColor(dc,Win^.Color.Back);
      S2:=Copy(S^,Win^.Start+Win^.Ln,Win^.Len-Win^.Ln);
      rect.left:=FWidth*(2+Win^.Ln);
      rect.right:=FWidth*(2+Win^.Len);
      ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,@S2[1],Win^.Len-Win^.Ln,NIL);
    end else begin
      S2:=Copy(S^,Win^.Start,Win^.Len-1);
      rect.left:=FWidth*2;
      rect.right:=FWidth*(2+Win^.Len-1);
      ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,@S2[1],Win^.Len-1,NIL);
    end;
  end else begin
    S2:=Copy(S^,Win^.Start,Win^.Len);
    rect.left:=FWidth*2;
    rect.right:=FWidth*(2+Win^.Len);
    ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,@S2[1],Win^.Len,NIL);
  end;
  SetColor(dc,Win^.Color.Back);
  rect.left:=FWidth*(2+Win^.Len);
  rect.right:=FWidth*(2+Win^.Len+1);
  ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,' ',1,NIL);
  rect.left:=FWidth*(2+Win^.Len+1);
  rect.right:=FWidth*(2+Win^.Len+2);
  if Win^.Ln-Win^.Start>=Win^.Len then
    ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,'>',1,NIL)
  else
    ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,' ',1,NIL);
  S^[Win^.Start]:=Ch2;
  if Win^.Start+Win^.Len<=256 then S^[Win^.Start+Win^.Len-1]:=Ch3;
  SetColor(dc,Win^.Color.Back);
  pen:=CreatePen(PS_SOLID,0,GetTextColor(dc));
  spen:=SelectObject(dc,pen);
  rect.left:=FWidth*(2+Win^.Position-Win^.Start);
  MoveToEx(dc,rect.left,rect.top+1,NIL);
  LineTo(dc,rect.left,rect.bottom-1);
  MoveToEx(dc,rect.left+1,rect.top+1,NIL);
  LineTo(dc,rect.left+1,rect.bottom-1);
  SelectObject(dc,spen);
  DeleteObject(pen);
  SelectObject(dc,orgfont);
end;

procedure DgFrameDisp(dc:HDC;Win:DgWinPo);
var rect:TRECT;
    brush2,sbrush:HBRUSH;
    pen1,spen:HPEN;
    FWidth,FHeight,len:Integer;
    orgfont:HFONT;
begin
  if not Win^.PullMode.Frame then exit;
  SetTextAlign(dc,TA_BOTTOM or TA_LEFT);
  SetTextCharacterExtra(dc,WinEnv.TExtra);
  orgfont:=SelectObject(dc,Win^.Font);
  FWidth:=Win^.FWidth;
  FHeight:=Win^.FHeight;
  len:=Win^.len;
  SetColor(dc,Win^.Color.Frame);
  brush2:=CreateSolidBrush(GetBkColor(dc));
  pen1:=CreatePen(PS_SOLID,0,GetBkColor(dc));
  sbrush:=SelectObject(dc,brush2);
  spen:=SelectObject(dc,pen1);
  Rectangle(dc,FWidth*(Win^.Width+1),FHeight,FWidth*(Win^.Width+2)+1,FHeight*(Win^.Height+1)+1);
  Rectangle(dc,-1,FHeight,FWidth+1,FHeight*(Win^.Height+1)+1);
  Rectangle(dc,-1,-1,FWidth*(Win^.Width+2)+1,FHeight+1);
  Rectangle(dc,-1,FHeight*(Win^.Height+1),FWidth*(Win^.Width+2)+1,FHeight*(Win^.Height+1+1)+1);
  SelectObject(dc,sbrush);
  SelectObject(dc,spen);
  DeleteObject(brush2);
  DeleteObject(pen1);
  brush2:=GetStockObject(NULL_BRUSH);
  pen1:=CreatePen(PS_SOLID,0,GetTextColor(dc));
  sbrush:=SelectObject(dc,brush2);
  spen:=SelectObject(dc,pen1);
  Rectangle(dc,FWidth div 2,FHeight div 2,
               FWidth*(Win^.Width+2)-FWidth div 2,FHeight*(Win^.Height+1+1)-FHeight div 2);
  SelectObject(dc,sbrush);
  SelectObject(dc,spen);
  DeleteObject(brush2);
  DeleteObject(pen1);
  if not Win^.Edit then begin
    if Win^.Start<>0 then begin
      rect.top:=FHeight;
      rect.bottom:=FHeight*(1+1);
      rect.left:=FWidth*(Win^.Width+1);
      rect.right:=FWidth*(Win^.Width+2);
      ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,'+',1,NIL);
    end;
    if Win^.Start+Win^.Row*Win^.Height<Win^.MaxNum then begin
      rect.top:=FHeight*(Win^.Height+1-1);
      rect.bottom:=FHeight*(Win^.Height+1);
      rect.left:=FWidth*(Win^.Width+1);
      rect.right:=FWidth*(Win^.Width+2);
      ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,'+',1,NIL);
    end;
  end;
  SetColor(dc,Win^.Color.Title);
  len:=Length(Win^.Title1);
  if len<>0 then begin
    rect.top:=0;
    rect.bottom:=FHeight;
    rect.left:=FWidth;
    rect.right:=FWidth*(len+1);
    ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,PChar(@(Win^.Title1[1])),len,NIL);
  end;
  SetColor(dc,Win^.Color.Title2);
  len:=Length(Win^.Title2);
  if len<>0 then begin
    rect.top:=FHeight*(Win^.Height+1);
    rect.bottom:=FHeight*(Win^.Height+1+1);
    rect.left:=FWidth;
    rect.right:=FWidth*(len+1);
    ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,PChar(@(Win^.Title2[1])),len,NIL);
  end;
  SelectObject(dc,orgfont);
end;

function Select(DispOnly:Boolean;var Shift:Boolean;MaxNum:Integer;var Buf;Len:Integer):Integer;
var msg:TMsg;
    Win:DgWinPo;
    dc:HDC;
    i,j:Integer;
    Wnd:HWND;
begin
  Win:=GetDgWindow;
  if Win=NIL then exit;
  Win^.Start:=CStart;
  Win^.Position:=CPosition;
  Win^.Menu:=@ByteArray(Buf);
  Win^.Maxnum:=Maxnum;
  Win^.Len:=Len;
  CRow:=Win^.Width div (Win^.Len+2);
  Win^.Row:=CRow;
  dc:=GetDC(Win^.Wnd);
  for i:=0 to Win^.Height-1 do
    for j:=0 to Win^.Row-1 do
      DgSdisp(dc,Win,i*Win^.Row+j,0);
  DgSdisp(dc,Win,Win^.Position-Win^.Start,1);
  DgFrameDisp(dc,Win);
  ReleaseDC(Win^.Wnd,dc);
  if not DispOnly then begin;
    Win^.KeyInput:=0;
    Wnd:=GetFocus;
    SetFocus(Win^.Wnd);
    while Win^.KeyInput=0 do begin
      if GetMessage(msg,0,0,0) then begin
        TranslateMessage(msg);
        DispatchMessage(msg);
      end;
    end;
    SetFocus(Wnd);
  end;
  Shift:=Win^.Shift;
  Select:=Win^.Select;
  CStart:=Win^.Start;
  CPosition:=Win^.Position;
end;

Procedure DgSelect2(Win:DgWinPo;Code:Integer);
var
  i,j:Integer;
  Buf:ByteArrayPo;
  shift:Integer;
begin
  shift:=GetAsyncKeyState(VK_SHIFT);
  if (shift and $8000)<>0 then Win^.Shift:=True
  else Win^.Shift:=False;
  Buf:=Win^.Menu;
  case Code of
  VK_UP:
    begin
      if Win^.Position>=Win^.Row then Dec(Win^.Position,Win^.Row)
      else if Win^.PullMode.Roll then begin
        if ((Win^.MaxNum-1) mod Win^.Row)>=Win^.Position then
         Inc(Win^.Position,Win^.Maxnum-(Win^.Maxnum-1) mod Win^.Row-1)
        else Win^.Position:=Win^.Maxnum-1;
      end;
    end;
  VK_DOWN:
    begin
      if Win^.Position<Win^.MaxNum-Win^.Row then Inc(Win^.Position,Win^.Row)
      else if (Win^.MaxNum-Win^.Start-1) div Win^.Row>=Win^.Height then
        Inc(Win^.Start,Win^.Row)
      else if Win^.PullMode.Roll then
        Win^.Position:=Win^.Position mod Win^.Row;
    end;
  VK_LEFT:
    begin
      if (not Win^.PullMode.UpDownOnly) then begin
        if Win^.Position>0 then Dec(Win^.Position)
        else if Win^.PullMode.Roll then Win^.Position:=Win^.Maxnum-1;
      end;
    end;
  VK_RIGHT:
    begin
      if (not Win^.PullMode.UpDownOnly) then begin
        if Win^.Position<Win^.MaxNum-1 then Inc(Win^.Position)
        else if Win^.PullMode.Roll then Win^.Position:=0;
      end;
    end;
  VK_HOME:
    begin
      Win^.Position:=0;
    end;
  VK_END:
    begin
      Win^.Position:=Win^.Maxnum-1;
    end;
  VK_SCROLL or VK_DOWN:
    begin
      if Win^.Start<=Win^.MaxNum-(Win^.MaxNum-1) mod Win^.Row-1-Win^.Row*(2*Win^.Height-1) then begin
        Inc(Win^.Position,Win^.Row*Win^.Height);
        Inc(Win^.Start,Win^.Row*Win^.Height);
      end else begin
        Win^.Position:=Win^.Position mod Win^.Row+Win^.MaxNum-(Win^.MaxNum-1) mod Win^.Row-1;
        if Win^.Position>=Win^.MaxNum then Dec(Win^.Position,Win^.Row);
        Win^.Start:=Win^.MaxNum-(Win^.MaxNum-1) mod Win^.Row-1-Win^.Row*(Win^.Height-1);
        if Win^.Start<0 then Win^.Start:=0;
      end;
    end;
  VK_SCROLL or VK_UP:
    begin
      if Win^.Start>=(Win^.Row*Win^.Height) then begin
        Dec(Win^.Position,Win^.Row*Win^.Height);
        Dec(Win^.Start,Win^.Row*Win^.Height);
      end else begin
        Win^.Position:=Win^.Position mod Win^.Row;
        Win^.Start:=0;
      end;
    end;
  else
    begin
      i:=0;
      j:=Win^.Position+1;
      if j>=Win^.MaxNum then j:=0;
      while (Char(Code)<>UpCase(Char(Buf^[j*(Win^.Len+1)+1]))) and (i<Win^.Maxnum) do begin
        Inc(i);
        Inc(j);
        if j>=Win^.MaxNum then j:=0;
      end;
      if i<>Win^.MaxNum then begin
        if Win^.PullMode.Letter then Code:=VK_RETURN;
        Win^.Position:=j;
      end;
    end;
  end;
  while ((Win^.Position-Win^.Start) div Win^.Row)>=Win^.Height do
    Inc(Win^.Start,Win^.Row);
  while Win^.Position<Win^.Start do Dec(Win^.Start,Win^.Row);
  InvalidateRect(Win^.Wnd,NIL,False);
  if (Code=VK_RETURN) or (Code=VK_ESCAPE) or
  (Win^.PullMode.UpDownOnly and ((Code=VK_LEFT) or (Code=VK_RIGHT))) then begin
    Win^.KeyInput:=-1;
    if (Win^.Maxnum<=0) then Win^.Select:=-1
    else if (Code=VK_RETURN) then Win^.Select:=Win^.Position
    else if (Code=VK_ESCAPE) then Win^.Select:=-1
    else if (Code=VK_LEFT) then Win^.Select:=-2
    else if (Code=VK_RIGHT) then Win^.Select:=-3;
  end;
end;

Procedure DgSelect3(Win:DgWinPo;Code:Integer;iMessage:UINT);
var S:StringPo;
    i,j,d:Integer;
    C:Char;
begin
  S:=StringPo(Win^.Menu);
  if (iMessage=WM_KEYDOWN) then begin
    if Code=VK_LEFT then begin
        if Win^.Position>1 then begin
           Dec(Win^.Position);
           if IsKanji2(S^,Win^.Position) then Dec(Win^.Position);
        end;
        Win^.NewInput:=True;
    end else if Code=VK_RIGHT then begin
        if Win^.Position<=Win^.Ln then begin
            Inc(Win^.Position);
            if (Win^.Position<=Win^.Ln) and IsKanji2(S^,Win^.Position) then Inc(Win^.Position);
        end;
        Win^.NewInput:=True;
    end else if Code=VK_BACK then begin
        if Win^.Position>1 then begin
            if IsKanji2(S^,Win^.Position-1) then d:=2
                                            else d:=1;
            for j:=1 to d do begin
                Dec(Win^.Position);
                if Win^.Position<=Win^.Ln then Dec(Win^.Ln);
                if (Win^.Start>1) and (Win^.Ln-Win^.Start+2<Win^.Len) or (Win^.Position<Win^.Start) then Dec(Win^.Start);
                for i:=Win^.Position to 254 do S^[i]:=S^[i+1];
                S^[255]:=' ';
            end;
        end;
        Win^.NewInput:=True;
    end else if Code=VK_DELETE then begin
        if Win^.Position<=Win^.Ln then begin
            C:=Char(S^[Win^.Position]);
            if IsKanji(Word(C)) then d:=2
                                else d:=1;
            for j:=1 to d do
                if Win^.Position<=Win^.Ln then begin
                    Dec(Win^.Ln);
                    for i:=Win^.Position to 254 do S^[i]:=S^[i+1];
                    S^[255]:=' ';
                    if (Win^.Start>1) and (Win^.Ln-Win^.Start+2<Win^.Len) then Dec(Win^.Start);
                end;
        end;
        Win^.NewInput:=True;
    end else if Code in [VK_HOME,VK_UP] then begin
        Win^.Position:=1;
        Win^.Start:=1;
        Win^.NewInput:=True;
    end else if Code in [VK_DOWN,VK_END] then begin
        Win^.Position:=Win^.Ln+1;
        if Win^.Position>Win^.Len then Win^.Start:=Win^.Position-Win^.Len+1
                                  else Win^.Start:=1;
        Win^.NewInput:=True;
    end else if Code=VK_CLEAR then begin
        for i:=1 to 255 do S^[i]:=' ';
        Win^.Position:=1;
        Win^.Start:=1;
        Win^.Ln:=0;
        Win^.NewInput:=True;
    end;
  end else if (iMessage=WM_CHAR) then begin
    if Char(Code) in [' '..Chr($FF)] then begin
      if not Win^.NewInput then begin
          Win^.Position:=1;
          Win^.Start:=1;
          Win^.Ln:=0;
          FillChar(S^,Sizeof(S^),' ');
          S^[0]:=Chr(255);
      end;
      C:=Char(Code);
      if (Win^.KanjiByte<>1) and IsKanji(Word(C)) then Win^.KanjiByte:=1
      else if (Win^.KanjiByte=1) then Win^.KanjiByte:=2
      else Win^.KanjiByte:=0;
      if (Win^.Ln<254) and (Win^.Position<255) or ( (Win^.Ln=254) or (Win^.Position=255) ) and ( (Win^.KanjiByte=0) or Win^.KanjiInput ) then begin
          if Win^.KanjiByte=1 then Win^.KanjiInput:=True
                              else Win^.KanjiInput:=False;
          for i:=254 downto Win^.Position do S^[i+1]:=S^[i];
          S^[Win^.Position]:=Char(Code);
          if (Win^.Position>Win^.Ln) then Win^.Ln:=Win^.Position
                                     else Inc(Win^.Ln);
          Inc(Win^.Position);
      end;
    end;
    Win^.NewInput:=True;
  end;
  if Win^.Position>Win^.Ln then Win^.Position:=Win^.Ln+1;
  if Win^.Position<1 then Win^.Position:=1;
  if not Win^.KanjiInput and IsKanji2(S^,Win^.Position) then Dec(Win^.Position);
  if Win^.Position<Win^.Start then Win^.Start:=Win^.Position;
  if (Win^.Position-Win^.Start>=Win^.Len) then Win^.Start:=Win^.Position-Win^.Len+1;
  InvalidateRect(Win^.Wnd,NIL,False);
  if (iMessage=WM_KEYDOWN) and ((Code=VK_RETURN) or (Code=VK_ESCAPE)) then Win^.KeyInput:=-1;
end;

function DgWinProc(Wnd:HWND;iMessage:UINT;ParamW:WPARAM;ParamL:LPARAM): LRESULT; stdcall;
var Win,WinCur:DgWinPo;
    rc:TRECT;
    ps:TPaintStruct;
    dc:HDC;
    i,j,k:Integer;
    Menu:Pointer;
    Mode:Integer;
begin
  WinCur:=DgWinRoot;
  while (WinCur<>NIL) and (WinCur^.Wnd<>Wnd) do
    WinCur:=WinCur^.Next;
  Win:=WinCur;
  if Win=NIL then begin
    DgWinProc:=DefWindowProc(Wnd,iMessage,ParamW,ParamL);
    exit;
  end;
  DgWinProc:=0;
  case iMessage of
  WM_PAINT:
    begin
      if GetUpdateRect(Wnd,rc,FALSE) then begin
        dc:=BeginPaint(Wnd,ps);
        if not Win^.Edit then begin
          for i:=0 to Win^.Height-1 do
            for j:=0 to Win^.Row-1 do
              DgSdisp(dc,Win,i*Win^.Row+j,0);
          DgSdisp(dc,Win,Win^.Position-Win^.Start,1);
        end else DgWdisp(dc,Win);
        DgFrameDisp(dc,Win);
        EndPaint(Wnd,ps);
      end;
    end;
  WM_KEYDOWN,WM_CHAR:
    begin
      Win^.KeyCode:=ParamW;
      if Win^.KeyInput=0 then begin
        if not Win^.Edit then begin
          if iMessage=WM_KEYDOWN then DgSelect2(Win,Win^.KeyCode);
        end else DgSelect3(Win,Win^.KeyCode,iMessage);
      end else if (Win^.KeyInput=1) and (iMessage=WM_KEYDOWN) then begin
        if (Char(Win^.KeyCode) in Win^.FinCode) then Win^.KeyInput:=-1;
      end;
    end;
  else begin
    DgWinProc:=DefWindowProc(Wnd,iMessage,ParamW,ParamL);
    end;
  end;
end;

procedure OpenWindow(X,Y,Width,Height:Integer);
var Win,WinCur,WinPrev:DgWinPo;
    Wnd:HWND;
    dwStyle:DWORD;
    winx,winy,winwidth,winheight:Integer;
    dc:HDC;
    orgfont:HFONT;
    tm:TTextMetric;
    rect:TRect;
    Width2,Height2:Integer;
    IDFont:TLogFont;
    DgWc:TWndClass;
begin
  GetMem(Win,SizeOf(DgWin));
  if (Win=NIL) then exit;
  WinCur:=DgWinRoot;
  WinPrev:=NIL;
  while WinCur<>NIL do
  begin
    WinPrev:=WinCur;
    WinCur:=WinCur^.Next;
  end;
  if WinPrev=NIL then DgWinRoot:=Win
  else WinPrev^.Next:=Win;
  Win^.Next:=NIL;
  Win^.Wnd:=0;
  Win^.Edit:=False;
  Win^.Ln:=0;
  if PullMode.Frame then begin
      Width2:=Width+2;
      Height2:=Height+2;
  end else begin
      Width2:=Width;
      Height2:=Height;
  end;
  if x<1 then x:=1;
  if y<1 then y:=1;
  if x+Width2-1>TWidth then x:=TWidth-Width2+1;
  if y+Height2>THeight+1 then y:=THeight-Height2+1;
  Win^.X:=X;
  Win^.Y:=Y;
  Win^.Width:=Width;
  Win^.Height:=Height;
  Win^.PullMode:=PullMode;
  Win^.Color:=PullColor;
  Win^.Menu:=NIL;
  Win^.Maxnum:=0;
  Win^.Row:=CRow;
  Win^.Position:=CPosition;
  Win^.Start:=CStart;
  Win^.Len:=0;
  Win^.FinCode:=[];
  Win^.Title1:='';
  Win^.Title2:='';
  if (WinEnv.TFont='') or (WinEnv.TSize<=0) then begin
    Win^.Font:=GetStockObject(OEM_FIXED_FONT);
  end else begin
    IDFont.lfHeight:=WinEnv.TSize;
    IDFont.lfWidth:=0;
    IDFont.lfEscapement:=0;
    IDFont.lfOrientation:=0;
    IDFont.lfUnderline:=0;
    IDFont.lfStrikeOut:=0;
    IDFont.lfWeight:=fw_Normal;
    IDFont.lfItalic:=0;
    IDFont.lfPitchAndFamily:=Fixed_Pitch or ff_Modern;
    IDFont.lfCharset:=ShiftJIS_CharSet;
    IDFont.lfOutPrecision:=Out_Default_Precis;
    IDFont.lfClipPrecision:=Clip_Default_Precis;
    IDFont.lfQuality:=PROOF_QUALITY;
    StrCopy(@IDFont.lfFaceName,@WinEnv.TFont);
    Win^.Font:=CreateFontIndirect(IDFont);
  end;
  dc:=GetDC(HWND_DESKTOP);
  orgfont:=SelectObject(dc,Win^.Font);
  GetTextMetrics(dc,tm);
  SelectObject(dc,orgfont);
  ReleaseDC(HWND_DESKTOP,dc);
  Win^.FHeight:=tm.tmHeight+tm.tmDescent+tm.tmExternalLeading;
  win^.FWidth:=tm.tmAveCharWidth+WinEnv.TExtra;
  GetWindowRect(MainWin.Wnd,rect);
  winx:=Win^.FWidth*(x-1);
  winy:=Win^.FHeight*(y-1);
  winwidth:=Win^.FWidth*(width2)+GetSystemMetrics(SM_CXBORDER);
  winheight:=Win^.FHeight*(height2)+GetSystemMetrics(SM_CYBORDER);
  if not SetWndClass then begin
    DgWc.style      :=CS_SAVEBITS;
    DgWc.lpfnWndProc:=@DgWinProc;
    DgWc.cbClsExtra :=0;
    DgWc.cbWndExtra :=0;
    DgWc.hInstance  :=hInstance;
    DgWc.hIcon      :=0;
    DgWc.hCursor    :=0;
    DgWc.hbrBackground:=0;
    DgWc.lpszMenuName:=NIL;
    DgWc.lpszClassName:=szDgClassName;
    if (RegisterClass(DgWc)=0) then exit;
    SetWndClass:=TRUE;
  end;
  dwStyle:=WS_VISIBLE or WS_BORDER or WS_CHILD  or WS_CLIPSIBLINGS;
  Wnd:=CreateWindow(szDgClassName,NIL,dwStyle,
                    winx,winy,winwidth,winheight,
                    MainWin.Wnd,0,hInstance,NIL);
  SetWindowPos(Wnd,HWND_TOP,0,0,0,0,SWP_NOMOVE or SWP_NOSIZE or SWP_DRAWFRAME);
  if Wnd=0 then exit;
  Win^.Wnd:=Wnd;
end;

procedure CloseWindow;
var WinCur,WinPrev:DgWinPo;
begin
  if DgWinRoot=NIL then exit;
  WinCur:=DgWinRoot;
  WinPrev:=NIL;
  while WinCur.Next<>NIL do begin
    WinPrev:=WinCur;
    WinCur:=WinCur^.Next;
  end;
  if WinCur^.Wnd<>0 then DestroyWindow(WinCur^.Wnd);
  DeleteObject(WinCur^.Font);
  if WinPrev=NIL then DgWinRoot:=NIL
  else WinPrev^.Next:=NIL;
  FreeMem(WinCur);
  if WinPrev<>NIL then begin
    CStart:=WinPrev^.Start;
    CPosition:=WinPrev^.Position;
    CRow:=WinPrev^.Row;
  end;
end;

procedure MakeFrame(Title1,Title2:String);
var x,y,h:Integer;
    winwidth,winheight:Integer;
    rect:TRect;
    Win:DgWinPo;
    dc:HDC;
begin
  Win:=GetDgWindow;
  if Win=NIL then exit;
  Win^.Title1:=Title1;
  Win^.Title2:=Title2;
  dc:=GetDC(Win^.Wnd);
  DgFrameDisp(dc,Win);
  ReleaseDC(Win^.Wnd,dc);
end;

procedure SelectMode(RollMode,LetterMode,UpDownOnlyMode,FrameMode:Boolean);
begin
    PullMode.Roll:=RollMode;
    PullMode.Letter:=LetterMode;
    PullMode.UpDownOnly:=UpDownOnlyMode;
    PullMode.Frame:=FrameMode;
end;

procedure SelMenu(Num,Len:Integer;var Menu);
begin
     ByteArray(Menu)[Num*(Len+1)]:=ByteArray(Menu)[Num*(Len+1)] or $80;
end;

procedure ClrMenu(Num,Len:Integer;var Menu);
begin
     ByteArray(Menu)[Num*(Len+1)]:=ByteArray(Menu)[Num*(Len+1)] and $7F;
end;

function Menued(Num,Len:Integer;var Menu):Boolean;
begin
    Menued:=(ByteArray(Menu)[Num*(Len+1)] and $80)<>0;
end;

procedure SetMenu(Num,Len:Integer;var Menu;Item:String);
begin
    Move(Item,ByteArray(Menu)[Num*(Len+1)],Len+1);
end;

function  SelectMenuS(x,y,Row,Line,Len,Position,Maxnum:Integer;var Menu;Title1,Title2:String;Fin:Integer):Integer;
var Sel:Integer;
    Shift:Boolean;
begin
   OpenWindow(x,y,(Len+2)*Row,Line);
   CStart:=0;
   CPosition:=Position;
   MakeFrame(Title1,Title2);
   repeat
       Sel:=Select(False,Shift,Maxnum,Menu,Len);
       if Sel>=0 then begin
	   if Menued(Sel,Len,Menu) and (not Shift) then ClrMenu(Sel,Len,Menu)
	   else SelMenu(Sel,Len,Menu);
       end;
   until Shift or (Sel=Fin) or (Sel<0);
   SelectMenuS:=Sel;
   CloseWindow;
end;

procedure SelectMenuSFirst(x,y,Row,Line,Len,Position,Maxnum:Integer);
var DBufPoSave:^InputBuffer;
begin
   OpenWindow(x,y,(Len+2)*Row,Line);
   DBufPoSave:=DBufPo;
   GetMem(DBufPo,SizeOf(InputBuffer));
   CStart:=0;
   CPosition:=Position;
   with InputBuffer(DbufPo^) do begin
       Po:=DbufPoSave;
       Lin:=Line;
       Leng:=Len;
       Max:=Maxnum;
   end;
end;

function SelectMenuSNext(var Menu;Title1,Title2:String):Integer;
var Shift:Boolean;
begin
   MakeFrame(Title1,Title2);
   with InputBuffer(DBufPo^) do
     SelectMenuSNext:=Select(False,Shift,Max,Menu,Leng);
end;

function  SelectMenuSNextS(var Menu;Title1,Title2:String;Fin:Integer):Integer;
var Sel,Position1,Position2:Integer;
    Shift:Boolean;
begin
   MakeFrame(Title1,Title2);
   with InputBuffer(DBufPo^) do begin
       repeat
           Sel:=Select(False,Shift,Max,Menu,Leng);
           if Sel>=0 then begin
               if Menued(Sel,Leng,Menu) and (not Shift) then ClrMenu(Sel,Leng,Menu)
               else SelMenu(Sel,Leng,Menu);
           end;
       until Shift or (Sel=Fin) or (Sel<0);
   end;
   SelectMenuSNextS:=Sel;
end;

procedure SelectMenuSDisp(Start,Position:Integer;var Menu;Title1,Title2:String);
var Shift:Boolean;
    Sel:Integer;
begin
   MakeFrame(Title1,Title2);
   with InputBuffer(DBufPo^) do begin
     CStart:=Start;
     CPosition:=Position;
     Sel:=Select(True,Shift,Max,Menu,Leng);
   end;
end;

procedure SelectMenuSEnd;
var  DBufPoSave:Pointer;
begin
    DBufPoSave:=InputBuffer(DBufPo^).Po;
    FreeMem(DBufPo,SizeOf(InputBuffer));
    DBufPo:=DBufPoSave;
    CloseWindow;
end;

function  SelectAMenu(x,y,Row,Line,Len,Position,Maxnum:Integer;var Menu;Title1,Title2:String):Integer;
var Shift:Boolean;
begin
   OpenWindow(x,y,(Len+2)*Row,Line);
   CStart:=0;
   CPosition:=Position;
   MakeFrame(Title1,Title2);
   SelectAMenu:=Select(False,Shift,Maxnum,Menu,Len);
   CloseWindow;
end;


procedure FWild(var Path:PathStr;var Dir:DirStr;var Name:NameStr;var Ext:ExtStr;AddExt:ExtStr);
var S:TSearchRec;
    Error:Integer;
Begin
   Path:=FExpand(Path);
   if (Pos('*',Path)=0) and (Pos('?',Path)=0) then begin
       Error:=FindFirst(Path,faDirectory,S);
       if (Error=0) and ((S.Attr and faDirectory)<>0) then Path:=Path+'\';
       FindClose(S);
   end;
   FSplit(Path,Dir,Name,Ext);
   if Name='' then Name:='*';
   if Ext='' then Ext:=AddExt;
   Path:=Dir+Name+Ext;
end;

function cmp(S1,S2:Pointer):Integer;
begin
    if String(S1^)<String(S2^) then cmp:=-1
    else if String(S1^)=String(S2^) then cmp:=0
    else cmp:=1;
end;


function GenDir(LenBuf :Word; var buf; var Dir:DirStr;var Path:PathStr):Integer;
type DirBuff = array [0..$1000] of FNameStr;
var SRec:TSearchRec;
    Name:NameStr;
    Ext:ExtStr;
    i,j,d,LastDrive:Integer;
    Error:Integer;
    Drive:DWORD;
    len:Integer;
Begin
   Path:=FExpand(Path);
   FSplit(Path,Dir,Name,Ext);
   i:=0;
   Error:=FindFirst(Dir+'*.*',faDirectory,SRec);
   while (Error=0) and (i<(LenBuf div SizeOf(FNameStr))) do begin
      If (SRec.Attr and faDirectory)<>0 then begin
        len:=StrLen(PChar(@Srec.FindData.cAlternateFileName));
        if len=0 then DirBuff(Buf)[i]:=Srec.Name+'\'
        else begin
          Move(Srec.FindData.cAlternateFileName,DirBuff(Buf)[i][1],12);
          DirBuff(Buf)[i][0]:=Char(len);
          DirBuff(Buf)[i]:=DirBuff(Buf)[i]+'\';
        end;
        Inc(i);
      end;
      Error:=FindNext(SRec)
   end;
   FindClose(SRec);
   d:=i;
   QSort(@DirBuff(Buf)[0],i,SizeOf(FNameStr),cmp);
   Error:=FindFirst(Path,faReadOnly or faHidden or faSysFile or faArchive,SRec);
   while (Error=0) and (i<(LenBuf div SizeOf(FNameStr))) do begin
      len:=StrLen(PChar(@Srec.FindData.cAlternateFileName));
      if len=0 then DirBuff(Buf)[i]:=Srec.Name
      else begin
        Move(Srec.FindData.cAlternateFileName,DirBuff(Buf)[i][1],12);
        DirBuff(Buf)[i][0]:=Char(len);
        DirBuff(Buf)[i]:=DirBuff(Buf)[i];
      end;
      Inc(i);
      Error:=FindNext(SRec)
   end;
   FindClose(SRec);
   QSort(@DirBuff(Buf)[d],i-d,SizeOf(FNameStr),cmp);
   Drive:=GetLogicalDrives;
   for j:=0 to 31 do
     if (Drive and (DWORD(1) shl j) )<>0 then begin
      if i<(LenBuf div SizeOf(FNameStr)) then begin
         DirBuff(Buf)[i][0]:=Char(2);
         DirBuff(Buf)[i][1]:=Char(j+Ord('A'));
         DirBuff(Buf)[i][2]:=':';
         Inc(i);
      end;
     end;
   GenDir:=i;
end;

procedure SelectFileSFirst(x,y,Row,Line:Integer;PathS:PathStr);
var
   DBufPoSave:Pointer;
   Dir:DirStr;
   Name:NameStr;
   Ext:ExtStr;
   ModeSave:SelectModeType;
Begin
   ModeSave:=PullMode;
   SelectMode(False,False,False,True);
   OpenWindow(x,y,15*Row,Line);
   CStart:=0;
   CPosition:=0;
   DBufPoSave:=DBufPo;
   GetMem(DBufPo,SizeOf(DirectoryBuffer));
   with DirectoryBuffer(DBufPo^) do begin
	Po:=DBufPoSave;
	Path:=PathS;
	FWild(Path,Dir,Name,Ext,'.*');
	FileNum:=GenDir(BufferSize*SizeOf(FNameStr),Buf,Dir,Path);
   end;
   PullMode:=ModeSave;
end;

function SelectFileSNext(var PathS:PathStr;Title:String;var Shift:Boolean):PathStr;
var  SelFil:Integer;
     Dir:DirStr;
     Name:NameStr;
     Ext:ExtStr;
Begin
   with DirectoryBuffer(DBufPo^) do begin
	SelFil:=-2;
	repeat
	   FWild(Path,Dir,Name,Ext,'.*');
	   MakeFrame(Path,Title);
	   SelFil:=Select(False,Shift,FileNum,Buf,13);
	   if SelFil<>-1 then
	     if (Pos('\',Buf[SelFil])<>0) or (Pos(':',Buf[SelFil])<>0) then begin
		   if Pos('\',Buf[SelFil])<>0 then Path:=Dir+Buf[SelFil]+Name+Ext
		   else Path:=Buf[SelFil]+Name+Ext;
		   CPosition:=0;
		   CStart:=0;
		   FileNum:=GenDir(BufferSize*SizeOf(FNameStr),Buf,Dir,Path);
		   SelFil:=-2;
	     end;
	until (SelFil<>-2);
	if (SelFil<>-1) then SelectFileSNext:=Dir+Buf[SelFil]
			else SelectFileSNext:='';
	PathS:=Path;
   end;
end;

procedure SelectFileSEnd;
var  DBufPoSave:Pointer;
begin
    DBufPoSave:=DirectoryBuffer(DBufPo^).Po;
    FreeMem(DBufPo,SizeOf(DirectoryBuffer));
    DBufPo:=DBufPoSave;
    CloseWindow;
end;

function SelectAFile(x,y,Row,Line:Integer;var Path:PathStr;Title:String):PathStr;
Type DirBuf= Array [0..BufferSize-1] of FNameStr;
var  SelFil,FileNum:Integer;
     Dir:DirStr;
     Buf:^DirBuf;
     Name:NameStr;
     Ext:ExtStr;
     S:TSearchRec;
     Shift:Boolean;
     ModeSave:SelectModeType;
Begin
   ModeSave:=PullMode;
   SelectMode(False,False,False,True);
   OpenWindow(x,y,15*Row,Line);
   GetMem(Buf,SizeOf(DirBuf));
   FWild(Path,Dir,Name,Ext,'.*');
   SelFil:=-2;
   repeat
      CPosition:=0;
      CStart:=0;
      FileNum:=GenDir(SizeOf(DirBuf),Buf^,Dir,Path);
      MakeFrame(Path,Title);
      SelFil:=Select(False,Shift,FileNum,Buf^,13);
      if SelFil<>-1 then begin
	if Pos('\',Buf^[SelFil])<>0 then begin
	    Path:=Dir+Buf^[SelFil]+Name+Ext;
	    SelFil:=-2;
	end else if Pos(':',Buf^[SelFil])<>0 then begin
	    Path:=Buf^[SelFil]+Name+Ext;
	    SelFil:=-2;
	end;
      end;
   until (SelFil<>-2);
   if (SelFil<>-1) then SelectAFile:=Dir+Buf^[SelFil]
		   else SelectAFile:='';
   FreeMem(Buf,SizeOf(DirBuf));
   CloseWindow;
   PullMode:=ModeSave;
end;


function  PWinX:Integer;
var Win:DgWinPo;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then PWinX:=1
  else PWinX:=Win.x+1;
end;

function  PWinY:Integer;
var Win:DgWinPo;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then PWinY:=1
  else PWinY:=Win.Y+1;
end;

function  PWinW:Integer;
var Win:DgWinPo;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then PWinW:=1
  else PWinW:=Win.Width;
end;

function  PWinH:Integer;
var Win:DgWinPo;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then PWinH:=1
  else PWinH:=Win.Height;
end;

procedure SetPullColor(Col:PullMenuColor);
begin
    PullColor:=Col;
end;

function DgInKey(Fin:CharSet):Char;
var msg:TMsg;
    Win:DgWinPo;
    dc:HDC;
    i,j:Integer;
    Wnd:HWND;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then exit;
  Win^.FinCode:=Fin;
  Win^.KeyInput:=1;
  dc:=GetDC(Win^.Wnd);
  for i:=0 to Win^.Height-1 do
    for j:=0 to Win^.Row-1 do
      DgSdisp(dc,Win,i*Win^.Row+j,0);
  DgSdisp(dc,Win,Win^.Position-Win^.Start,1);
  DgFrameDisp(dc,Win);
  ReleaseDC(Win^.Wnd,dc);
  Wnd:=GetFocus;
  SetFocus(Win^.Wnd);
  while Win^.KeyInput=1 do begin
    if (GetMessage(msg,0,0,0)) then begin
      TranslateMessage(msg);
      DispatchMessage(msg);
    end;
  end;
  SetFocus(Wnd);
  DgInKey:=Char(Win^.KeyCode);
end;

function WindowInputChar(x,y:Integer;Str,Title1,Title2:String;Fin:CharSet):Char;
var Ch,Ch2:Char;
    Key:Word;
    Start,Po,dx,dy,Sel:Integer;
    Shift,Ctrl,Grph:Boolean;
    Win:DgWinPo;
    ModeSave:SelectModeType;
Begin
   ModeSave:=PullMode;
   PullMode.Letter:=False;
   OpenWindow(x,y,Length(Str)+2,1);
   Win:=GetDgWindow;
   if (Win=NIL) then exit;
   Win^.Start:=0;
   Win^.Position:=1;
   Win^.Menu:=@Str;
   Win^.Maxnum:=1;
   Win^.Len:=Length(Str);
   CRow:=Win^.Width div (Win^.Len+2);
   Win^.Row:=CRow;
   MakeFrame(Title1,Title2);
   Ch:=DgInKey(Fin);
   WindowInputChar:=Ch;
   CloseWindow;
   PullMode:=ModeSave;
end;

procedure PullWriteXY2(dc:HDC;x,y:Integer;S:String;Col:Word);
var Len:Integer;
    rect:TRect;
begin
  SetColor(dc,Col);
  Len:=Length(S);
  rect.top:=FHeight*(y-1);
  rect.bottom:=FHeight*y;
  rect.left:=FWidth*(x-1);
  rect.right:=FWidth*(x-1+Len);
  ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,@S[1],Len,NIL);
  PullX:=x+Len;
  PullY:=y;
end;

procedure PullWrite2(dc:HDC;S:String;Col:Word);
var Len:Integer;
    rect:TRect;
    x,y:Integer;
begin
  SetColor(dc,Col);
  Len:=Length(S);
  x:=PullX;
  y:=PullY;
  rect.top:=FHeight*(y-1);
  rect.bottom:=FHeight*y;
  rect.left:=FWidth*(x-1);
  rect.right:=FWidth*(x-1+Len);
  ExtTextOut(dc,rect.left,rect.bottom,ETO_OPAQUE,@rect,@S[1],Len,NIL);
  PullX:=x+Len;
  PullY:=y;
end;

procedure PutStr2(dc:HDC;x,y,len:Integer;S:String;Attr1,Attr2:Word);
var L:Boolean;
begin
  L:=Length(S)>Len;
  if L then begin
      if IsKanji2(S,len-1) then S:=Copy(S,1,len-3)+' '
                           else S:=Copy(S,1,len-2);
  end;
  PullWriteXY2(dc,x,y,S,Attr1);
  if L then PullWrite2(dc,'..',Attr2);
end;

procedure MakeFrameXY2(dc:HDC;X,Y,W,H:Integer;FrameCol,TitleCol,TitleCol2,Shadow:Word;Title1,Title2:String);
var i,Len:Integer;
    rect:TRECT;
    brush2,sbrush:HBRUSH;
    pen1,spen:HPEN;
begin
  Len:=Length(Title1);
  if Len>W then begin
    if IsKanji2(Title1,Len-W+4) then Title1[Len-W+4]:=' ';
    Title1:=Copy('...'+Copy(Title1,Len-W+4,W-3),1,W);
  end;
  Len:=Length(Title2);
  if Len>W then begin
    if IsKanji2(Title2,Len-W+4) then Title2[Len-W+4]:=' ';
    Title2:=Copy('...'+Copy(Title2,Len-W+4,W-3),1,W);
  end;
  Dec(X);
  Dec(Y,1);
  SetColor(dc,FrameCol);
  brush2:=CreateSolidBrush(GetBkColor(dc));
  pen1:=CreatePen(PS_SOLID,0,GetBkColor(dc));
  sbrush:=SelectObject(dc,brush2);
  spen:=SelectObject(dc,pen1);
  Rectangle(dc,FWidth*(x+W+1),FHeight*y,FWidth*(x+W+2)+1,FHeight*(y+H+1)+1);
  Rectangle(dc,FWidth*x-1,FHeight*y,FWidth*(x+1)+1,FHeight*(y+H+1)+1);
  Rectangle(dc,FWidth*x-1,FHeight*y-1,FWidth*(x+W+2)+1,FHeight*y+1);
  Rectangle(dc,FWidth*x-1,FHeight*(y+H+1),FWidth*(x+W+2)+1,FHeight*(y+H+1+1)+1);
  SelectObject(dc,sbrush);
  SelectObject(dc,spen);
  DeleteObject(brush2);
  DeleteObject(pen1);
  brush2:=GetStockObject(NULL_BRUSH);
  pen1:=CreatePen(PS_SOLID,0,GetTextColor(dc));
  sbrush:=SelectObject(dc,brush2);
  spen:=SelectObject(dc,pen1);
  Rectangle(dc,FWidth*x+FWidth div 2,FHeight*y+FHeight div 2,
               FWidth*x+FWidth*(W+2)-FWidth div 2,FHeight*y+FHeight*(H+1+1)-FHeight div 2);
  SelectObject(dc,sbrush);
  SelectObject(dc,spen);
  DeleteObject(brush2);
  DeleteObject(pen1);
  Inc(X);
  Inc(Y,1);
  PullWriteXY2(dc,X+(W-Length(Title1)) div 2+1,Y,Title1,TitleCol);
  PullWriteXY2(dc,X+(W-Length(Title2)) div 2+1,Y+H+1,Title2,TitleCol2);
end;

procedure ClearFrameXY2(dc:HDC;X,Y,W,H,BackCol:Integer);
var i,j:Integer;
    brush:HBRUSH;
    rect:TRect;
begin
  SetColor(dc,BackCol);
  brush:=CreateSolidBrush(GetBkColor(dc));
  Dec(X);
  Dec(Y,1);
  rect.left:=FWidth*x;
  rect.right:=FWidth*(x+W)+1;
  rect.top:=FHeight*y;
  rect.bottom:=FHeight*(y+H);
  FillRect(dc,rect,brush);
  DeleteObject(brush);
end;

procedure PullWriteXYW(x,y:Integer;S:String;Col:Word);
var dc:HDC;
    Win:DGWinPo;
    orgfont:HFont;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then exit;
  dc:=GetDC(Win^.Wnd);
  SetTextAlign(dc,TA_BOTTOM or TA_LEFT);
  SetTextCharacterExtra(dc,WinEnv.TExtra);
  orgfont:=SelectObject(dc,Win^.Font);
  PullWriteXY2(dc,x,y,S,Col);
  SelectObject(dc,orgfont);
  ReleaseDC(Win^.Wnd,dc);
end;

procedure PullWrite(S:String;Col:Word);
var dc:HDC;
    Win:DGWinPo;
    orgfont:HFont;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then exit;
  dc:=GetDC(Win^.Wnd);
  orgfont:=SelectObject(dc,Win^.Font);
  PullWrite2(dc,S,Col);
  SelectObject(dc,orgfont);
  ReleaseDC(Win^.Wnd,dc);
end;

procedure PutStr(x,y,len:Integer;S:String;Attr1,Attr2:Word);
var dc:HDC;
    Win:DGWinPo;
    orgfont:HFont;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then exit;
  dc:=GetDC(Win^.Wnd);
  orgfont:=SelectObject(dc,Win^.Font);
  PutStr2(dc,x,y,len,S,Attr1,Attr2);
  SelectObject(dc,orgfont);
  ReleaseDC(Win^.Wnd,dc);
end;

procedure MakeFrameXY(X,Y,W,H:Integer;FrameCol,TitleCol,TitleCol2,Shadow:Word;Title1,Title2:String);
var dc:HDC;
    Win:DGWinPo;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then exit;
  dc:=GetDC(Win^.Wnd);
  MakeFrameXY2(dc,X,Y,W,H,FrameCol,TitleCol,TitleCol2,Shadow,Title1,Title2);
  ReleaseDC(Win^.Wnd,dc);
end;

procedure ClearFrameXY(X,Y,W,H,BackCol:Integer);
var dc:HDC;
    Win:DGWinPo;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then exit;
  dc:=GetDC(Win^.Wnd);
  ClearFrameXY2(dc,X,Y,W,H,BackCol);
  ReleaseDC(Win^.Wnd,dc);
end;


procedure ClearFrame;
var Win:DGWinPo;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then exit;
  ClearFrameXY(Win^.X,Win^.Y,Win^.Width,Win^.Height,Win^.Color.Back);
end;

procedure PullReadKey(var Key:Word;var Shift,Ctrl,Grph:Boolean);
var msg:TMsg;
    Win:DgWinPo;
    dc:HDC;
    Wnd:HWND;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then exit;
  Wnd:=GetFocus;
  Win^.KeyInput:=2;
  Key:=0;
  while (Key=0) do begin
  SetFocus(Win^.Wnd);
  if (GetMessage(msg,0,0,0)) then begin
    if (msg.hwnd=Win^.Wnd) and (msg.Message=WM_KEYDOWN) then begin
      Key:=msg.WParam;
      Win^.KeyCode:=Key;
      if (GetAsyncKeyState(VK_SHIFT) and $8000)<>0 then Shift:=True
      else Shift:=False;
      if (GetAsyncKeyState(VK_CONTROL) and $8000)<>0 then Ctrl:=True
      else Ctrl:=False;
      if (GetAsyncKeyState(VK_TAB) and $8000)<>0 then Grph:=True
      else Grph:=False;
    end;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
  end;
  SetFocus(Wnd);
end;

procedure CheckEscape(var Key:Word);
var msg:TMsg;
begin
  Key:=0;
  if (PeekMessage(msg,0,0,0,PM_REMOVE)) then begin
    if (msg.Message=WM_KEYDOWN) then begin
      Key:=msg.WParam;
    end;
    TranslateMessage(msg);
    DispatchMessage(msg);
  end;
end;

(*
procedure ChgPullKey(Key:Word;var Ch,Ch2:Char);
begin
    With PullKey do begin
      Ch2:=Chr(Key shr 8);
      Ch:=Chr(Key);
      if Ord(Ch)=0 then
        case Ord(Ch2) of
           $3A: Ch:=UP;
           $3D: Ch:=DOWN;
           $3B: Ch:=LEFT;
           $3C: Ch:=RIGHT;
           $36: Ch:=ROLLUP;
           $37: Ch:=ROLLDOWN;
           $3E: Ch:=HOME;
           $AE: Ch:=HOMES;
           $39: Ch:=DEL;
           $81: begin
                  MouseCursorOff;
                  PullQuit;
                end;
        end;
      if Ch=Chr($08) then Ch:=BS;
      if Ch=Chr($0D) then Ch:=CR;
      if Ch=Chr($1B) then Ch:=ESC;
    end;
end;
*)

function DgInKey2:Integer;
var msg:TMsg;
    Win:DgWinPo;
    dc:HDC;
    Wnd:HWND;
begin
  Win:=GetDgWindow;
  if (Win=NIL) then exit;
  dc:=GetDC(Win^.Wnd);
  DgWdisp(dc,Win);
  DgFrameDisp(dc,Win);
  ReleaseDC(Win^.Wnd,dc);
  Win^.KeyInput:=0;
  Wnd:=GetFocus;
  SetFocus(Win^.Wnd);
  while Win^.KeyInput=0 do begin
    if (GetMessage(msg,0,0,0)) then begin
      TranslateMessage(msg);
      DispatchMessage(msg);
    end;
  end;
  SetFocus(Wnd);
  DgInKey2:=Win^.KeyCode;
end;

function GetDgWindow:DgWinPo;
var Win:DgWinPo;
begin
   if DgWinRoot=NIL then begin
     GetDgWindow:=NIL;
     exit;
   end;
   Win:=DgWinRoot;
   while Win.Next<>NIL do Win:=Win^.Next;
   GetDgWindow:=Win;
end;

function WindowInput(x,y,Len:Integer;var Str:String;Title1,Title2:String):Boolean;
var Ch:Integer;
    S:String;
    Win:DgWinPo;
begin
   OpenWindow(x,y,Len+2,1);
   Win:=GetDgWindow;
   if (Win=NIL) then begin
     WindowInput:=False;
     exit;
   end;
   Win^.Edit:=True;
   MakeFrame(Title1,Title2);
   FillChar(S,SizeOf(S),' ');
   S:=Str;
   S[0]:=Chr(255);
   Win^.Ln:=Length(Str);
   Win^.Position:=Win^.Ln+1;
   Win^.Len:=Len;
   if Win^.Position>Win^.Len then Win^.Start:=Win^.Position-Win^.Len+1
   else Win^.Start:=1;
   Win^.NewInput:=False;
   Win^.KanjiByte:=0;
   Win^.KanjiInput:=False;
   Win^.Menu:=@S;
   Ch:=DgInKey2;
   While (S[Win^.Ln]=' ') and (Win^.Ln>0) do Dec(Win^.Ln);
   if Ch=VK_RETURN then begin
     Str:=Copy(S,1,Win^.Ln);
     WindowInput:=True;
  end else WindowInput:=False;
  CloseWindow;
end;

procedure SetMenuString(Row,Line,Len,Position,Maxnum:Integer;var Menu);
var Win:DgWinPo;
begin
  Win:=GetDgWindow;
  if (Win<>NIL) then begin
    Win^.Menu:=@Menu;
    Win^.Row:=Row;
    Win^.Line:=Line;
    Win^.Len:=Len;
    Win^.Position:=Position;
    Win^.MaxNum:=MaxNum;
  end;
end;

procedure PullQuitNull;
begin
end;

begin
  PullQuit:=PullQuitNull;
end.

end.
